namespace llvm {}
using namespace llvm;
struct X86StringToOpcodeEntry
{
    const char* Name;
    unsigned short Opcode;
};
static const X86StringToOpcodeEntry gX86StringToOpcodeTable[] = {
  /*{ "aaa", X86::AAA },
  { "aad", X86::AAD8i8 },
  { "aad", X86::AAD8i8 },
  { "aam", X86::AAM8i8 },
  { "aam", X86::AAM8i8 },
  { "aas", X86::AAS },
  { "adc", X86::ADC8i8 },
  { "adc", X86::ADC8rr },
  { "adc", X86::ADC8ri },
  { "adc", X86::ADC8rm },
  { "adc", X86::ADC16i16 },
  { "adc", X86::ADC16rr },
  { "adc", X86::ADC16ri8 },
  { "adc", X86::ADC16ri },
  { "adc", X86::ADC16rm },
  { "adc", X86::ADC32i32 },
  { "adc", X86::ADC32rr },
  { "adc", X86::ADC32ri8 },
  { "adc", X86::ADC32ri },
  { "adc", X86::ADC32rm },
  { "adc", X86::ADC64i32 },
  { "adc", X86::ADC64rr },
  { "adc", X86::ADC64ri8 },
  { "adc", X86::ADC64ri32 },
  { "adc", X86::ADC64rm },
  { "adc", X86::ADC16mr },
  { "adc", X86::ADC16mi8 },
  { "adc", X86::ADC16mi },
  { "adc", X86::ADC32mr },
  { "adc", X86::ADC32mi8 },
  { "adc", X86::ADC32mi },
  { "adc", X86::ADC64mr },
  { "adc", X86::ADC64mi8 },
  { "adc", X86::ADC64mi32 },
  { "adc", X86::ADC8mr },
  { "adc", X86::ADC8mi },
  { "adcx", X86::ADCX32rr },
  { "adcx", X86::ADCX32rm },
  { "adcx", X86::ADCX64rr },
  { "adcx", X86::ADCX64rm },
  { "add", X86::ADD8i8 },
  { "add", X86::ADD8rr },
  { "add", X86::ADD8ri },
  { "add", X86::ADD8rm },
  { "add", X86::ADD16i16 },
  { "add", X86::ADD16rr },
  { "add", X86::ADD16ri8 },
  { "add", X86::ADD16ri },
  { "add", X86::ADD16rm },
  { "add", X86::ADD32i32 },
  { "add", X86::ADD32rr },
  { "add", X86::ADD32ri8 },
  { "add", X86::ADD32ri },
  { "add", X86::ADD32rm },
  { "add", X86::ADD64i32 },
  { "add", X86::ADD64rr },
  { "add", X86::ADD64ri8 },
  { "add", X86::ADD64ri32 },
  { "add", X86::ADD64rm },
  { "add", X86::ADD16mr },
  { "add", X86::ADD16mi8 },
  { "add", X86::ADD16mi },
  { "add", X86::ADD32mr },
  { "add", X86::ADD32mi8 },
  { "add", X86::ADD32mi },
  { "add", X86::ADD64mr },
  { "add", X86::ADD64mi8 },
  { "add", X86::ADD64mi32 },
  { "add", X86::ADD8mr },
  { "add", X86::ADD8mi },
  { "addpd", X86::ADDPDrr },
  { "addpd", X86::ADDPDrm },
  { "addps", X86::ADDPSrr },
  { "addps", X86::ADDPSrm },
  { "addsd", X86::ADDSDrr },
  { "addsd", X86::ADDSDrm },
  { "addss", X86::ADDSSrr },
  { "addss", X86::ADDSSrm },
  { "addsubpd", X86::ADDSUBPDrr },
  { "addsubpd", X86::ADDSUBPDrm },
  { "addsubps", X86::ADDSUBPSrr },
  { "addsubps", X86::ADDSUBPSrm },
  { "adox", X86::ADOX32rr },
  { "adox", X86::ADOX32rm },
  { "adox", X86::ADOX64rr },
  { "adox", X86::ADOX64rm },
  { "aesdec", X86::AESDECrr },
  { "aesdec", X86::AESDECrm },
  { "aesdeclast", X86::AESDECLASTrr },
  { "aesdeclast", X86::AESDECLASTrm },
  { "aesenc", X86::AESENCrr },
  { "aesenc", X86::AESENCrm },
  { "aesenclast", X86::AESENCLASTrr },
  { "aesenclast", X86::AESENCLASTrm },
  { "aesimc", X86::AESIMCrr },
  { "aesimc", X86::AESIMCrm },
  { "aeskeygenassist", X86::AESKEYGENASSIST128rr },
  { "aeskeygenassist", X86::AESKEYGENASSIST128rm },
  { "and", X86::AND8i8 },
  { "and", X86::AND8rr },
  { "and", X86::AND8ri },
  { "and", X86::AND8rm },
  { "and", X86::AND16i16 },
  { "and", X86::AND16rr },
  { "and", X86::AND16ri8 },
  { "and", X86::AND16ri },
  { "and", X86::AND16rm },
  { "and", X86::AND32i32 },
  { "and", X86::AND32rr },
  { "and", X86::AND32ri8 },
  { "and", X86::AND32ri },
  { "and", X86::AND32rm },
  { "and", X86::AND64i32 },
  { "and", X86::AND64rr },
  { "and", X86::AND64ri8 },
  { "and", X86::AND64ri32 },
  { "and", X86::AND64rm },
  { "and", X86::AND16mr },
  { "and", X86::AND16mi8 },
  { "and", X86::AND16mi },
  { "and", X86::AND32mr },
  { "and", X86::AND32mi8 },
  { "and", X86::AND32mi },
  { "and", X86::AND64mr },
  { "and", X86::AND64mi8 },
  { "and", X86::AND64mi32 },
  { "and", X86::AND8mr },
  { "and", X86::AND8mi },
  { "andn", X86::ANDN32rr },
  { "andn", X86::ANDN32rm },
  { "andn", X86::ANDN64rr },
  { "andn", X86::ANDN64rm },
  { "andnpd", X86::ANDNPDrr },
  { "andnpd", X86::ANDNPDrm },
  { "andnps", X86::ANDNPSrr },
  { "andnps", X86::ANDNPSrm },
  { "andpd", X86::ANDPDrr },
  { "andpd", X86::ANDPDrm },
  { "andps", X86::ANDPSrr },
  { "andps", X86::ANDPSrm },
  { "arpl", X86::ARPL16rr },
  { "arpl", X86::ARPL16mr },
  { "bextr", X86::BEXTR32rr },
  { "bextr", X86::BEXTRI32ri },
  { "bextr", X86::BEXTR32rm },
  { "bextr", X86::BEXTRI32mi },
  { "bextr", X86::BEXTR64rr },
  { "bextr", X86::BEXTRI64ri },
  { "bextr", X86::BEXTR64rm },
  { "bextr", X86::BEXTRI64mi },
  { "blcfill", X86::BLCFILL32rr },
  { "blcfill", X86::BLCFILL32rm },
  { "blcfill", X86::BLCFILL64rr },
  { "blcfill", X86::BLCFILL64rm },
  { "blci", X86::BLCI32rr },
  { "blci", X86::BLCI32rm },
  { "blci", X86::BLCI64rr },
  { "blci", X86::BLCI64rm },
  { "blcic", X86::BLCIC32rr },
  { "blcic", X86::BLCIC32rm },
  { "blcic", X86::BLCIC64rr },
  { "blcic", X86::BLCIC64rm },
  { "blcmsk", X86::BLCMSK32rr },
  { "blcmsk", X86::BLCMSK32rm },
  { "blcmsk", X86::BLCMSK64rr },
  { "blcmsk", X86::BLCMSK64rm },
  { "blcs", X86::BLCS32rr },
  { "blcs", X86::BLCS32rm },
  { "blcs", X86::BLCS64rr },
  { "blcs", X86::BLCS64rm },
  { "blendpd", X86::BLENDPDrri },
  { "blendpd", X86::BLENDPDrmi },
  { "blendps", X86::BLENDPSrri },
  { "blendps", X86::BLENDPSrmi },
  { "blendvpd", X86::BLENDVPDrr0 },
  { "blendvpd", X86::BLENDVPDrm0 },
  { "blendvpd", X86::BLENDVPDrr0 },
  { "blendvpd", X86::BLENDVPDrm0 },
  { "blendvps", X86::BLENDVPSrr0 },
  { "blendvps", X86::BLENDVPSrm0 },
  { "blendvps", X86::BLENDVPSrr0 },
  { "blendvps", X86::BLENDVPSrm0 },
  { "blsfill", X86::BLSFILL32rr },
  { "blsfill", X86::BLSFILL32rm },
  { "blsfill", X86::BLSFILL64rr },
  { "blsfill", X86::BLSFILL64rm },
  { "blsi", X86::BLSI32rr },
  { "blsi", X86::BLSI32rm },
  { "blsi", X86::BLSI64rr },
  { "blsi", X86::BLSI64rm },
  { "blsic", X86::BLSIC32rr },
  { "blsic", X86::BLSIC32rm },
  { "blsic", X86::BLSIC64rr },
  { "blsic", X86::BLSIC64rm },
  { "blsmsk", X86::BLSMSK32rr },
  { "blsmsk", X86::BLSMSK32rm },
  { "blsmsk", X86::BLSMSK64rr },
  { "blsmsk", X86::BLSMSK64rm },
  { "blsr", X86::BLSR32rr },
  { "blsr", X86::BLSR32rm },
  { "blsr", X86::BLSR64rr },
  { "blsr", X86::BLSR64rm },
  { "bound", X86::BOUNDS16rm },
  { "bound", X86::BOUNDS32rm },
  { "bsf", X86::BSF16rr },
  { "bsf", X86::BSF16rm },
  { "bsf", X86::BSF32rr },
  { "bsf", X86::BSF32rm },
  { "bsf", X86::BSF64rr },
  { "bsf", X86::BSF64rm },
  { "bsr", X86::BSR16rr },
  { "bsr", X86::BSR16rm },
  { "bsr", X86::BSR32rr },
  { "bsr", X86::BSR32rm },
  { "bsr", X86::BSR64rr },
  { "bsr", X86::BSR64rm },
  { "bswap", X86::BSWAP32r },
  { "bswap", X86::BSWAP64r },
  { "bt", X86::BT16rr },
  { "bt", X86::BT16ri8 },
  { "bt", X86::BT32rr },
  { "bt", X86::BT32ri8 },
  { "bt", X86::BT64rr },
  { "bt", X86::BT64ri8 },
  { "bt", X86::BT16mr },
  { "bt", X86::BT16mi8 },
  { "bt", X86::BT32mr },
  { "bt", X86::BT32mi8 },
  { "bt", X86::BT32mi8 },
  { "bt", X86::BT64mr },
  { "bt", X86::BT64mi8 },
  { "btc", X86::BTC16rr },
  { "btc", X86::BTC16ri8 },
  { "btc", X86::BTC32rr },
  { "btc", X86::BTC32ri8 },
  { "btc", X86::BTC64rr },
  { "btc", X86::BTC64ri8 },
  { "btc", X86::BTC16mr },
  { "btc", X86::BTC16mi8 },
  { "btc", X86::BTC32mr },
  { "btc", X86::BTC32mi8 },
  { "btc", X86::BTC32mi8 },
  { "btc", X86::BTC64mr },
  { "btc", X86::BTC64mi8 },
  { "btr", X86::BTR16rr },
  { "btr", X86::BTR16ri8 },
  { "btr", X86::BTR32rr },
  { "btr", X86::BTR32ri8 },
  { "btr", X86::BTR64rr },
  { "btr", X86::BTR64ri8 },
  { "btr", X86::BTR16mr },
  { "btr", X86::BTR16mi8 },
  { "btr", X86::BTR32mr },
  { "btr", X86::BTR32mi8 },
  { "btr", X86::BTR32mi8 },
  { "btr", X86::BTR64mr },
  { "btr", X86::BTR64mi8 },
  { "bts", X86::BTS16rr },
  { "bts", X86::BTS16ri8 },
  { "bts", X86::BTS32rr },
  { "bts", X86::BTS32ri8 },
  { "bts", X86::BTS64rr },
  { "bts", X86::BTS64ri8 },
  { "bts", X86::BTS16mr },
  { "bts", X86::BTS16mi8 },
  { "bts", X86::BTS32mr },
  { "bts", X86::BTS32mi8 },
  { "bts", X86::BTS32mi8 },
  { "bts", X86::BTS64mr },
  { "bts", X86::BTS64mi8 },
  { "bzhi", X86::BZHI32rr },
  { "bzhi", X86::BZHI32rm },
  { "bzhi", X86::BZHI64rr },
  { "bzhi", X86::BZHI64rm },
  { "call", X86::CALL16r },
  { "call", X86::CALL32r },
  { "call", X86::CALL64r },
  { "call", X86::CALL64pcrel32 },
  { "call", X86::CALLpcrel32 },
  { "call", X86::CALLpcrel16 },
  { "call", X86::CALL16m },
  { "call", X86::CALL32m },
  { "call", X86::CALL64m },
  { "call", X86::CALL64m },
  { "call", X86::CALL32m },
  { "call", X86::CALL16m },
  { "call", X86::FARCALL16i },
  { "call", X86::FARCALL32i },
  { "calll", X86::FARCALL32i },
  { "callw", X86::FARCALL16i },
  { "cbw", X86::CBW },
  { "cdq", X86::CDQ },
  { "cdqe", X86::CDQE },
  { "clac", X86::CLAC },
  { "clc", X86::CLC },
  { "cld", X86::CLD },
  { "clflush", X86::CLFLUSH },
  { "clgi", X86::CLGI },
  { "cli", X86::CLI },
  { "clrb", X86::XOR8rr },
  { "clrl", X86::XOR32rr },
  { "clrq", X86::XOR64rr },
  { "clrw", X86::XOR16rr },
  { "clts", X86::CLTS },
  { "cmc", X86::CMC },
  { "cmova", X86::CMOVA16rr },
  { "cmova", X86::CMOVA16rm },
  { "cmova", X86::CMOVA32rr },
  { "cmova", X86::CMOVA32rm },
  { "cmova", X86::CMOVA64rr },
  { "cmova", X86::CMOVA64rm },
  { "cmovae", X86::CMOVAE16rr },
  { "cmovae", X86::CMOVAE16rm },
  { "cmovae", X86::CMOVAE32rr },
  { "cmovae", X86::CMOVAE32rm },
  { "cmovae", X86::CMOVAE64rr },
  { "cmovae", X86::CMOVAE64rm },
  { "cmovb", X86::CMOVB16rr },
  { "cmovb", X86::CMOVB16rm },
  { "cmovb", X86::CMOVB32rr },
  { "cmovb", X86::CMOVB32rm },
  { "cmovb", X86::CMOVB64rr },
  { "cmovb", X86::CMOVB64rm },
  { "cmovbe", X86::CMOVBE16rr },
  { "cmovbe", X86::CMOVBE16rm },
  { "cmovbe", X86::CMOVBE32rr },
  { "cmovbe", X86::CMOVBE32rm },
  { "cmovbe", X86::CMOVBE64rr },
  { "cmovbe", X86::CMOVBE64rm },
  { "cmove", X86::CMOVE16rr },
  { "cmove", X86::CMOVE16rm },
  { "cmove", X86::CMOVE32rr },
  { "cmove", X86::CMOVE32rm },
  { "cmove", X86::CMOVE64rr },
  { "cmove", X86::CMOVE64rm },
  { "cmovg", X86::CMOVG16rr },
  { "cmovg", X86::CMOVG16rm },
  { "cmovg", X86::CMOVG32rr },
  { "cmovg", X86::CMOVG32rm },
  { "cmovg", X86::CMOVG64rr },
  { "cmovg", X86::CMOVG64rm },
  { "cmovge", X86::CMOVGE16rr },
  { "cmovge", X86::CMOVGE16rm },
  { "cmovge", X86::CMOVGE32rr },
  { "cmovge", X86::CMOVGE32rm },
  { "cmovge", X86::CMOVGE64rr },
  { "cmovge", X86::CMOVGE64rm },
  { "cmovl", X86::CMOVL16rr },
  { "cmovl", X86::CMOVL16rm },
  { "cmovl", X86::CMOVL32rr },
  { "cmovl", X86::CMOVL32rm },
  { "cmovl", X86::CMOVL64rr },
  { "cmovl", X86::CMOVL64rm },
  { "cmovle", X86::CMOVLE16rr },
  { "cmovle", X86::CMOVLE16rm },
  { "cmovle", X86::CMOVLE32rr },
  { "cmovle", X86::CMOVLE32rm },
  { "cmovle", X86::CMOVLE64rr },
  { "cmovle", X86::CMOVLE64rm },
  { "cmovne", X86::CMOVNE16rr },
  { "cmovne", X86::CMOVNE16rm },
  { "cmovne", X86::CMOVNE32rr },
  { "cmovne", X86::CMOVNE32rm },
  { "cmovne", X86::CMOVNE64rr },
  { "cmovne", X86::CMOVNE64rm },
  { "cmovno", X86::CMOVNO16rr },
  { "cmovno", X86::CMOVNO16rm },
  { "cmovno", X86::CMOVNO32rr },
  { "cmovno", X86::CMOVNO32rm },
  { "cmovno", X86::CMOVNO64rr },
  { "cmovno", X86::CMOVNO64rm },
  { "cmovnp", X86::CMOVNP16rr },
  { "cmovnp", X86::CMOVNP16rm },
  { "cmovnp", X86::CMOVNP32rr },
  { "cmovnp", X86::CMOVNP32rm },
  { "cmovnp", X86::CMOVNP64rr },
  { "cmovnp", X86::CMOVNP64rm },
  { "cmovns", X86::CMOVNS16rr },
  { "cmovns", X86::CMOVNS16rm },
  { "cmovns", X86::CMOVNS32rr },
  { "cmovns", X86::CMOVNS32rm },
  { "cmovns", X86::CMOVNS64rr },
  { "cmovns", X86::CMOVNS64rm },
  { "cmovo", X86::CMOVO16rr },
  { "cmovo", X86::CMOVO16rm },
  { "cmovo", X86::CMOVO32rr },
  { "cmovo", X86::CMOVO32rm },
  { "cmovo", X86::CMOVO64rr },
  { "cmovo", X86::CMOVO64rm },
  { "cmovp", X86::CMOVP16rr },
  { "cmovp", X86::CMOVP16rm },
  { "cmovp", X86::CMOVP32rr },
  { "cmovp", X86::CMOVP32rm },
  { "cmovp", X86::CMOVP64rr },
  { "cmovp", X86::CMOVP64rm },
  { "cmovs", X86::CMOVS16rr },
  { "cmovs", X86::CMOVS16rm },
  { "cmovs", X86::CMOVS32rr },
  { "cmovs", X86::CMOVS32rm },
  { "cmovs", X86::CMOVS64rr },
  { "cmovs", X86::CMOVS64rm },
  { "cmp", X86::CMP8i8 },
  { "cmp", X86::CMP8rr },
  { "cmp", X86::CMP8ri },
  { "cmp", X86::CMP8rm },
  { "cmp", X86::CMP16i16 },
  { "cmp", X86::CMP16rr },
  { "cmp", X86::CMP16ri8 },
  { "cmp", X86::CMP16ri },
  { "cmp", X86::CMP16rm },
  { "cmp", X86::CMP32i32 },
  { "cmp", X86::CMP32rr },
  { "cmp", X86::CMP32ri8 },
  { "cmp", X86::CMP32ri },
  { "cmp", X86::CMP32rm },
  { "cmp", X86::CMP64i32 },
  { "cmp", X86::CMP64rr },
  { "cmp", X86::CMP64ri8 },
  { "cmp", X86::CMP64ri32 },
  { "cmp", X86::CMP64rm },
  { "cmp", X86::CMP16mr },
  { "cmp", X86::CMP16mi8 },
  { "cmp", X86::CMP16mi },
  { "cmp", X86::CMP32mr },
  { "cmp", X86::CMP32mi8 },
  { "cmp", X86::CMP32mi },
  { "cmp", X86::CMP64mr },
  { "cmp", X86::CMP64mi8 },
  { "cmp", X86::CMP64mi32 },
  { "cmp", X86::CMP8mr },
  { "cmp", X86::CMP8mi },
  { "cmp", X86::CMPPDrri },
  { "cmp", X86::CMPPDrmi },
  { "cmp", X86::CMPPSrri },
  { "cmp", X86::CMPPSrmi },
  { "cmp", X86::CMPSDrr },
  { "cmp", X86::CMPSDrm },
  { "cmp", X86::CMPSSrr },
  { "cmp", X86::CMPSSrm },
  { "cmppd", X86::CMPPDrri_alt },
  { "cmppd", X86::CMPPDrmi_alt },
  { "cmpps", X86::CMPPSrri_alt },
  { "cmpps", X86::CMPPSrmi_alt },
  { "cmpsb", X86::CMPSB },
  { "cmpsd", X86::CMPSL },
  { "cmpsd", X86::CMPSDrr_alt },
  { "cmpsd", X86::CMPSDrm_alt },
  { "cmpsq", X86::CMPSQ },
  { "cmpss", X86::CMPSSrr_alt },
  { "cmpss", X86::CMPSSrm_alt },
  { "cmpsw", X86::CMPSW },
  { "cmpxchg", X86::CMPXCHG8rr },
  { "cmpxchg", X86::CMPXCHG16rr },
  { "cmpxchg", X86::CMPXCHG32rr },
  { "cmpxchg", X86::CMPXCHG64rr },
  { "cmpxchg", X86::CMPXCHG16rm },
  { "cmpxchg", X86::CMPXCHG32rm },
  { "cmpxchg", X86::CMPXCHG64rm },
  { "cmpxchg", X86::CMPXCHG8rm },
  { "cmpxchg16b", X86::CMPXCHG16B },
  { "cmpxchg8b", X86::CMPXCHG8B },
  { "comisd", X86::COMISDrr },
  { "comisd", X86::COMISDrm },
  { "comiss", X86::COMISSrr },
  { "comiss", X86::COMISSrm },
  { "cpuid", X86::CPUID },
  { "cqo", X86::CQO },
  { "crc32", X86::CRC32r32r8 },
  { "crc32", X86::CRC32r32r16 },
  { "crc32", X86::CRC32r32r32 },
  { "crc32", X86::CRC32r32m16 },
  { "crc32", X86::CRC32r32m32 },
  { "crc32", X86::CRC32r32m8 },
  { "crc32", X86::CRC32r64r8 },
  { "crc32", X86::CRC32r64r64 },
  { "crc32", X86::CRC32r64m64 },
  { "crc32", X86::CRC32r64m8 },
  { "cs", X86::CS_PREFIX },
  { "cvtdq2pd", X86::CVTDQ2PDrr },
  { "cvtdq2pd", X86::CVTDQ2PDrm },
  { "cvtdq2ps", X86::CVTDQ2PSrr },
  { "cvtdq2ps", X86::CVTDQ2PSrm },
  { "cvtpd2dq", X86::CVTPD2DQrr },
  { "cvtpd2dq", X86::CVTPD2DQrm },
  { "cvtpd2pi", X86::MMX_CVTPD2PIirr },
  { "cvtpd2pi", X86::MMX_CVTPD2PIirm },
  { "cvtpd2ps", X86::CVTPD2PSrr },
  { "cvtpd2ps", X86::CVTPD2PSrm },
  { "cvtpi2pd", X86::MMX_CVTPI2PDirr },
  { "cvtpi2pd", X86::MMX_CVTPI2PDirm },
  { "cvtpi2ps", X86::MMX_CVTPI2PSirr },
  { "cvtpi2ps", X86::MMX_CVTPI2PSirm },
  { "cvtps2dq", X86::CVTPS2DQrr },
  { "cvtps2dq", X86::CVTPS2DQrm },
  { "cvtps2pd", X86::CVTPS2PDrr },
  { "cvtps2pd", X86::CVTPS2PDrm },
  { "cvtps2pi", X86::MMX_CVTPS2PIirr },
  { "cvtps2pi", X86::MMX_CVTPS2PIirm },
  { "cvtsd2si", X86::CVTSD2SIrr },
  { "cvtsd2si", X86::CVTSD2SIrr },
  { "cvtsd2si", X86::CVTSD2SIrm },
  { "cvtsd2si", X86::CVTSD2SIrm },
  { "cvtsd2si", X86::CVTSD2SI64rr },
  { "cvtsd2si", X86::CVTSD2SI64rr },
  { "cvtsd2si", X86::CVTSD2SI64rm },
  { "cvtsd2si", X86::CVTSD2SI64rm },
  { "cvtsd2ss", X86::CVTSD2SSrr },
  { "cvtsd2ss", X86::CVTSD2SSrm },
  { "cvtsi2sd", X86::CVTSI2SDrr },
  { "cvtsi2sd", X86::CVTSI2SD64rr },
  { "cvtsi2sd", X86::CVTSI2SDrm },
  { "cvtsi2sd", X86::CVTSI2SDrm },
  { "cvtsi2sd", X86::CVTSI2SD64rm },
  { "cvtsi2ss", X86::CVTSI2SSrr },
  { "cvtsi2ss", X86::CVTSI2SS64rr },
  { "cvtsi2ss", X86::CVTSI2SSrm },
  { "cvtsi2ss", X86::CVTSI2SSrm },
  { "cvtsi2ss", X86::CVTSI2SS64rm },
  { "cvtss2sd", X86::CVTSS2SDrr },
  { "cvtss2sd", X86::CVTSS2SDrm },
  { "cvtss2si", X86::CVTSS2SIrr },
  { "cvtss2si", X86::CVTSS2SIrr },
  { "cvtss2si", X86::CVTSS2SIrm },
  { "cvtss2si", X86::CVTSS2SIrm },
  { "cvtss2si", X86::CVTSS2SI64rr },
  { "cvtss2si", X86::CVTSS2SI64rr },
  { "cvtss2si", X86::CVTSS2SI64rm },
  { "cvtss2si", X86::CVTSS2SI64rm },
  { "cvttpd2dq", X86::CVTTPD2DQrr },
  { "cvttpd2dq", X86::CVTTPD2DQrm },
  { "cvttpd2pi", X86::MMX_CVTTPD2PIirr },
  { "cvttpd2pi", X86::MMX_CVTTPD2PIirm },
  { "cvttps2dq", X86::CVTTPS2DQrr },
  { "cvttps2dq", X86::CVTTPS2DQrm },
  { "cvttps2pi", X86::MMX_CVTTPS2PIirr },
  { "cvttps2pi", X86::MMX_CVTTPS2PIirm },
  { "cvttsd2si", X86::CVTTSD2SIrr },
  { "cvttsd2si", X86::CVTTSD2SIrr },
  { "cvttsd2si", X86::CVTTSD2SIrm },
  { "cvttsd2si", X86::CVTTSD2SIrm },
  { "cvttsd2si", X86::CVTTSD2SI64rr },
  { "cvttsd2si", X86::CVTTSD2SI64rr },
  { "cvttsd2si", X86::CVTTSD2SI64rm },
  { "cvttsd2si", X86::CVTTSD2SI64rm },
  { "cvttss2si", X86::CVTTSS2SIrr },
  { "cvttss2si", X86::CVTTSS2SIrr },
  { "cvttss2si", X86::CVTTSS2SIrm },
  { "cvttss2si", X86::CVTTSS2SIrm },
  { "cvttss2si", X86::CVTTSS2SI64rr },
  { "cvttss2si", X86::CVTTSS2SI64rr },
  { "cvttss2si", X86::CVTTSS2SI64rm },
  { "cvttss2si", X86::CVTTSS2SI64rm },
  { "cwd", X86::CWD },
  { "cwde", X86::CWDE },
  { "daa", X86::DAA },
  { "das", X86::DAS },
  { "data16", X86::DATA16_PREFIX },
  { "dec", X86::DEC8r },
  { "dec", X86::DEC16r },
  { "dec", X86::DEC64_16r },
  { "dec", X86::DEC32r },
  { "dec", X86::DEC64_32r },
  { "dec", X86::DEC64r },
  { "dec", X86::DEC16m },
  { "dec", X86::DEC64_16m },
  { "dec", X86::DEC32m },
  { "dec", X86::DEC64_32m },
  { "dec", X86::DEC64m },
  { "dec", X86::DEC8m },
  { "div", X86::DIV8r },
  { "div", X86::DIV16r },
  { "div", X86::DIV32r },
  { "div", X86::DIV64r },
  { "div", X86::DIV16m },
  { "div", X86::DIV32m },
  { "div", X86::DIV64m },
  { "div", X86::DIV8m },
  { "div", X86::DIV8r },
  { "div", X86::DIV8m },
  { "div", X86::DIV16r },
  { "div", X86::DIV16m },
  { "div", X86::DIV32r },
  { "div", X86::DIV32m },
  { "div", X86::DIV64r },
  { "div", X86::DIV64m },
  { "divpd", X86::DIVPDrr },
  { "divpd", X86::DIVPDrm },
  { "divps", X86::DIVPSrr },
  { "divps", X86::DIVPSrm },
  { "divsd", X86::DIVSDrr },
  { "divsd", X86::DIVSDrm },
  { "divss", X86::DIVSSrr },
  { "divss", X86::DIVSSrm },
  { "dppd", X86::DPPDrri },
  { "dppd", X86::DPPDrmi },
  { "dpps", X86::DPPSrri },
  { "dpps", X86::DPPSrmi },
  { "ds", X86::DS_PREFIX },
  { "emms", X86::MMX_EMMS },
  { "encls", X86::ENCLS },
  { "enclu", X86::ENCLU },
  { "enter", X86::ENTER },
  { "es", X86::ES_PREFIX },
  { "extractps", X86::EXTRACTPSrr },
  { "extractps", X86::EXTRACTPSmr },
  { "extrq", X86::EXTRQ },
  { "extrq", X86::EXTRQI },
  { "f2xm1", X86::F2XM1 },
  { "fabs", X86::ABS_F },
  { "fadd", X86::ADD_FST0r },
  { "fadd", X86::ADD_F32m },
  { "fadd", X86::ADD_F64m },
  { "fadd", X86::ADD_FST0r },
  { "fadd", X86::ADD_FST0r },
  { "fadd", X86::ADD_FrST0 },
  { "faddp", X86::ADD_FPrST0 },
  { "faddp", X86::ADD_FPrST0 },
  { "faddp", X86::ADD_FPrST0 },
  { "faddp", X86::ADD_FPrST0 },
  { "faddp", X86::ADD_FPrST0 },
  { "fbld", X86::FBLDm },
  { "fbstp", X86::FBSTPm },
  { "fchs", X86::CHS_F },
  { "fcmovb", X86::CMOVB_F },
  { "fcmovbe", X86::CMOVBE_F },
  { "fcmove", X86::CMOVE_F },
  { "fcmovnb", X86::CMOVNB_F },
  { "fcmovnbe", X86::CMOVNBE_F },
  { "fcmovne", X86::CMOVNE_F },
  { "fcmovnu", X86::CMOVNP_F },
  { "fcmovu", X86::CMOVP_F },
  { "fcom", X86::COM_FST0r },
  { "fcom", X86::COM_FST0r },
  { "fcom", X86::FCOM32m },
  { "fcom", X86::FCOM64m },
  { "fcomi", X86::COM_FIr },
  { "fcomi", X86::COM_FIr },
  { "fcomi", X86::COM_FIr },
  { "fcomi", X86::COM_FIr },
  { "fcomp", X86::COMP_FST0r },
  { "fcomp", X86::COMP_FST0r },
  { "fcomp", X86::FCOMP32m },
  { "fcomp", X86::FCOMP64m },
  { "fcompi", X86::COM_FIPr },
  { "fcompi", X86::COM_FIPr },
  { "fcompi", X86::COM_FIPr },
  { "fcompi", X86::COM_FIPr },
  { "fcompp", X86::FCOMPP },
  { "fcos", X86::COS_F },
  { "fdecstp", X86::FDECSTP },
  { "fdiv", X86::DIV_FST0r },
  { "fdiv", X86::DIV_F32m },
  { "fdiv", X86::DIV_F64m },
  { "fdiv", X86::DIV_FST0r },
  { "fdiv", X86::DIV_FST0r },
  { "fdiv", X86::DIV_FrST0 },
  { "fdivp", X86::DIV_FPrST0 },
  { "fdivp", X86::DIV_FPrST0 },
  { "fdivp", X86::DIV_FPrST0 },
  { "fdivp", X86::DIV_FPrST0 },
  { "fdivp", X86::DIV_FPrST0 },
  { "fdivr", X86::DIVR_FST0r },
  { "fdivr", X86::DIVR_F32m },
  { "fdivr", X86::DIVR_F64m },
  { "fdivr", X86::DIVR_FST0r },
  { "fdivr", X86::DIVR_FST0r },
  { "fdivr", X86::DIVR_FrST0 },
  { "fdivrp", X86::DIVR_FPrST0 },
  { "fdivrp", X86::DIVR_FPrST0 },
  { "fdivrp", X86::DIVR_FPrST0 },
  { "fdivrp", X86::DIVR_FPrST0 },
  { "fdivrp", X86::DIVR_FPrST0 },
  { "femms", X86::FEMMS },
  { "ffree", X86::FFREE },
  { "fiadd", X86::ADD_FI16m },
  { "fiadd", X86::ADD_FI32m },
  { "ficom", X86::FICOM16m },
  { "ficom", X86::FICOM32m },
  { "ficomp", X86::FICOMP16m },
  { "ficomp", X86::FICOMP32m },
  { "fidiv", X86::DIV_FI16m },
  { "fidiv", X86::DIV_FI32m },
  { "fidivr", X86::DIVR_FI16m },
  { "fidivr", X86::DIVR_FI32m },
  { "fild", X86::ILD_F16m },
  { "fild", X86::ILD_F32m },
  { "fild", X86::ILD_F64m },
  { "fimul", X86::MUL_FI16m },
  { "fimul", X86::MUL_FI32m },
  { "fincstp", X86::FINCSTP },
  { "fist", X86::IST_F16m },
  { "fist", X86::IST_F32m },
  { "fistp", X86::IST_FP16m },
  { "fistp", X86::IST_FP32m },
  { "fistp", X86::IST_FP64m },
  { "fisttp", X86::ISTT_FP16m },
  { "fisttp", X86::ISTT_FP32m },
  { "fisttp", X86::ISTT_FP64m },
  { "fisub", X86::SUB_FI16m },
  { "fisub", X86::SUB_FI32m },
  { "fisubr", X86::SUBR_FI16m },
  { "fisubr", X86::SUBR_FI32m },
  { "fld", X86::LD_Frr },
  { "fld", X86::LD_F32m },
  { "fld", X86::LD_F64m },
  { "fld", X86::LD_F80m },
  { "fld1", X86::LD_F1 },
  { "fldcw", X86::FLDCW16m },
  { "fldenv", X86::FLDENVm },
  { "fldl2e", X86::FLDL2E },
  { "fldl2t", X86::FLDL2T },
  { "fldlg2", X86::FLDLG2 },
  { "fldln2", X86::FLDLN2 },
  { "fldpi", X86::FLDPI },
  { "fldz", X86::LD_F0 },
  { "fmul", X86::MUL_FST0r },
  { "fmul", X86::MUL_F32m },
  { "fmul", X86::MUL_F64m },
  { "fmul", X86::MUL_FST0r },
  { "fmul", X86::MUL_FST0r },
  { "fmul", X86::MUL_FrST0 },
  { "fmulp", X86::MUL_FPrST0 },
  { "fmulp", X86::MUL_FPrST0 },
  { "fmulp", X86::MUL_FPrST0 },
  { "fmulp", X86::MUL_FPrST0 },
  { "fmulp", X86::MUL_FPrST0 },
  { "fnclex", X86::FNCLEX },
  { "fninit", X86::FNINIT },
  { "fnop", X86::FNOP },
  { "fnsave", X86::FSAVEm },
  { "fnstcw", X86::FNSTCW16m },
  { "fnstenv", X86::FSTENVm },
  { "fnstsw", X86::FNSTSW16r },
  { "fnstsw", X86::FNSTSW16r },
  { "fnstsw", X86::FNSTSW16r },
  { "fnstsw", X86::FNSTSW16r },
  { "fnstsw", X86::FNSTSWm },
  { "fpatan", X86::FPATAN },
  { "fprem", X86::FPREM },
  { "fprem1", X86::FPREM1 },
  { "fptan", X86::FPTAN },
  { "frndint", X86::FRNDINT },
  { "frstor", X86::FRSTORm },
  { "fs", X86::FS_PREFIX },
  { "fscale", X86::FSCALE },
  { "fsin", X86::SIN_F },
  { "fsincos", X86::FSINCOS },
  { "fsqrt", X86::SQRT_F },
  { "fst", X86::ST_Frr },
  { "fst", X86::ST_F32m },
  { "fst", X86::ST_F64m },
  { "fstp", X86::ST_FPrr },
  { "fstp", X86::ST_FP32m },
  { "fstp", X86::ST_FP64m },
  { "fstp", X86::ST_FP80m },
  { "fsub", X86::SUB_FST0r },
  { "fsub", X86::SUB_F32m },
  { "fsub", X86::SUB_F64m },
  { "fsub", X86::SUB_FST0r },
  { "fsub", X86::SUB_FST0r },
  { "fsub", X86::SUB_FrST0 },
  { "fsubp", X86::SUB_FPrST0 },
  { "fsubp", X86::SUB_FPrST0 },
  { "fsubp", X86::SUB_FPrST0 },
  { "fsubp", X86::SUB_FPrST0 },
  { "fsubp", X86::SUB_FPrST0 },
  { "fsubr", X86::SUBR_FST0r },
  { "fsubr", X86::SUBR_F32m },
  { "fsubr", X86::SUBR_F64m },
  { "fsubr", X86::SUBR_FST0r },
  { "fsubr", X86::SUBR_FST0r },
  { "fsubr", X86::SUBR_FrST0 },
  { "fsubrp", X86::SUBR_FPrST0 },
  { "fsubrp", X86::SUBR_FPrST0 },
  { "fsubrp", X86::SUBR_FPrST0 },
  { "fsubrp", X86::SUBR_FPrST0 },
  { "fsubrp", X86::SUBR_FPrST0 },
  { "ftst", X86::TST_F },
  { "fucom", X86::UCOM_Fr },
  { "fucom", X86::UCOM_Fr },
  { "fucomi", X86::UCOM_FIr },
  { "fucomi", X86::UCOM_FIr },
  { "fucomi", X86::UCOM_FIr },
  { "fucomi", X86::UCOM_FIr },
  { "fucomp", X86::UCOM_FPr },
  { "fucomp", X86::UCOM_FPr },
  { "fucompi", X86::UCOM_FIPr },
  { "fucompi", X86::UCOM_FIPr },
  { "fucompi", X86::UCOM_FIPr },
  { "fucompi", X86::UCOM_FIPr },
  { "fucompp", X86::UCOM_FPPr },
  { "fxam", X86::FXAM },
  { "fxch", X86::XCH_F },
  { "fxch", X86::XCH_F },
  { "fxrstor", X86::FXRSTOR },
  { "fxrstor64", X86::FXRSTOR64 },
  { "fxsave", X86::FXSAVE },
  { "fxsave64", X86::FXSAVE64 },
  { "fxtract", X86::FXTRACT },
  { "fyl2x", X86::FYL2X },
  { "fyl2xp1", X86::FYL2XP1 },
  { "gs", X86::GS_PREFIX },
  { "haddpd", X86::HADDPDrr },
  { "haddpd", X86::HADDPDrm },
  { "haddps", X86::HADDPSrr },
  { "haddps", X86::HADDPSrm },
  { "hlt", X86::HLT },
  { "hsubpd", X86::HSUBPDrr },
  { "hsubpd", X86::HSUBPDrm },
  { "hsubps", X86::HSUBPSrr },
  { "hsubps", X86::HSUBPSrm },
  { "idiv", X86::IDIV8r },
  { "idiv", X86::IDIV16r },
  { "idiv", X86::IDIV32r },
  { "idiv", X86::IDIV64r },
  { "idiv", X86::IDIV16m },
  { "idiv", X86::IDIV32m },
  { "idiv", X86::IDIV64m },
  { "idiv", X86::IDIV8m },
  { "idiv", X86::IDIV8r },
  { "idiv", X86::IDIV8m },
  { "idiv", X86::IDIV16r },
  { "idiv", X86::IDIV16m },
  { "idiv", X86::IDIV32r },
  { "idiv", X86::IDIV32m },
  { "idiv", X86::IDIV64r },
  { "idiv", X86::IDIV64m },
  { "imul", X86::IMUL8r },
  { "imul", X86::IMUL16r },
  { "imul", X86::IMUL32r },
  { "imul", X86::IMUL64r },
  { "imul", X86::IMUL16m },
  { "imul", X86::IMUL32m },
  { "imul", X86::IMUL64m },
  { "imul", X86::IMUL8m },
  { "imul", X86::IMUL16rr },
  { "imul", X86::IMUL16rm },
  { "imul", X86::IMUL32rr },
  { "imul", X86::IMUL32rm },
  { "imul", X86::IMUL64rr },
  { "imul", X86::IMUL64rm },
  { "imul", X86::IMUL16rri8 },
  { "imul", X86::IMUL16rri },
  { "imul", X86::IMUL16rmi8 },
  { "imul", X86::IMUL16rmi },
  { "imul", X86::IMUL32rri8 },
  { "imul", X86::IMUL32rri },
  { "imul", X86::IMUL32rmi8 },
  { "imul", X86::IMUL32rmi },
  { "imul", X86::IMUL64rri8 },
  { "imul", X86::IMUL64rri32 },
  { "imul", X86::IMUL64rmi8 },
  { "imul", X86::IMUL64rmi32 },
  { "imull", X86::IMUL32rri8 },
  { "imull", X86::IMUL32rri },
  { "imulq", X86::IMUL64rri8 },
  { "imulq", X86::IMUL64rri32 },
  { "imulw", X86::IMUL16rri8 },
  { "imulw", X86::IMUL16rri },
  { "in", X86::IN8rr },
  { "in", X86::IN8ri },
  { "in", X86::IN16rr },
  { "in", X86::IN16ri },
  { "in", X86::IN32rr },
  { "in", X86::IN32ri },
  { "inb", X86::IN8rr },
  { "inb", X86::IN8ri },
  { "inc", X86::INC8r },
  { "inc", X86::INC16r },
  { "inc", X86::INC64_16r },
  { "inc", X86::INC32r },
  { "inc", X86::INC64_32r },
  { "inc", X86::INC64r },
  { "inc", X86::INC16m },
  { "inc", X86::INC64_16m },
  { "inc", X86::INC32m },
  { "inc", X86::INC64_32m },
  { "inc", X86::INC64m },
  { "inc", X86::INC8m },
  { "inl", X86::IN32rr },
  { "inl", X86::IN32ri },
  { "insb", X86::INSB },
  { "insd", X86::INSL },
  { "insertps", X86::INSERTPSrr },
  { "insertps", X86::INSERTPSrm },
  { "insertq", X86::INSERTQ },
  { "insertq", X86::INSERTQI },
  { "insw", X86::INSW },
  { "int", X86::INT },
  { "int3", X86::INT3 },
  { "into", X86::INTO },
  { "invd", X86::INVD },
  { "invept", X86::INVEPT32 },
  { "invept", X86::INVEPT64 },
  { "invlpg", X86::INVLPG },
  { "invlpga", X86::INVLPGA32 },
  { "invlpga", X86::INVLPGA64 },
  { "invpcid", X86::INVPCID32 },
  { "invpcid", X86::INVPCID64 },
  { "invvpid", X86::INVVPID32 },
  { "invvpid", X86::INVVPID64 },
  { "inw", X86::IN16rr },
  { "inw", X86::IN16ri },
  { "iret", X86::IRET16 },
  { "iretd", X86::IRET32 },
  { "iretq", X86::IRET64 },
  { "ja", X86::JA_2 },
  { "ja", X86::JA_1 },
  { "ja", X86::JA_4 },
  { "jae", X86::JAE_2 },
  { "jae", X86::JAE_1 },
  { "jae", X86::JAE_4 },
  { "jb", X86::JB_2 },
  { "jb", X86::JB_1 },
  { "jb", X86::JB_4 },
  { "jbe", X86::JBE_2 },
  { "jbe", X86::JBE_1 },
  { "jbe", X86::JBE_4 },
  { "jcxz", X86::JCXZ },
  { "je", X86::JE_2 },
  { "je", X86::JE_1 },
  { "je", X86::JE_4 },
  { "jecxz", X86::JECXZ_32 },
  { "jecxz", X86::JECXZ_64 },
  { "jg", X86::JG_2 },
  { "jg", X86::JG_1 },
  { "jg", X86::JG_4 },
  { "jge", X86::JGE_2 },
  { "jge", X86::JGE_1 },
  { "jge", X86::JGE_4 },
  { "jl", X86::JL_2 },
  { "jl", X86::JL_1 },
  { "jl", X86::JL_4 },
  { "jle", X86::JLE_2 },
  { "jle", X86::JLE_1 },
  { "jle", X86::JLE_4 },
  { "jmp", X86::JMP16r },
  { "jmp", X86::JMP32r },
  { "jmp", X86::JMP64r },
  { "jmp", X86::JMP_2 },
  { "jmp", X86::JMP_1 },
  { "jmp", X86::JMP_4 },
  { "jmp", X86::JMP16m },
  { "jmp", X86::JMP32m },
  { "jmp", X86::JMP64m },
  { "jmp", X86::JMP64m },
  { "jmp", X86::JMP32m },
  { "jmp", X86::JMP16m },
  { "jmp", X86::FARJMP16i },
  { "jmp", X86::FARJMP32i },
  { "jmpl", X86::FARJMP32i },
  { "jmpw", X86::FARJMP16i },
  { "jne", X86::JNE_2 },
  { "jne", X86::JNE_1 },
  { "jne", X86::JNE_4 },
  { "jno", X86::JNO_2 },
  { "jno", X86::JNO_1 },
  { "jno", X86::JNO_4 },
  { "jnp", X86::JNP_2 },
  { "jnp", X86::JNP_1 },
  { "jnp", X86::JNP_4 },
  { "jns", X86::JNS_2 },
  { "jns", X86::JNS_1 },
  { "jns", X86::JNS_4 },
  { "jo", X86::JO_2 },
  { "jo", X86::JO_1 },
  { "jo", X86::JO_4 },
  { "jp", X86::JP_2 },
  { "jp", X86::JP_1 },
  { "jp", X86::JP_4 },
  { "jrcxz", X86::JRCXZ },
  { "js", X86::JS_2 },
  { "js", X86::JS_1 },
  { "js", X86::JS_4 },
  { "kandb", X86::KANDBrr },
  { "kandd", X86::KANDDrr },
  { "kandnb", X86::KANDNBrr },
  { "kandnd", X86::KANDNDrr },
  { "kandnq", X86::KANDNQrr },
  { "kandnw", X86::KANDNWrr },
  { "kandq", X86::KANDQrr },
  { "kandw", X86::KANDWrr },
  { "kmovb", X86::KMOVBrk },
  { "kmovb", X86::KMOVBkr },
  { "kmovb", X86::KMOVBkk },
  { "kmovb", X86::KMOVBkm },
  { "kmovb", X86::KMOVBmk },
  { "kmovd", X86::KMOVDrk },
  { "kmovd", X86::KMOVDkr },
  { "kmovd", X86::KMOVDkk },
  { "kmovd", X86::KMOVDkm },
  { "kmovd", X86::KMOVDmk },
  { "kmovq", X86::KMOVQrk },
  { "kmovq", X86::KMOVQkr },
  { "kmovq", X86::KMOVQkk },
  { "kmovq", X86::KMOVQkm },
  { "kmovq", X86::KMOVQmk },
  { "kmovw", X86::KMOVWrk },
  { "kmovw", X86::KMOVWkr },
  { "kmovw", X86::KMOVWkk },
  { "kmovw", X86::KMOVWkm },
  { "kmovw", X86::KMOVWmk },
  { "knotb", X86::KNOTBrr },
  { "knotd", X86::KNOTDrr },
  { "knotq", X86::KNOTQrr },
  { "knotw", X86::KNOTWrr },
  { "korb", X86::KORBrr },
  { "kord", X86::KORDrr },
  { "korq", X86::KORQrr },
  { "kortestw", X86::KORTESTWrr },
  { "korw", X86::KORWrr },
  { "kshiftlw", X86::KSHIFTLWri },
  { "kshiftrw", X86::KSHIFTRWri },
  { "kunpckbw", X86::KUNPCKBWrr },
  { "kxnorb", X86::KXNORBrr },
  { "kxnord", X86::KXNORDrr },
  { "kxnorq", X86::KXNORQrr },
  { "kxnorw", X86::KXNORWrr },
  { "kxorb", X86::KXORBrr },
  { "kxord", X86::KXORDrr },
  { "kxorq", X86::KXORQrr },
  { "kxorw", X86::KXORWrr },
  { "lahf", X86::LAHF },
  { "lar", X86::LAR16rr },
  { "lar", X86::LAR16rm },
  { "lar", X86::LAR32rr },
  { "lar", X86::LAR32rm },
  { "lar", X86::LAR64rr },
  { "lar", X86::LAR64rm },
  { "lcall", X86::FARCALL16m },
  { "lcall", X86::FARCALL32m },
  { "lcall", X86::FARCALL64 },
  { "lcall", X86::FARCALL32m },
  { "lcall", X86::FARCALL16m },
  { "lcall", X86::FARCALL32i },
  { "lcall", X86::FARCALL16i },
  { "lcall", X86::FARCALL16i },
  { "lcall", X86::FARCALL32i },
  { "lddqu", X86::LDDQUrm },
  { "ldmxcsr", X86::LDMXCSR },
  { "lds", X86::LDS16rm },
  { "lds", X86::LDS32rm },
  { "lea", X86::LEA16r },
  { "lea", X86::LEA32r },
  { "lea", X86::LEA64_32r },
  { "lea", X86::LEA64r },
  { "leave", X86::LEAVE },
  { "leave", X86::LEAVE64 },
  { "les", X86::LES16rm },
  { "les", X86::LES32rm },
  { "lfence", X86::LFENCE },
  { "lfs", X86::LFS16rm },
  { "lfs", X86::LFS32rm },
  { "lfs", X86::LFS64rm },
  { "lgdt", X86::LGDT16m },
  { "lgdt", X86::LGDT32m },
  { "lgdt", X86::LGDT64m },
  { "lgs", X86::LGS16rm },
  { "lgs", X86::LGS32rm },
  { "lgs", X86::LGS64rm },
  { "lidt", X86::LIDT16m },
  { "lidt", X86::LIDT32m },
  { "lidt", X86::LIDT64m },
  { "ljmp", X86::FARJMP16m },
  { "ljmp", X86::FARJMP32m },
  { "ljmp", X86::FARJMP64 },
  { "ljmp", X86::FARJMP32m },
  { "ljmp", X86::FARJMP16m },
  { "ljmp", X86::FARJMP32i },
  { "ljmp", X86::FARJMP16i },
  { "ljmp", X86::FARJMP16i },
  { "ljmp", X86::FARJMP32i },
  { "lldt", X86::LLDT16r },
  { "lldt", X86::LLDT16m },
  { "lmsw", X86::LMSW16r },
  { "lmsw", X86::LMSW16m },
  { "lock", X86::LOCK_PREFIX },
  { "lods", X86::LODSB },
  { "lods", X86::LODSW },
  { "lods", X86::LODSL },
  { "lods", X86::LODSQ },
  { "lodsb", X86::LODSB },
  { "lodsb", X86::LODSB },
  { "lodsd", X86::LODSL },
  { "lodsd", X86::LODSL },
  { "lodsq", X86::LODSQ },
  { "lodsq", X86::LODSQ },
  { "lodsw", X86::LODSW },
  { "lodsw", X86::LODSW },
  { "loop", X86::LOOP },
  { "loope", X86::LOOPE },
  { "loopne", X86::LOOPNE },
  { "lsl", X86::LSL16rr },
  { "lsl", X86::LSL16rm },
  { "lsl", X86::LSL32rr },
  { "lsl", X86::LSL32rm },
  { "lsl", X86::LSL64rr },
  { "lsl", X86::LSL64rm },
  { "lss", X86::LSS16rm },
  { "lss", X86::LSS32rm },
  { "lss", X86::LSS64rm },
  { "ltr", X86::LTRr },
  { "ltr", X86::LTRm },
  { "lzcnt", X86::LZCNT16rr },
  { "lzcnt", X86::LZCNT16rm },
  { "lzcnt", X86::LZCNT32rr },
  { "lzcnt", X86::LZCNT32rm },
  { "lzcnt", X86::LZCNT64rr },
  { "lzcnt", X86::LZCNT64rm },
  { "maskmovdqu", X86::MASKMOVDQU },
  { "maskmovdqu", X86::MASKMOVDQU64 },
  { "maskmovq", X86::MMX_MASKMOVQ },
  { "maskmovq", X86::MMX_MASKMOVQ64 },
  { "maxpd", X86::MAXPDrr },
  { "maxpd", X86::MAXPDrm },
  { "maxps", X86::MAXPSrr },
  { "maxps", X86::MAXPSrm },
  { "maxsd", X86::MAXSDrr },
  { "maxsd", X86::MAXSDrm },
  { "maxss", X86::MAXSSrr },
  { "maxss", X86::MAXSSrm },
  { "mfence", X86::MFENCE },
  { "minpd", X86::MINPDrr },
  { "minpd", X86::MINPDrm },
  { "minps", X86::MINPSrr },
  { "minps", X86::MINPSrm },
  { "minsd", X86::MINSDrr },
  { "minsd", X86::MINSDrm },
  { "minss", X86::MINSSrr },
  { "minss", X86::MINSSrm },
  { "monitor", X86::MONITORrrr },
  { "monitor", X86::MONITORrrr },
  { "monitor", X86::MONITORrrr },
  { "montmul", X86::MONTMUL },
  { "mov", X86::MOV8o8a },
  { "mov", X86::MOV8o8a_16 },
  { "mov", X86::MOV8rr },
  { "mov", X86::MOV8ri },
  { "mov", X86::MOV8rm },
  { "mov", X86::MOV16o16a },
  { "mov", X86::MOV16o16a_16 },
  { "mov", X86::MOV16rr },
  { "mov", X86::MOV16rs },
  { "mov", X86::MOV16ri },
  { "mov", X86::MOV16rm },
  { "mov", X86::MOV32o32a },
  { "mov", X86::MOV32o32a_16 },
  { "mov", X86::MOV32rr },
  { "mov", X86::MOV32rs },
  { "mov", X86::MOV32rd },
  { "mov", X86::MOV32rc },
  { "mov", X86::MOV32ri },
  { "mov", X86::MOV32rm },
  { "mov", X86::MOV64rr },
  { "mov", X86::MOV64rs },
  { "mov", X86::MOV64rd },
  { "mov", X86::MOV64rc },
  { "mov", X86::MOV64ri32 },
  { "mov", X86::MOV64rm },
  { "mov", X86::MOV16sr },
  { "mov", X86::MOV32sr },
  { "mov", X86::MOV64sr },
  { "mov", X86::MOV16sm },
  { "mov", X86::MOV32sm },
  { "mov", X86::MOV32ms },
  { "mov", X86::MOV64sm },
  { "mov", X86::MOV32dr },
  { "mov", X86::MOV64dr },
  { "mov", X86::MOV32cr },
  { "mov", X86::MOV64cr },
  { "mov", X86::MOV32sm },
  { "mov", X86::MOV64mr },
  { "mov", X86::MOV64ms },
  { "mov", X86::MOV64mi32 },
  { "mov", X86::MOV16ao16 },
  { "mov", X86::MOV16ao16_16 },
  { "mov", X86::MOV16mr },
  { "mov", X86::MOV16ms },
  { "mov", X86::MOV16mi },
  { "mov", X86::MOV32ao32 },
  { "mov", X86::MOV32ao32_16 },
  { "mov", X86::MOV32mr },
  { "mov", X86::MOV32ms },
  { "mov", X86::MOV32mi },
  { "mov", X86::MOV8ao8 },
  { "mov", X86::MOV8ao8_16 },
  { "mov", X86::MOV8mr },
  { "mov", X86::MOV8mi },
  { "movabs", X86::MOV64o8a },
  { "movabs", X86::MOV64o16a },
  { "movabs", X86::MOV64o32a },
  { "movabs", X86::MOV64o64a },
  { "movabs", X86::MOV64ri },
  { "movabs", X86::MOV64ao16 },
  { "movabs", X86::MOV64ao32 },
  { "movabs", X86::MOV64ao64 },
  { "movabs", X86::MOV64ao8 },
  { "movapd", X86::MOVAPDrr },
  { "movapd", X86::MOVAPDrm },
  { "movapd", X86::MOVAPDmr },
  { "movaps", X86::MOVAPSrr },
  { "movaps", X86::MOVAPSrm },
  { "movaps", X86::MOVAPSmr },
  { "movbe", X86::MOVBE16rm },
  { "movbe", X86::MOVBE32rm },
  { "movbe", X86::MOVBE64rm },
  { "movbe", X86::MOVBE16mr },
  { "movbe", X86::MOVBE32mr },
  { "movbe", X86::MOVBE64mr },
  { "movd", X86::MMX_MOVD64grr },
  { "movd", X86::MOVPDI2DIrr },
  { "movd", X86::MMX_MOVD64from64rr },
  { "movd", X86::MMX_MOVD64rr },
  { "movd", X86::MMX_MOVD64to64rr },
  { "movd", X86::MMX_MOVD64rm },
  { "movd", X86::MOVDI2PDIrr },
  { "movd", X86::MOVDI2PDIrm },
  { "movd", X86::MMX_MOVD64mr },
  { "movd", X86::MOVPDI2DImr },
  { "movddup", X86::MOVDDUPrr },
  { "movddup", X86::MOVDDUPrm },
  { "movdq2q", X86::MMX_MOVDQ2Qrr },
  { "movdqa", X86::MOVDQArr },
  { "movdqa", X86::MOVDQArm },
  { "movdqa", X86::MOVDQAmr },
  { "movdqu", X86::MOVDQUrr },
  { "movdqu", X86::MOVDQUrm },
  { "movdqu", X86::MOVDQUmr },
  { "movhlps", X86::MOVHLPSrr },
  { "movhpd", X86::MOVHPDrm },
  { "movhpd", X86::MOVHPDmr },
  { "movhps", X86::MOVHPSrm },
  { "movhps", X86::MOVHPSmr },
  { "movlhps", X86::MOVLHPSrr },
  { "movlpd", X86::MOVLPDrm },
  { "movlpd", X86::MOVLPDmr },
  { "movlps", X86::MOVLPSrm },
  { "movlps", X86::MOVLPSmr },
  { "movmskpd", X86::MOVMSKPDrr },
  { "movmskps", X86::MOVMSKPSrr },
  { "movntdq", X86::MOVNTDQmr },
  { "movntdqa", X86::MOVNTDQArm },
  { "movnti", X86::MOVNTImr },
  { "movnti", X86::MOVNTI_64mr },
  { "movntpd", X86::MOVNTPDmr },
  { "movntps", X86::MOVNTPSmr },
  { "movntq", X86::MMX_MOVNTQmr },
  { "movntsd", X86::MOVNTSD },
  { "movntss", X86::MOVNTSS },
  { "movq", X86::MMX_MOVD64to64rr },
  { "movq", X86::MOVPQIto64rr },
  { "movq", X86::MOVPQIto64rr },
  { "movq", X86::MMX_MOVD64from64rr },
  { "movq", X86::MMX_MOVQ64rr },
  { "movq", X86::MMX_MOVQ64rm },
  { "movq", X86::MOV64toPQIrr },
  { "movq", X86::MOV64toPQIrr },
  { "movq", X86::MOVZPQILo2PQIrr },
  { "movq", X86::MOVQI2PQIrm },
  { "movq", X86::MOV64ri },
  { "movq", X86::MMX_MOVQ64mr },
  { "movq", X86::MOVPQI2QImr },
  { "movq2dq", X86::MMX_MOVQ2DQrr },
  { "movsb", X86::MOVSB },
  { "movsd", X86::MOVSDrr },
  { "movsd", X86::MOVSDrm },
  { "movsd", X86::MOVSL },
  { "movsd", X86::MOVSDmr },
  { "movshdup", X86::MOVSHDUPrr },
  { "movshdup", X86::MOVSHDUPrm },
  { "movsldup", X86::MOVSLDUPrr },
  { "movsldup", X86::MOVSLDUPrm },
  { "movsq", X86::MOVSQ },
  { "movss", X86::MOVSSrr },
  { "movss", X86::MOVSSrm },
  { "movss", X86::MOVSSmr },
  { "movsw", X86::MOVSW },
  { "movsx", X86::MOVSX16rr8 },
  { "movsx", X86::MOVSX32rr8 },
  { "movsx", X86::MOVSX64rr8 },
  { "movsx", X86::MOVSX16rr8 },
  { "movsx", X86::MOVSX32rr16 },
  { "movsx", X86::MOVSX64rr16 },
  { "movsx", X86::MOVSX16rm8 },
  { "movsx", X86::MOVSX32rr8 },
  { "movsx", X86::MOVSX32rr16 },
  { "movsx", X86::MOVSX64rr32 },
  { "movsx", X86::MOVSX32rm16 },
  { "movsx", X86::MOVSX32rm8 },
  { "movsx", X86::MOVSX64rr8 },
  { "movsx", X86::MOVSX64rr16 },
  { "movsx", X86::MOVSX64rm16 },
  { "movsx", X86::MOVSX64rm8 },
  { "movsx", X86::MOVSX16rm8 },
  { "movsxd", X86::MOVSX64rr32 },
  { "movsxd", X86::MOVSX64rm32 },
  { "movupd", X86::MOVUPDrr },
  { "movupd", X86::MOVUPDrm },
  { "movupd", X86::MOVUPDmr },
  { "movups", X86::MOVUPSrr },
  { "movups", X86::MOVUPSrm },
  { "movups", X86::MOVUPSmr },
  { "movzx", X86::MOVZX16rr8 },
  { "movzx", X86::MOVZX32rr8 },
  { "movzx", X86::MOVZX64rr8_Q },
  { "movzx", X86::MOVZX16rr8 },
  { "movzx", X86::MOVZX32rr16 },
  { "movzx", X86::MOVZX64rr16_Q },
  { "movzx", X86::MOVZX16rm8 },
  { "movzx", X86::MOVZX32rr8 },
  { "movzx", X86::MOVZX32rr16 },
  { "movzx", X86::MOVZX32rm16 },
  { "movzx", X86::MOVZX32rm8 },
  { "movzx", X86::MOVZX64rr8_Q },
  { "movzx", X86::MOVZX64rr16_Q },
  { "movzx", X86::MOVZX64rm16_Q },
  { "movzx", X86::MOVZX64rm8_Q },
  { "movzx", X86::MOVZX16rm8 },
  { "mpsadbw", X86::MPSADBWrri },
  { "mpsadbw", X86::MPSADBWrmi },
  { "mul", X86::MUL8r },
  { "mul", X86::MUL16r },
  { "mul", X86::MUL32r },
  { "mul", X86::MUL64r },
  { "mul", X86::MUL16m },
  { "mul", X86::MUL32m },
  { "mul", X86::MUL64m },
  { "mul", X86::MUL8m },
  { "mulpd", X86::MULPDrr },
  { "mulpd", X86::MULPDrm },
  { "mulps", X86::MULPSrr },
  { "mulps", X86::MULPSrm },
  { "mulsd", X86::MULSDrr },
  { "mulsd", X86::MULSDrm },
  { "mulss", X86::MULSSrr },
  { "mulss", X86::MULSSrm },
  { "mulx", X86::MULX32rr },
  { "mulx", X86::MULX32rm },
  { "mulx", X86::MULX64rr },
  { "mulx", X86::MULX64rm },
  { "mwait", X86::MWAITrr },
  { "mwait", X86::MWAITrr },
  { "mwait", X86::MWAITrr },
  { "neg", X86::NEG8r },
  { "neg", X86::NEG16r },
  { "neg", X86::NEG32r },
  { "neg", X86::NEG64r },
  { "neg", X86::NEG16m },
  { "neg", X86::NEG32m },
  { "neg", X86::NEG64m },
  { "neg", X86::NEG8m },
  { "nop", X86::NOOP },
  { "nop", X86::NOOPW },
  { "nop", X86::NOOPL },
  { "not", X86::NOT8r },
  { "not", X86::NOT16r },
  { "not", X86::NOT32r },
  { "not", X86::NOT64r },
  { "not", X86::NOT16m },
  { "not", X86::NOT32m },
  { "not", X86::NOT64m },
  { "not", X86::NOT8m },
  { "or", X86::OR8i8 },
  { "or", X86::OR8rr },
  { "or", X86::OR8ri },
  { "or", X86::OR8rm },
  { "or", X86::OR16i16 },
  { "or", X86::OR16rr },
  { "or", X86::OR16ri8 },
  { "or", X86::OR16ri },
  { "or", X86::OR16rm },
  { "or", X86::OR32i32 },
  { "or", X86::OR32rr },
  { "or", X86::OR32ri8 },
  { "or", X86::OR32ri },
  { "or", X86::OR32rm },
  { "or", X86::OR64i32 },
  { "or", X86::OR64rr },
  { "or", X86::OR64ri8 },
  { "or", X86::OR64ri32 },
  { "or", X86::OR64rm },
  { "or", X86::OR16mr },
  { "or", X86::OR16mi8 },
  { "or", X86::OR16mi },
  { "or", X86::OR32mr },
  { "or", X86::OR32mi8 },
  { "or", X86::OR32mi },
  { "or", X86::OR64mr },
  { "or", X86::OR64mi8 },
  { "or", X86::OR64mi32 },
  { "or", X86::OR8mr },
  { "or", X86::OR8mi },
  { "orpd", X86::ORPDrr },
  { "orpd", X86::ORPDrm },
  { "orps", X86::ORPSrr },
  { "orps", X86::ORPSrm },
  { "out", X86::OUT8rr },
  { "out", X86::OUT16rr },
  { "out", X86::OUT32rr },
  { "out", X86::OUT8ir },
  { "out", X86::OUT16ir },
  { "out", X86::OUT32ir },
  { "outb", X86::OUT8rr },
  { "outb", X86::OUT8ir },
  { "outl", X86::OUT32rr },
  { "outl", X86::OUT32ir },
  { "outsb", X86::OUTSB },
  { "outsd", X86::OUTSL },
  { "outsw", X86::OUTSW },
  { "outw", X86::OUT16rr },
  { "outw", X86::OUT16ir },
  { "pabsb", X86::MMX_PABSBrr64 },
  { "pabsb", X86::MMX_PABSBrm64 },
  { "pabsb", X86::PABSBrr128 },
  { "pabsb", X86::PABSBrm128 },
  { "pabsd", X86::MMX_PABSDrr64 },
  { "pabsd", X86::MMX_PABSDrm64 },
  { "pabsd", X86::PABSDrr128 },
  { "pabsd", X86::PABSDrm128 },
  { "pabsw", X86::MMX_PABSWrr64 },
  { "pabsw", X86::MMX_PABSWrm64 },
  { "pabsw", X86::PABSWrr128 },
  { "pabsw", X86::PABSWrm128 },
  { "packssdw", X86::MMX_PACKSSDWirr },
  { "packssdw", X86::MMX_PACKSSDWirm },
  { "packssdw", X86::PACKSSDWrr },
  { "packssdw", X86::PACKSSDWrm },
  { "packsswb", X86::MMX_PACKSSWBirr },
  { "packsswb", X86::MMX_PACKSSWBirm },
  { "packsswb", X86::PACKSSWBrr },
  { "packsswb", X86::PACKSSWBrm },
  { "packusdw", X86::PACKUSDWrr },
  { "packusdw", X86::PACKUSDWrm },
  { "packuswb", X86::MMX_PACKUSWBirr },
  { "packuswb", X86::MMX_PACKUSWBirm },
  { "packuswb", X86::PACKUSWBrr },
  { "packuswb", X86::PACKUSWBrm },
  { "paddb", X86::MMX_PADDBirr },
  { "paddb", X86::MMX_PADDBirm },
  { "paddb", X86::PADDBrr },
  { "paddb", X86::PADDBrm },
  { "paddd", X86::MMX_PADDDirr },
  { "paddd", X86::MMX_PADDDirm },
  { "paddd", X86::PADDDrr },
  { "paddd", X86::PADDDrm },
  { "paddq", X86::MMX_PADDQirr },
  { "paddq", X86::MMX_PADDQirm },
  { "paddq", X86::PADDQrr },
  { "paddq", X86::PADDQrm },
  { "paddsb", X86::MMX_PADDSBirr },
  { "paddsb", X86::MMX_PADDSBirm },
  { "paddsb", X86::PADDSBrr },
  { "paddsb", X86::PADDSBrm },
  { "paddsw", X86::MMX_PADDSWirr },
  { "paddsw", X86::MMX_PADDSWirm },
  { "paddsw", X86::PADDSWrr },
  { "paddsw", X86::PADDSWrm },
  { "paddusb", X86::MMX_PADDUSBirr },
  { "paddusb", X86::MMX_PADDUSBirm },
  { "paddusb", X86::PADDUSBrr },
  { "paddusb", X86::PADDUSBrm },
  { "paddusw", X86::MMX_PADDUSWirr },
  { "paddusw", X86::MMX_PADDUSWirm },
  { "paddusw", X86::PADDUSWrr },
  { "paddusw", X86::PADDUSWrm },
  { "paddw", X86::MMX_PADDWirr },
  { "paddw", X86::MMX_PADDWirm },
  { "paddw", X86::PADDWrr },
  { "paddw", X86::PADDWrm },
  { "palignr", X86::MMX_PALIGNR64irr },
  { "palignr", X86::MMX_PALIGNR64irm },
  { "palignr", X86::PALIGNR128rr },
  { "palignr", X86::PALIGNR128rm },
  { "pand", X86::MMX_PANDirr },
  { "pand", X86::MMX_PANDirm },
  { "pand", X86::PANDrr },
  { "pand", X86::PANDrm },
  { "pandn", X86::MMX_PANDNirr },
  { "pandn", X86::MMX_PANDNirm },
  { "pandn", X86::PANDNrr },
  { "pandn", X86::PANDNrm },
  { "pause", X86::PAUSE },
  { "pavgb", X86::MMX_PAVGBirr },
  { "pavgb", X86::MMX_PAVGBirm },
  { "pavgb", X86::PAVGBrr },
  { "pavgb", X86::PAVGBrm },
  { "pavgusb", X86::PAVGUSBrr },
  { "pavgusb", X86::PAVGUSBrm },
  { "pavgw", X86::MMX_PAVGWirr },
  { "pavgw", X86::MMX_PAVGWirm },
  { "pavgw", X86::PAVGWrr },
  { "pavgw", X86::PAVGWrm },
  { "pblendvb", X86::PBLENDVBrr0 },
  { "pblendvb", X86::PBLENDVBrm0 },
  { "pblendvb", X86::PBLENDVBrr0 },
  { "pblendvb", X86::PBLENDVBrm0 },
  { "pblendw", X86::PBLENDWrri },
  { "pblendw", X86::PBLENDWrmi },
  { "pclmulhqhqdq", X86::PCLMULQDQrr },
  { "pclmulhqhqdq", X86::PCLMULQDQrm },
  { "pclmulhqlqdq", X86::PCLMULQDQrr },
  { "pclmulhqlqdq", X86::PCLMULQDQrm },
  { "pclmullqhqdq", X86::PCLMULQDQrr },
  { "pclmullqhqdq", X86::PCLMULQDQrm },
  { "pclmullqlqdq", X86::PCLMULQDQrr },
  { "pclmullqlqdq", X86::PCLMULQDQrm },
  { "pclmulqdq", X86::PCLMULQDQrr },
  { "pclmulqdq", X86::PCLMULQDQrm },
  { "pcmpeqb", X86::MMX_PCMPEQBirr },
  { "pcmpeqb", X86::MMX_PCMPEQBirm },
  { "pcmpeqb", X86::PCMPEQBrr },
  { "pcmpeqb", X86::PCMPEQBrm },
  { "pcmpeqd", X86::MMX_PCMPEQDirr },
  { "pcmpeqd", X86::MMX_PCMPEQDirm },
  { "pcmpeqd", X86::PCMPEQDrr },
  { "pcmpeqd", X86::PCMPEQDrm },
  { "pcmpeqq", X86::PCMPEQQrr },
  { "pcmpeqq", X86::PCMPEQQrm },
  { "pcmpeqw", X86::MMX_PCMPEQWirr },
  { "pcmpeqw", X86::MMX_PCMPEQWirm },
  { "pcmpeqw", X86::PCMPEQWrr },
  { "pcmpeqw", X86::PCMPEQWrm },
  { "pcmpestri", X86::PCMPESTRIrr },
  { "pcmpestri", X86::PCMPESTRIrm },
  { "pcmpestrm", X86::PCMPESTRM128rr },
  { "pcmpestrm", X86::PCMPESTRM128rm },
  { "pcmpgtb", X86::MMX_PCMPGTBirr },
  { "pcmpgtb", X86::MMX_PCMPGTBirm },
  { "pcmpgtb", X86::PCMPGTBrr },
  { "pcmpgtb", X86::PCMPGTBrm },
  { "pcmpgtd", X86::MMX_PCMPGTDirr },
  { "pcmpgtd", X86::MMX_PCMPGTDirm },
  { "pcmpgtd", X86::PCMPGTDrr },
  { "pcmpgtd", X86::PCMPGTDrm },
  { "pcmpgtq", X86::PCMPGTQrr },
  { "pcmpgtq", X86::PCMPGTQrm },
  { "pcmpgtw", X86::MMX_PCMPGTWirr },
  { "pcmpgtw", X86::MMX_PCMPGTWirm },
  { "pcmpgtw", X86::PCMPGTWrr },
  { "pcmpgtw", X86::PCMPGTWrm },
  { "pcmpistri", X86::PCMPISTRIrr },
  { "pcmpistri", X86::PCMPISTRIrm },
  { "pcmpistrm", X86::PCMPISTRM128rr },
  { "pcmpistrm", X86::PCMPISTRM128rm },
  { "pdep", X86::PDEP32rr },
  { "pdep", X86::PDEP32rm },
  { "pdep", X86::PDEP64rr },
  { "pdep", X86::PDEP64rm },
  { "pext", X86::PEXT32rr },
  { "pext", X86::PEXT32rm },
  { "pext", X86::PEXT64rr },
  { "pext", X86::PEXT64rm },
  { "pextrb", X86::PEXTRBrr },
  { "pextrb", X86::PEXTRBmr },
  { "pextrd", X86::PEXTRDrr },
  { "pextrd", X86::PEXTRDmr },
  { "pextrq", X86::PEXTRQrr },
  { "pextrq", X86::PEXTRQmr },
  { "pextrw", X86::MMX_PEXTRWirri },
  { "pextrw", X86::PEXTRWri },
  { "pextrw", X86::PEXTRWmr },
  { "pf2id", X86::PF2IDrr },
  { "pf2id", X86::PF2IDrm },
  { "pf2iw", X86::PF2IWrr },
  { "pf2iw", X86::PF2IWrm },
  { "pfacc", X86::PFACCrr },
  { "pfacc", X86::PFACCrm },
  { "pfadd", X86::PFADDrr },
  { "pfadd", X86::PFADDrm },
  { "pfcmpeq", X86::PFCMPEQrr },
  { "pfcmpeq", X86::PFCMPEQrm },
  { "pfcmpge", X86::PFCMPGErr },
  { "pfcmpge", X86::PFCMPGErm },
  { "pfcmpgt", X86::PFCMPGTrr },
  { "pfcmpgt", X86::PFCMPGTrm },
  { "pfmax", X86::PFMAXrr },
  { "pfmax", X86::PFMAXrm },
  { "pfmin", X86::PFMINrr },
  { "pfmin", X86::PFMINrm },
  { "pfmul", X86::PFMULrr },
  { "pfmul", X86::PFMULrm },
  { "pfnacc", X86::PFNACCrr },
  { "pfnacc", X86::PFNACCrm },
  { "pfpnacc", X86::PFPNACCrr },
  { "pfpnacc", X86::PFPNACCrm },
  { "pfrcp", X86::PFRCPrr },
  { "pfrcp", X86::PFRCPrm },
  { "pfrcpit1", X86::PFRCPIT1rr },
  { "pfrcpit1", X86::PFRCPIT1rm },
  { "pfrcpit2", X86::PFRCPIT2rr },
  { "pfrcpit2", X86::PFRCPIT2rm },
  { "pfrsqit1", X86::PFRSQIT1rr },
  { "pfrsqit1", X86::PFRSQIT1rm },
  { "pfrsqrt", X86::PFRSQRTrr },
  { "pfrsqrt", X86::PFRSQRTrm },
  { "pfsub", X86::PFSUBrr },
  { "pfsub", X86::PFSUBrm },
  { "pfsubr", X86::PFSUBRrr },
  { "pfsubr", X86::PFSUBRrm },
  { "phaddd", X86::MMX_PHADDrr64 },
  { "phaddd", X86::MMX_PHADDrm64 },
  { "phaddd", X86::PHADDDrr },
  { "phaddd", X86::PHADDDrm },
  { "phaddsw", X86::MMX_PHADDSWrr64 },
  { "phaddsw", X86::MMX_PHADDSWrm64 },
  { "phaddsw", X86::PHADDSWrr128 },
  { "phaddsw", X86::PHADDSWrm128 },
  { "phaddw", X86::MMX_PHADDWrr64 },
  { "phaddw", X86::MMX_PHADDWrm64 },
  { "phaddw", X86::PHADDWrr },
  { "phaddw", X86::PHADDWrm },
  { "phminposuw", X86::PHMINPOSUWrr128 },
  { "phminposuw", X86::PHMINPOSUWrm128 },
  { "phsubd", X86::MMX_PHSUBDrr64 },
  { "phsubd", X86::MMX_PHSUBDrm64 },
  { "phsubd", X86::PHSUBDrr },
  { "phsubd", X86::PHSUBDrm },
  { "phsubsw", X86::MMX_PHSUBSWrr64 },
  { "phsubsw", X86::MMX_PHSUBSWrm64 },
  { "phsubsw", X86::PHSUBSWrr128 },
  { "phsubsw", X86::PHSUBSWrm128 },
  { "phsubw", X86::MMX_PHSUBWrr64 },
  { "phsubw", X86::MMX_PHSUBWrm64 },
  { "phsubw", X86::PHSUBWrr },
  { "phsubw", X86::PHSUBWrm },
  { "pi2fd", X86::PI2FDrr },
  { "pi2fd", X86::PI2FDrm },
  { "pi2fw", X86::PI2FWrr },
  { "pi2fw", X86::PI2FWrm },
  { "pinsrb", X86::PINSRBrr },
  { "pinsrb", X86::PINSRBrm },
  { "pinsrd", X86::PINSRDrr },
  { "pinsrd", X86::PINSRDrm },
  { "pinsrq", X86::PINSRQrr },
  { "pinsrq", X86::PINSRQrm },
  { "pinsrw", X86::MMX_PINSRWirri },
  { "pinsrw", X86::MMX_PINSRWirmi },
  { "pinsrw", X86::PINSRWrri },
  { "pinsrw", X86::PINSRWrmi },
  { "pmaddubsw", X86::MMX_PMADDUBSWrr64 },
  { "pmaddubsw", X86::MMX_PMADDUBSWrm64 },
  { "pmaddubsw", X86::PMADDUBSWrr128 },
  { "pmaddubsw", X86::PMADDUBSWrm128 },
  { "pmaddwd", X86::MMX_PMADDWDirr },
  { "pmaddwd", X86::MMX_PMADDWDirm },
  { "pmaddwd", X86::PMADDWDrr },
  { "pmaddwd", X86::PMADDWDrm },
  { "pmaxsb", X86::PMAXSBrr },
  { "pmaxsb", X86::PMAXSBrm },
  { "pmaxsd", X86::PMAXSDrr },
  { "pmaxsd", X86::PMAXSDrm },
  { "pmaxsw", X86::MMX_PMAXSWirr },
  { "pmaxsw", X86::MMX_PMAXSWirm },
  { "pmaxsw", X86::PMAXSWrr },
  { "pmaxsw", X86::PMAXSWrm },
  { "pmaxub", X86::MMX_PMAXUBirr },
  { "pmaxub", X86::MMX_PMAXUBirm },
  { "pmaxub", X86::PMAXUBrr },
  { "pmaxub", X86::PMAXUBrm },
  { "pmaxud", X86::PMAXUDrr },
  { "pmaxud", X86::PMAXUDrm },
  { "pmaxuw", X86::PMAXUWrr },
  { "pmaxuw", X86::PMAXUWrm },
  { "pminsb", X86::PMINSBrr },
  { "pminsb", X86::PMINSBrm },
  { "pminsd", X86::PMINSDrr },
  { "pminsd", X86::PMINSDrm },
  { "pminsw", X86::MMX_PMINSWirr },
  { "pminsw", X86::MMX_PMINSWirm },
  { "pminsw", X86::PMINSWrr },
  { "pminsw", X86::PMINSWrm },
  { "pminub", X86::MMX_PMINUBirr },
  { "pminub", X86::MMX_PMINUBirm },
  { "pminub", X86::PMINUBrr },
  { "pminub", X86::PMINUBrm },
  { "pminud", X86::PMINUDrr },
  { "pminud", X86::PMINUDrm },
  { "pminuw", X86::PMINUWrr },
  { "pminuw", X86::PMINUWrm },
  { "pmovmskb", X86::MMX_PMOVMSKBrr },
  { "pmovmskb", X86::PMOVMSKBrr },
  { "pmovsxbd", X86::PMOVSXBDrr },
  { "pmovsxbd", X86::PMOVSXBDrm },
  { "pmovsxbq", X86::PMOVSXBQrr },
  { "pmovsxbq", X86::PMOVSXBQrm },
  { "pmovsxbw", X86::PMOVSXBWrr },
  { "pmovsxbw", X86::PMOVSXBWrm },
  { "pmovsxdq", X86::PMOVSXDQrr },
  { "pmovsxdq", X86::PMOVSXDQrm },
  { "pmovsxwd", X86::PMOVSXWDrr },
  { "pmovsxwd", X86::PMOVSXWDrm },
  { "pmovsxwq", X86::PMOVSXWQrr },
  { "pmovsxwq", X86::PMOVSXWQrm },
  { "pmovzxbd", X86::PMOVZXBDrr },
  { "pmovzxbd", X86::PMOVZXBDrm },
  { "pmovzxbq", X86::PMOVZXBQrr },
  { "pmovzxbq", X86::PMOVZXBQrm },
  { "pmovzxbw", X86::PMOVZXBWrr },
  { "pmovzxbw", X86::PMOVZXBWrm },
  { "pmovzxdq", X86::PMOVZXDQrr },
  { "pmovzxdq", X86::PMOVZXDQrm },
  { "pmovzxwd", X86::PMOVZXWDrr },
  { "pmovzxwd", X86::PMOVZXWDrm },
  { "pmovzxwq", X86::PMOVZXWQrr },
  { "pmovzxwq", X86::PMOVZXWQrm },
  { "pmuldq", X86::PMULDQrr },
  { "pmuldq", X86::PMULDQrm },
  { "pmulhrsw", X86::MMX_PMULHRSWrr64 },
  { "pmulhrsw", X86::MMX_PMULHRSWrm64 },
  { "pmulhrsw", X86::PMULHRSWrr128 },
  { "pmulhrsw", X86::PMULHRSWrm128 },
  { "pmulhrw", X86::PMULHRWrr },
  { "pmulhrw", X86::PMULHRWrm },
  { "pmulhuw", X86::MMX_PMULHUWirr },
  { "pmulhuw", X86::MMX_PMULHUWirm },
  { "pmulhuw", X86::PMULHUWrr },
  { "pmulhuw", X86::PMULHUWrm },
  { "pmulhw", X86::MMX_PMULHWirr },
  { "pmulhw", X86::MMX_PMULHWirm },
  { "pmulhw", X86::PMULHWrr },
  { "pmulhw", X86::PMULHWrm },
  { "pmulld", X86::PMULLDrr },
  { "pmulld", X86::PMULLDrm },
  { "pmullw", X86::MMX_PMULLWirr },
  { "pmullw", X86::MMX_PMULLWirm },
  { "pmullw", X86::PMULLWrr },
  { "pmullw", X86::PMULLWrm },
  { "pmuludq", X86::MMX_PMULUDQirr },
  { "pmuludq", X86::MMX_PMULUDQirm },
  { "pmuludq", X86::PMULUDQrr },
  { "pmuludq", X86::PMULUDQrm },
  { "pop", X86::POP16r },
  { "pop", X86::POP16rmr },
  { "pop", X86::POP32r },
  { "pop", X86::POP32rmr },
  { "pop", X86::POP64r },
  { "pop", X86::POP64rmr },
  { "pop", X86::POPDS16 },
  { "pop", X86::POPDS32 },
  { "pop", X86::POPSS16 },
  { "pop", X86::POPSS32 },
  { "pop", X86::POPES16 },
  { "pop", X86::POPES32 },
  { "pop", X86::POPFS32 },
  { "pop", X86::POPFS64 },
  { "pop", X86::POPFS16 },
  { "pop", X86::POPGS32 },
  { "pop", X86::POPGS64 },
  { "pop", X86::POPGS16 },
  { "pop", X86::POP16rmm },
  { "pop", X86::POP32rmm },
  { "pop", X86::POP64rmm },
  { "popal", X86::POPA32 },
  { "popaw", X86::POPA16 },
  { "popcnt", X86::POPCNT16rr },
  { "popcnt", X86::POPCNT16rm },
  { "popcnt", X86::POPCNT32rr },
  { "popcnt", X86::POPCNT32rm },
  { "popcnt", X86::POPCNT64rr },
  { "popcnt", X86::POPCNT64rm },
  { "popf", X86::POPF16 },
  { "popfd", X86::POPF32 },
  { "popfq", X86::POPF64 },
  { "por", X86::MMX_PORirr },
  { "por", X86::MMX_PORirm },
  { "por", X86::PORrr },
  { "por", X86::PORrm },
  { "prefetch", X86::PREFETCH },
  { "prefetchnta", X86::PREFETCHNTA },
  { "prefetcht0", X86::PREFETCHT0 },
  { "prefetcht1", X86::PREFETCHT1 },
  { "prefetcht2", X86::PREFETCHT2 },
  { "prefetchw", X86::PREFETCHW },
  { "psadbw", X86::MMX_PSADBWirr },
  { "psadbw", X86::MMX_PSADBWirm },
  { "psadbw", X86::PSADBWrr },
  { "psadbw", X86::PSADBWrm },
  { "pshufb", X86::MMX_PSHUFBrr64 },
  { "pshufb", X86::MMX_PSHUFBrm64 },
  { "pshufb", X86::PSHUFBrr },
  { "pshufb", X86::PSHUFBrm },
  { "pshufd", X86::PSHUFDri },
  { "pshufd", X86::PSHUFDmi },
  { "pshufhw", X86::PSHUFHWri },
  { "pshufhw", X86::PSHUFHWmi },
  { "pshuflw", X86::PSHUFLWri },
  { "pshuflw", X86::PSHUFLWmi },
  { "pshufw", X86::MMX_PSHUFWri },
  { "pshufw", X86::MMX_PSHUFWmi },
  { "psignb", X86::MMX_PSIGNBrr64 },
  { "psignb", X86::MMX_PSIGNBrm64 },
  { "psignb", X86::PSIGNBrr },
  { "psignb", X86::PSIGNBrm },
  { "psignd", X86::MMX_PSIGNDrr64 },
  { "psignd", X86::MMX_PSIGNDrm64 },
  { "psignd", X86::PSIGNDrr },
  { "psignd", X86::PSIGNDrm },
  { "psignw", X86::MMX_PSIGNWrr64 },
  { "psignw", X86::MMX_PSIGNWrm64 },
  { "psignw", X86::PSIGNWrr },
  { "psignw", X86::PSIGNWrm },
  { "pslld", X86::MMX_PSLLDrr },
  { "pslld", X86::MMX_PSLLDri },
  { "pslld", X86::MMX_PSLLDrm },
  { "pslld", X86::PSLLDrr },
  { "pslld", X86::PSLLDri },
  { "pslld", X86::PSLLDrm },
  { "pslldq", X86::PSLLDQri },
  { "psllq", X86::MMX_PSLLQrr },
  { "psllq", X86::MMX_PSLLQri },
  { "psllq", X86::MMX_PSLLQrm },
  { "psllq", X86::PSLLQrr },
  { "psllq", X86::PSLLQri },
  { "psllq", X86::PSLLQrm },
  { "psllw", X86::MMX_PSLLWrr },
  { "psllw", X86::MMX_PSLLWri },
  { "psllw", X86::MMX_PSLLWrm },
  { "psllw", X86::PSLLWrr },
  { "psllw", X86::PSLLWri },
  { "psllw", X86::PSLLWrm },
  { "psrad", X86::MMX_PSRADrr },
  { "psrad", X86::MMX_PSRADri },
  { "psrad", X86::MMX_PSRADrm },
  { "psrad", X86::PSRADrr },
  { "psrad", X86::PSRADri },
  { "psrad", X86::PSRADrm },
  { "psraw", X86::MMX_PSRAWrr },
  { "psraw", X86::MMX_PSRAWri },
  { "psraw", X86::MMX_PSRAWrm },
  { "psraw", X86::PSRAWrr },
  { "psraw", X86::PSRAWri },
  { "psraw", X86::PSRAWrm },
  { "psrld", X86::MMX_PSRLDrr },
  { "psrld", X86::MMX_PSRLDri },
  { "psrld", X86::MMX_PSRLDrm },
  { "psrld", X86::PSRLDrr },
  { "psrld", X86::PSRLDri },
  { "psrld", X86::PSRLDrm },
  { "psrldq", X86::PSRLDQri },
  { "psrlq", X86::MMX_PSRLQrr },
  { "psrlq", X86::MMX_PSRLQri },
  { "psrlq", X86::MMX_PSRLQrm },
  { "psrlq", X86::PSRLQrr },
  { "psrlq", X86::PSRLQri },
  { "psrlq", X86::PSRLQrm },
  { "psrlw", X86::MMX_PSRLWrr },
  { "psrlw", X86::MMX_PSRLWri },
  { "psrlw", X86::MMX_PSRLWrm },
  { "psrlw", X86::PSRLWrr },
  { "psrlw", X86::PSRLWri },
  { "psrlw", X86::PSRLWrm },
  { "psubb", X86::MMX_PSUBBirr },
  { "psubb", X86::MMX_PSUBBirm },
  { "psubb", X86::PSUBBrr },
  { "psubb", X86::PSUBBrm },
  { "psubd", X86::MMX_PSUBDirr },
  { "psubd", X86::MMX_PSUBDirm },
  { "psubd", X86::PSUBDrr },
  { "psubd", X86::PSUBDrm },
  { "psubq", X86::MMX_PSUBQirr },
  { "psubq", X86::MMX_PSUBQirm },
  { "psubq", X86::PSUBQrr },
  { "psubq", X86::PSUBQrm },
  { "psubsb", X86::MMX_PSUBSBirr },
  { "psubsb", X86::MMX_PSUBSBirm },
  { "psubsb", X86::PSUBSBrr },
  { "psubsb", X86::PSUBSBrm },
  { "psubsw", X86::MMX_PSUBSWirr },
  { "psubsw", X86::MMX_PSUBSWirm },
  { "psubsw", X86::PSUBSWrr },
  { "psubsw", X86::PSUBSWrm },
  { "psubusb", X86::MMX_PSUBUSBirr },
  { "psubusb", X86::MMX_PSUBUSBirm },
  { "psubusb", X86::PSUBUSBrr },
  { "psubusb", X86::PSUBUSBrm },
  { "psubusw", X86::MMX_PSUBUSWirr },
  { "psubusw", X86::MMX_PSUBUSWirm },
  { "psubusw", X86::PSUBUSWrr },
  { "psubusw", X86::PSUBUSWrm },
  { "psubw", X86::MMX_PSUBWirr },
  { "psubw", X86::MMX_PSUBWirm },
  { "psubw", X86::PSUBWrr },
  { "psubw", X86::PSUBWrm },
  { "pswapd", X86::PSWAPDrr },
  { "pswapd", X86::PSWAPDrm },
  { "ptest", X86::PTESTrr },
  { "ptest", X86::PTESTrm },
  { "punpckhbw", X86::MMX_PUNPCKHBWirr },
  { "punpckhbw", X86::MMX_PUNPCKHBWirm },
  { "punpckhbw", X86::PUNPCKHBWrr },
  { "punpckhbw", X86::PUNPCKHBWrm },
  { "punpckhdq", X86::MMX_PUNPCKHDQirr },
  { "punpckhdq", X86::MMX_PUNPCKHDQirm },
  { "punpckhdq", X86::PUNPCKHDQrr },
  { "punpckhdq", X86::PUNPCKHDQrm },
  { "punpckhqdq", X86::PUNPCKHQDQrr },
  { "punpckhqdq", X86::PUNPCKHQDQrm },
  { "punpckhwd", X86::MMX_PUNPCKHWDirr },
  { "punpckhwd", X86::MMX_PUNPCKHWDirm },
  { "punpckhwd", X86::PUNPCKHWDrr },
  { "punpckhwd", X86::PUNPCKHWDrm },
  { "punpcklbw", X86::MMX_PUNPCKLBWirr },
  { "punpcklbw", X86::MMX_PUNPCKLBWirm },
  { "punpcklbw", X86::PUNPCKLBWrr },
  { "punpcklbw", X86::PUNPCKLBWrm },
  { "punpckldq", X86::MMX_PUNPCKLDQirr },
  { "punpckldq", X86::MMX_PUNPCKLDQirm },
  { "punpckldq", X86::PUNPCKLDQrr },
  { "punpckldq", X86::PUNPCKLDQrm },
  { "punpcklqdq", X86::PUNPCKLQDQrr },
  { "punpcklqdq", X86::PUNPCKLQDQrm },
  { "punpcklwd", X86::MMX_PUNPCKLWDirr },
  { "punpcklwd", X86::MMX_PUNPCKLWDirm },
  { "punpcklwd", X86::PUNPCKLWDrr },
  { "punpcklwd", X86::PUNPCKLWDrm },
  { "push", X86::PUSH16r },
  { "push", X86::PUSH16rmr },
  { "push", X86::PUSH32r },
  { "push", X86::PUSH32rmr },
  { "push", X86::PUSH64r },
  { "push", X86::PUSH64rmr },
  { "push", X86::PUSHCS16 },
  { "push", X86::PUSHCS32 },
  { "push", X86::PUSHDS16 },
  { "push", X86::PUSHDS32 },
  { "push", X86::PUSHSS16 },
  { "push", X86::PUSHSS32 },
  { "push", X86::PUSHES16 },
  { "push", X86::PUSHES32 },
  { "push", X86::PUSHFS32 },
  { "push", X86::PUSHFS64 },
  { "push", X86::PUSHFS16 },
  { "push", X86::PUSHGS32 },
  { "push", X86::PUSHGS64 },
  { "push", X86::PUSHGS16 },
  { "push", X86::PUSH64i8 },
  { "push", X86::PUSH16i8 },
  { "push", X86::PUSH32i8 },
  { "push", X86::PUSH64i32 },
  { "push", X86::PUSH64i16 },
  { "push", X86::PUSHi16 },
  { "push", X86::PUSHi32 },
  { "push", X86::PUSH16rmm },
  { "push", X86::PUSH32rmm },
  { "push", X86::PUSH64rmm },
  { "pushal", X86::PUSHA32 },
  { "pushaw", X86::PUSHA16 },
  { "pushf", X86::PUSHF16 },
  { "pushfd", X86::PUSHF32 },
  { "pushfq", X86::PUSHF64 },
  { "pxor", X86::MMX_PXORirr },
  { "pxor", X86::MMX_PXORirm },
  { "pxor", X86::PXORrr },
  { "pxor", X86::PXORrm },
  { "rcl", X86::RCL8r1 },
  { "rcl", X86::RCL16r1 },
  { "rcl", X86::RCL32r1 },
  { "rcl", X86::RCL64r1 },
  { "rcl", X86::RCL16m1 },
  { "rcl", X86::RCL32m1 },
  { "rcl", X86::RCL64m1 },
  { "rcl", X86::RCL8m1 },
  { "rcl", X86::RCL8rCL },
  { "rcl", X86::RCL8ri },
  { "rcl", X86::RCL16rCL },
  { "rcl", X86::RCL16ri },
  { "rcl", X86::RCL32rCL },
  { "rcl", X86::RCL32ri },
  { "rcl", X86::RCL64rCL },
  { "rcl", X86::RCL64ri },
  { "rcl", X86::RCL16mCL },
  { "rcl", X86::RCL16mi },
  { "rcl", X86::RCL32mCL },
  { "rcl", X86::RCL32mi },
  { "rcl", X86::RCL64mCL },
  { "rcl", X86::RCL64mi },
  { "rcl", X86::RCL8mCL },
  { "rcl", X86::RCL8mi },
  { "rcpps", X86::RCPPSr },
  { "rcpps", X86::RCPPSm },
  { "rcpss", X86::RCPSSr },
  { "rcpss", X86::RCPSSm },
  { "rcr", X86::RCR8r1 },
  { "rcr", X86::RCR16r1 },
  { "rcr", X86::RCR32r1 },
  { "rcr", X86::RCR64r1 },
  { "rcr", X86::RCR16m1 },
  { "rcr", X86::RCR32m1 },
  { "rcr", X86::RCR64m1 },
  { "rcr", X86::RCR8m1 },
  { "rcr", X86::RCR8rCL },
  { "rcr", X86::RCR8ri },
  { "rcr", X86::RCR16rCL },
  { "rcr", X86::RCR16ri },
  { "rcr", X86::RCR32rCL },
  { "rcr", X86::RCR32ri },
  { "rcr", X86::RCR64rCL },
  { "rcr", X86::RCR64ri },
  { "rcr", X86::RCR16mCL },
  { "rcr", X86::RCR16mi },
  { "rcr", X86::RCR32mCL },
  { "rcr", X86::RCR32mi },
  { "rcr", X86::RCR64mCL },
  { "rcr", X86::RCR64mi },
  { "rcr", X86::RCR8mCL },
  { "rcr", X86::RCR8mi },
  { "rdfsbase", X86::RDFSBASE },
  { "rdfsbase", X86::RDFSBASE64 },
  { "rdgsbase", X86::RDGSBASE },
  { "rdgsbase", X86::RDGSBASE64 },
  { "rdmsr", X86::RDMSR },
  { "rdpmc", X86::RDPMC },
  { "rdrand", X86::RDRAND16r },
  { "rdrand", X86::RDRAND32r },
  { "rdrand", X86::RDRAND64r },
  { "rdseed", X86::RDSEED16r },
  { "rdseed", X86::RDSEED32r },
  { "rdseed", X86::RDSEED64r },
  { "rdtsc", X86::RDTSC },
  { "rdtscp", X86::RDTSCP },
  { "rep", X86::REP_PREFIX },
  { "repne", X86::REPNE_PREFIX },
  { "ret", X86::RETL },
  { "ret", X86::RETQ },
  { "ret", X86::RETW },
  { "ret", X86::RETIL },
  { "ret", X86::RETIQ },
  { "ret", X86::RETIW },
  { "retf", X86::LRETL },
  { "retf", X86::LRETW },
  { "retf", X86::LRETIL },
  { "retf", X86::LRETIW },
  { "retfq", X86::LRETQ },
  { "retfq", X86::LRETIQ },
  { "rex64", X86::REX64_PREFIX },
  { "rol", X86::ROL8r1 },
  { "rol", X86::ROL16r1 },
  { "rol", X86::ROL32r1 },
  { "rol", X86::ROL64r1 },
  { "rol", X86::ROL16m1 },
  { "rol", X86::ROL32m1 },
  { "rol", X86::ROL64m1 },
  { "rol", X86::ROL8m1 },
  { "rol", X86::ROL8rCL },
  { "rol", X86::ROL8ri },
  { "rol", X86::ROL16rCL },
  { "rol", X86::ROL16ri },
  { "rol", X86::ROL32rCL },
  { "rol", X86::ROL32ri },
  { "rol", X86::ROL64rCL },
  { "rol", X86::ROL64ri },
  { "rol", X86::ROL16mCL },
  { "rol", X86::ROL16mi },
  { "rol", X86::ROL32mCL },
  { "rol", X86::ROL32mi },
  { "rol", X86::ROL64mCL },
  { "rol", X86::ROL64mi },
  { "rol", X86::ROL8mCL },
  { "rol", X86::ROL8mi },
  { "ror", X86::ROR8r1 },
  { "ror", X86::ROR16r1 },
  { "ror", X86::ROR32r1 },
  { "ror", X86::ROR64r1 },
  { "ror", X86::ROR16m1 },
  { "ror", X86::ROR32m1 },
  { "ror", X86::ROR64m1 },
  { "ror", X86::ROR8m1 },
  { "ror", X86::ROR8rCL },
  { "ror", X86::ROR8ri },
  { "ror", X86::ROR16rCL },
  { "ror", X86::ROR16ri },
  { "ror", X86::ROR32rCL },
  { "ror", X86::ROR32ri },
  { "ror", X86::ROR64rCL },
  { "ror", X86::ROR64ri },
  { "ror", X86::ROR16mCL },
  { "ror", X86::ROR16mi },
  { "ror", X86::ROR32mCL },
  { "ror", X86::ROR32mi },
  { "ror", X86::ROR64mCL },
  { "ror", X86::ROR64mi },
  { "ror", X86::ROR8mCL },
  { "ror", X86::ROR8mi },
  { "rorx", X86::RORX32ri },
  { "rorx", X86::RORX32mi },
  { "rorx", X86::RORX64ri },
  { "rorx", X86::RORX64mi },
  { "roundpd", X86::ROUNDPDr },
  { "roundpd", X86::ROUNDPDm },
  { "roundps", X86::ROUNDPSr },
  { "roundps", X86::ROUNDPSm },
  { "roundsd", X86::ROUNDSDr },
  { "roundsd", X86::ROUNDSDm },
  { "roundss", X86::ROUNDSSr },
  { "roundss", X86::ROUNDSSm },
  { "rsm", X86::RSM },
  { "rsqrtps", X86::RSQRTPSr },
  { "rsqrtps", X86::RSQRTPSm },
  { "rsqrtss", X86::RSQRTSSr },
  { "rsqrtss", X86::RSQRTSSm },
  { "sahf", X86::SAHF },
  { "sar", X86::SAR8r1 },
  { "sar", X86::SAR16r1 },
  { "sar", X86::SAR32r1 },
  { "sar", X86::SAR64r1 },
  { "sar", X86::SAR16m1 },
  { "sar", X86::SAR32m1 },
  { "sar", X86::SAR64m1 },
  { "sar", X86::SAR8m1 },
  { "sar", X86::SAR8rCL },
  { "sar", X86::SAR8ri },
  { "sar", X86::SAR16rCL },
  { "sar", X86::SAR16ri },
  { "sar", X86::SAR32rCL },
  { "sar", X86::SAR32ri },
  { "sar", X86::SAR64rCL },
  { "sar", X86::SAR64ri },
  { "sar", X86::SAR16mCL },
  { "sar", X86::SAR16mi },
  { "sar", X86::SAR32mCL },
  { "sar", X86::SAR32mi },
  { "sar", X86::SAR64mCL },
  { "sar", X86::SAR64mi },
  { "sar", X86::SAR8mCL },
  { "sar", X86::SAR8mi },
  { "sarx", X86::SARX32rr },
  { "sarx", X86::SARX32rm },
  { "sarx", X86::SARX64rr },
  { "sarx", X86::SARX64rm },
  { "sbb", X86::SBB8i8 },
  { "sbb", X86::SBB8rr },
  { "sbb", X86::SBB8ri },
  { "sbb", X86::SBB8rm },
  { "sbb", X86::SBB16i16 },
  { "sbb", X86::SBB16rr },
  { "sbb", X86::SBB16ri8 },
  { "sbb", X86::SBB16ri },
  { "sbb", X86::SBB16rm },
  { "sbb", X86::SBB32i32 },
  { "sbb", X86::SBB32rr },
  { "sbb", X86::SBB32ri8 },
  { "sbb", X86::SBB32ri },
  { "sbb", X86::SBB32rm },
  { "sbb", X86::SBB64i32 },
  { "sbb", X86::SBB64rr },
  { "sbb", X86::SBB64ri8 },
  { "sbb", X86::SBB64ri32 },
  { "sbb", X86::SBB64rm },
  { "sbb", X86::SBB16mr },
  { "sbb", X86::SBB16mi8 },
  { "sbb", X86::SBB16mi },
  { "sbb", X86::SBB32mr },
  { "sbb", X86::SBB32mi8 },
  { "sbb", X86::SBB32mi },
  { "sbb", X86::SBB64mr },
  { "sbb", X86::SBB64mi8 },
  { "sbb", X86::SBB64mi32 },
  { "sbb", X86::SBB8mr },
  { "sbb", X86::SBB8mi },
  { "scas", X86::SCASB },
  { "scas", X86::SCASW },
  { "scas", X86::SCASL },
  { "scas", X86::SCASQ },
  { "scasb", X86::SCASB },
  { "scasb", X86::SCASB },
  { "scasd", X86::SCASL },
  { "scasd", X86::SCASL },
  { "scasq", X86::SCASQ },
  { "scasq", X86::SCASQ },
  { "scasw", X86::SCASW },
  { "scasw", X86::SCASW },
  { "seta", X86::SETAr },
  { "seta", X86::SETAm },
  { "setae", X86::SETAEr },
  { "setae", X86::SETAEm },
  { "setb", X86::SETBr },
  { "setb", X86::SETBm },
  { "setbe", X86::SETBEr },
  { "setbe", X86::SETBEm },
  { "sete", X86::SETEr },
  { "sete", X86::SETEm },
  { "setg", X86::SETGr },
  { "setg", X86::SETGm },
  { "setge", X86::SETGEr },
  { "setge", X86::SETGEm },
  { "setl", X86::SETLr },
  { "setl", X86::SETLm },
  { "setle", X86::SETLEr },
  { "setle", X86::SETLEm },
  { "setne", X86::SETNEr },
  { "setne", X86::SETNEm },
  { "setno", X86::SETNOr },
  { "setno", X86::SETNOm },
  { "setnp", X86::SETNPr },
  { "setnp", X86::SETNPm },
  { "setns", X86::SETNSr },
  { "setns", X86::SETNSm },
  { "seto", X86::SETOr },
  { "seto", X86::SETOm },
  { "setp", X86::SETPr },
  { "setp", X86::SETPm },
  { "sets", X86::SETSr },
  { "sets", X86::SETSm },
  { "sfence", X86::SFENCE },
  { "sgdt", X86::SGDT16m },
  { "sgdt", X86::SGDT32m },
  { "sgdt", X86::SGDT64m },
  { "sha1msg1", X86::SHA1MSG1rr },
  { "sha1msg1", X86::SHA1MSG1rm },
  { "sha1msg2", X86::SHA1MSG2rr },
  { "sha1msg2", X86::SHA1MSG2rm },
  { "sha1nexte", X86::SHA1NEXTErr },
  { "sha1nexte", X86::SHA1NEXTErm },
  { "sha1rnds4", X86::SHA1RNDS4rri },
  { "sha1rnds4", X86::SHA1RNDS4rmi },
  { "sha256msg1", X86::SHA256MSG1rr },
  { "sha256msg1", X86::SHA256MSG1rm },
  { "sha256msg2", X86::SHA256MSG2rr },
  { "sha256msg2", X86::SHA256MSG2rm },
  { "sha256rnds2", X86::SHA256RNDS2rr },
  { "sha256rnds2", X86::SHA256RNDS2rm },
  { "sha256rnds2", X86::SHA256RNDS2rr },
  { "sha256rnds2", X86::SHA256RNDS2rm },
  { "shl", X86::SHL8r1 },
  { "shl", X86::SHL16r1 },
  { "shl", X86::SHL32r1 },
  { "shl", X86::SHL64r1 },
  { "shl", X86::SHL16m1 },
  { "shl", X86::SHL32m1 },
  { "shl", X86::SHL64m1 },
  { "shl", X86::SHL8m1 },
  { "shl", X86::SHL8rCL },
  { "shl", X86::SHL8ri },
  { "shl", X86::SHL16rCL },
  { "shl", X86::SHL16ri },
  { "shl", X86::SHL32rCL },
  { "shl", X86::SHL32ri },
  { "shl", X86::SHL64rCL },
  { "shl", X86::SHL64ri },
  { "shl", X86::SHL16mCL },
  { "shl", X86::SHL16mi },
  { "shl", X86::SHL32mCL },
  { "shl", X86::SHL32mi },
  { "shl", X86::SHL64mCL },
  { "shl", X86::SHL64mi },
  { "shl", X86::SHL8mCL },
  { "shl", X86::SHL8mi },
  { "shld", X86::SHLD16rrCL },
  { "shld", X86::SHLD32rrCL },
  { "shld", X86::SHLD64rrCL },
  { "shld", X86::SHLD16mrCL },
  { "shld", X86::SHLD32mrCL },
  { "shld", X86::SHLD64mrCL },
  { "shld", X86::SHLD16rrCL },
  { "shld", X86::SHLD16rri8 },
  { "shld", X86::SHLD32rrCL },
  { "shld", X86::SHLD32rri8 },
  { "shld", X86::SHLD64rrCL },
  { "shld", X86::SHLD64rri8 },
  { "shld", X86::SHLD16mrCL },
  { "shld", X86::SHLD16mri8 },
  { "shld", X86::SHLD32mrCL },
  { "shld", X86::SHLD32mri8 },
  { "shld", X86::SHLD64mrCL },
  { "shld", X86::SHLD64mri8 },
  { "shlx", X86::SHLX32rr },
  { "shlx", X86::SHLX32rm },
  { "shlx", X86::SHLX64rr },
  { "shlx", X86::SHLX64rm },
  { "shr", X86::SHR8r1 },
  { "shr", X86::SHR16r1 },
  { "shr", X86::SHR32r1 },
  { "shr", X86::SHR64r1 },
  { "shr", X86::SHR16m1 },
  { "shr", X86::SHR32m1 },
  { "shr", X86::SHR64m1 },
  { "shr", X86::SHR8m1 },
  { "shr", X86::SHR8rCL },
  { "shr", X86::SHR8ri },
  { "shr", X86::SHR16rCL },
  { "shr", X86::SHR16ri },
  { "shr", X86::SHR32rCL },
  { "shr", X86::SHR32ri },
  { "shr", X86::SHR64rCL },
  { "shr", X86::SHR64ri },
  { "shr", X86::SHR16mCL },
  { "shr", X86::SHR16mi },
  { "shr", X86::SHR32mCL },
  { "shr", X86::SHR32mi },
  { "shr", X86::SHR64mCL },
  { "shr", X86::SHR64mi },
  { "shr", X86::SHR8mCL },
  { "shr", X86::SHR8mi },
  { "shrd", X86::SHRD16rrCL },
  { "shrd", X86::SHRD32rrCL },
  { "shrd", X86::SHRD64rrCL },
  { "shrd", X86::SHRD16mrCL },
  { "shrd", X86::SHRD32mrCL },
  { "shrd", X86::SHRD64mrCL },
  { "shrd", X86::SHRD16rrCL },
  { "shrd", X86::SHRD16rri8 },
  { "shrd", X86::SHRD32rrCL },
  { "shrd", X86::SHRD32rri8 },
  { "shrd", X86::SHRD64rrCL },
  { "shrd", X86::SHRD64rri8 },
  { "shrd", X86::SHRD16mrCL },
  { "shrd", X86::SHRD16mri8 },
  { "shrd", X86::SHRD32mrCL },
  { "shrd", X86::SHRD32mri8 },
  { "shrd", X86::SHRD64mrCL },
  { "shrd", X86::SHRD64mri8 },
  { "shrx", X86::SHRX32rr },
  { "shrx", X86::SHRX32rm },
  { "shrx", X86::SHRX64rr },
  { "shrx", X86::SHRX64rm },
  { "shufpd", X86::SHUFPDrri },
  { "shufpd", X86::SHUFPDrmi },
  { "shufps", X86::SHUFPSrri },
  { "shufps", X86::SHUFPSrmi },
  { "sidt", X86::SIDT16m },
  { "sidt", X86::SIDT32m },
  { "sidt", X86::SIDT64m },
  { "skinit", X86::SKINIT },
  { "sldt", X86::SLDT16r },
  { "sldt", X86::SLDT32r },
  { "sldt", X86::SLDT64r },
  { "sldt", X86::SLDT16m },
  { "sldt", X86::SLDT64m },
  { "sldt", X86::SLDT16m },
  { "smsw", X86::SMSW16r },
  { "smsw", X86::SMSW32r },
  { "smsw", X86::SMSW64r },
  { "smsw", X86::SMSW16m },
  { "sqrtpd", X86::SQRTPDr },
  { "sqrtpd", X86::SQRTPDm },
  { "sqrtps", X86::SQRTPSr },
  { "sqrtps", X86::SQRTPSm },
  { "sqrtsd", X86::SQRTSDr },
  { "sqrtsd", X86::SQRTSDm },
  { "sqrtss", X86::SQRTSSr },
  { "sqrtss", X86::SQRTSSm },
  { "ss", X86::SS_PREFIX },
  { "stac", X86::STAC },
  { "stc", X86::STC },
  { "std", X86::STD },
  { "stgi", X86::STGI },
  { "sti", X86::STI },
  { "stmxcsr", X86::STMXCSR },
  { "stos", X86::STOSW },
  { "stos", X86::STOSL },
  { "stos", X86::STOSQ },
  { "stos", X86::STOSB },
  { "stosb", X86::STOSB },
  { "stosb", X86::STOSB },
  { "stosd", X86::STOSL },
  { "stosd", X86::STOSL },
  { "stosq", X86::STOSQ },
  { "stosq", X86::STOSQ },
  { "stosw", X86::STOSW },
  { "stosw", X86::STOSW },
  { "str", X86::STR16r },
  { "str", X86::STR32r },
  { "str", X86::STR64r },
  { "str", X86::STRm },
  { "sub", X86::SUB8i8 },
  { "sub", X86::SUB8rr },
  { "sub", X86::SUB8ri },
  { "sub", X86::SUB8rm },
  { "sub", X86::SUB16i16 },
  { "sub", X86::SUB16rr },
  { "sub", X86::SUB16ri8 },
  { "sub", X86::SUB16ri },
  { "sub", X86::SUB16rm },
  { "sub", X86::SUB32i32 },
  { "sub", X86::SUB32rr },
  { "sub", X86::SUB32ri8 },
  { "sub", X86::SUB32ri },
  { "sub", X86::SUB32rm },
  { "sub", X86::SUB64i32 },
  { "sub", X86::SUB64rr },
  { "sub", X86::SUB64ri8 },
  { "sub", X86::SUB64ri32 },
  { "sub", X86::SUB64rm },
  { "sub", X86::SUB16mr },
  { "sub", X86::SUB16mi8 },
  { "sub", X86::SUB16mi },
  { "sub", X86::SUB32mr },
  { "sub", X86::SUB32mi8 },
  { "sub", X86::SUB32mi },
  { "sub", X86::SUB64mr },
  { "sub", X86::SUB64mi8 },
  { "sub", X86::SUB64mi32 },
  { "sub", X86::SUB8mr },
  { "sub", X86::SUB8mi },
  { "subpd", X86::SUBPDrr },
  { "subpd", X86::SUBPDrm },
  { "subps", X86::SUBPSrr },
  { "subps", X86::SUBPSrm },
  { "subsd", X86::SUBSDrr },
  { "subsd", X86::SUBSDrm },
  { "subss", X86::SUBSSrr },
  { "subss", X86::SUBSSrm },
  { "swapgs", X86::SWAPGS },
  { "syscall", X86::SYSCALL },
  { "sysenter", X86::SYSENTER },
  { "sysexit", X86::SYSEXIT64 },
  { "sysexit", X86::SYSEXIT },
  { "sysret", X86::SYSRET64 },
  { "sysret", X86::SYSRET },
  { "t1mskc", X86::T1MSKC32rr },
  { "t1mskc", X86::T1MSKC32rm },
  { "t1mskc", X86::T1MSKC64rr },
  { "t1mskc", X86::T1MSKC64rm },
  { "test", X86::TEST8i8 },
  { "test", X86::TEST8rr },
  { "test", X86::TEST8ri },
  { "test", X86::TEST8rm },
  { "test", X86::TEST16i16 },
  { "test", X86::TEST16rr },
  { "test", X86::TEST16ri },
  { "test", X86::TEST16rm },
  { "test", X86::TEST32i32 },
  { "test", X86::TEST32rr },
  { "test", X86::TEST32ri },
  { "test", X86::TEST32rm },
  { "test", X86::TEST64i32 },
  { "test", X86::TEST64rr },
  { "test", X86::TEST64ri32 },
  { "test", X86::TEST64rm },
  { "test", X86::TEST16rm },
  { "test", X86::TEST16mi },
  { "test", X86::TEST32rm },
  { "test", X86::TEST32mi },
  { "test", X86::TEST64rm },
  { "test", X86::TEST64mi32 },
  { "test", X86::TEST8rm },
  { "test", X86::TEST8mi },
  { "tzcnt", X86::TZCNT16rr },
  { "tzcnt", X86::TZCNT16rm },
  { "tzcnt", X86::TZCNT32rr },
  { "tzcnt", X86::TZCNT32rm },
  { "tzcnt", X86::TZCNT64rr },
  { "tzcnt", X86::TZCNT64rm },
  { "tzmsk", X86::TZMSK32rr },
  { "tzmsk", X86::TZMSK32rm },
  { "tzmsk", X86::TZMSK64rr },
  { "tzmsk", X86::TZMSK64rm },
  { "ucomisd", X86::UCOMISDrr },
  { "ucomisd", X86::UCOMISDrm },
  { "ucomiss", X86::UCOMISSrr },
  { "ucomiss", X86::UCOMISSrm },
  { "ud2", X86::TRAP },
  { "ud2b", X86::UD2B },
  { "unpckhpd", X86::UNPCKHPDrr },
  { "unpckhpd", X86::UNPCKHPDrm },
  { "unpckhps", X86::UNPCKHPSrr },
  { "unpckhps", X86::UNPCKHPSrm },
  { "unpcklpd", X86::UNPCKLPDrr },
  { "unpcklpd", X86::UNPCKLPDrm },
  { "unpcklps", X86::UNPCKLPSrr },
  { "unpcklps", X86::UNPCKLPSrm },
  { "vaddpd", X86::VADDPDrr },
  { "vaddpd", X86::VADDPDrm },
  { "vaddpd", X86::VADDPDYrr },
  { "vaddpd", X86::VADDPDYrm },
  { "vaddpd", X86::VADDPDZrr },
  { "vaddpd", X86::VADDPDZrm },
  { "vaddpd", X86::VADDPDZrmb },
  { "vaddpd", X86::VADDPDZrrk },
  { "vaddpd", X86::VADDPDZrmk },
  { "vaddpd", X86::VADDPDZrrkz },
  { "vaddpd", X86::VADDPDZrmkz },
  { "vaddpd", X86::VADDPDZrmbk },
  { "vaddpd", X86::VADDPDZrmbkz },
  { "vaddps", X86::VADDPSrr },
  { "vaddps", X86::VADDPSrm },
  { "vaddps", X86::VADDPSYrr },
  { "vaddps", X86::VADDPSYrm },
  { "vaddps", X86::VADDPSZrr },
  { "vaddps", X86::VADDPSZrm },
  { "vaddps", X86::VADDPSZrmb },
  { "vaddps", X86::VADDPSZrrk },
  { "vaddps", X86::VADDPSZrmk },
  { "vaddps", X86::VADDPSZrrkz },
  { "vaddps", X86::VADDPSZrmkz },
  { "vaddps", X86::VADDPSZrmbk },
  { "vaddps", X86::VADDPSZrmbkz },
  { "vaddsd", X86::VADDSDrr },
  { "vaddsd", X86::VADDSDrm },
  { "vaddsd", X86::VADDSDZrr },
  { "vaddsd", X86::VADDSDZrm },
  { "vaddss", X86::VADDSSrr },
  { "vaddss", X86::VADDSSrm },
  { "vaddss", X86::VADDSSZrr },
  { "vaddss", X86::VADDSSZrm },
  { "vaddsubpd", X86::VADDSUBPDrr },
  { "vaddsubpd", X86::VADDSUBPDrm },
  { "vaddsubpd", X86::VADDSUBPDYrr },
  { "vaddsubpd", X86::VADDSUBPDYrm },
  { "vaddsubps", X86::VADDSUBPSrr },
  { "vaddsubps", X86::VADDSUBPSrm },
  { "vaddsubps", X86::VADDSUBPSYrr },
  { "vaddsubps", X86::VADDSUBPSYrm },
  { "vaesdec", X86::VAESDECrr },
  { "vaesdec", X86::VAESDECrm },
  { "vaesdeclast", X86::VAESDECLASTrr },
  { "vaesdeclast", X86::VAESDECLASTrm },
  { "vaesenc", X86::VAESENCrr },
  { "vaesenc", X86::VAESENCrm },
  { "vaesenclast", X86::VAESENCLASTrr },
  { "vaesenclast", X86::VAESENCLASTrm },
  { "vaesimc", X86::VAESIMCrr },
  { "vaesimc", X86::VAESIMCrm },
  { "vaeskeygenassist", X86::VAESKEYGENASSIST128rr },
  { "vaeskeygenassist", X86::VAESKEYGENASSIST128rm },
  { "valignd", X86::VALIGNDrri },
  { "valignd", X86::VALIGNDrmi },
  { "valignd", X86::VALIGNDrrik },
  { "valignd", X86::VALIGNDrrikz },
  { "valignq", X86::VALIGNQrri },
  { "valignq", X86::VALIGNQrmi },
  { "valignq", X86::VALIGNQrrik },
  { "valignq", X86::VALIGNQrrikz },
  { "vandnpd", X86::VANDNPDrr },
  { "vandnpd", X86::VANDNPDrm },
  { "vandnpd", X86::VANDNPDYrr },
  { "vandnpd", X86::VANDNPDYrm },
  { "vandnps", X86::VANDNPSrr },
  { "vandnps", X86::VANDNPSrm },
  { "vandnps", X86::VANDNPSYrr },
  { "vandnps", X86::VANDNPSYrm },
  { "vandpd", X86::VANDPDrr },
  { "vandpd", X86::VANDPDrm },
  { "vandpd", X86::VANDPDYrr },
  { "vandpd", X86::VANDPDYrm },
  { "vandps", X86::VANDPSrr },
  { "vandps", X86::VANDPSrm },
  { "vandps", X86::VANDPSYrr },
  { "vandps", X86::VANDPSYrm },
  { "vblendmpd", X86::VBLENDMPDZrr },
  { "vblendmpd", X86::VBLENDMPDZrm },
  { "vblendmps", X86::VBLENDMPSZrr },
  { "vblendmps", X86::VBLENDMPSZrm },
  { "vblendpd", X86::VBLENDPDrri },
  { "vblendpd", X86::VBLENDPDrmi },
  { "vblendpd", X86::VBLENDPDYrri },
  { "vblendpd", X86::VBLENDPDYrmi },
  { "vblendps", X86::VBLENDPSrri },
  { "vblendps", X86::VBLENDPSrmi },
  { "vblendps", X86::VBLENDPSYrri },
  { "vblendps", X86::VBLENDPSYrmi },
  { "vblendvpd", X86::VBLENDVPDrr },
  { "vblendvpd", X86::VBLENDVPDrm },
  { "vblendvpd", X86::VBLENDVPDYrr },
  { "vblendvpd", X86::VBLENDVPDYrm },
  { "vblendvps", X86::VBLENDVPSrr },
  { "vblendvps", X86::VBLENDVPSrm },
  { "vblendvps", X86::VBLENDVPSYrr },
  { "vblendvps", X86::VBLENDVPSYrm },
  { "vbroadcastf128", X86::VBROADCASTF128 },
  { "vbroadcasti128", X86::VBROADCASTI128 },
  { "vbroadcasti32x4", X86::VBROADCASTI32X4rm },
  { "vbroadcasti32x4", X86::VBROADCASTI32X4krm },
  { "vbroadcasti64x4", X86::VBROADCASTI64X4rm },
  { "vbroadcasti64x4", X86::VBROADCASTI64X4krm },
  { "vbroadcastsd", X86::VBROADCASTSDYrr },
  { "vbroadcastsd", X86::VBROADCASTSDYrm },
  { "vbroadcastsd", X86::VBROADCASTSDZrr },
  { "vbroadcastsd", X86::VBROADCASTSDZrm },
  { "vbroadcastss", X86::VBROADCASTSSrr },
  { "vbroadcastss", X86::VBROADCASTSSrm },
  { "vbroadcastss", X86::VBROADCASTSSYrr },
  { "vbroadcastss", X86::VBROADCASTSSYrm },
  { "vbroadcastss", X86::VBROADCASTSSZrr },
  { "vbroadcastss", X86::VBROADCASTSSZrm },
  { "vcmp", X86::VCMPPDrri },
  { "vcmp", X86::VCMPPDrmi },
  { "vcmp", X86::VCMPPDYrri },
  { "vcmp", X86::VCMPPDYrmi },
  { "vcmp", X86::VCMPPDZrri },
  { "vcmp", X86::VCMPPSrri },
  { "vcmp", X86::VCMPPSrmi },
  { "vcmp", X86::VCMPPSYrri },
  { "vcmp", X86::VCMPPSYrmi },
  { "vcmp", X86::VCMPPSZrri },
  { "vcmp", X86::VCMPSDrr },
  { "vcmp", X86::VCMPSDrm },
  { "vcmp", X86::VCMPSDZrr },
  { "vcmp", X86::VCMPSDZrm },
  { "vcmp", X86::VCMPSSrr },
  { "vcmp", X86::VCMPSSrm },
  { "vcmp", X86::VCMPSSZrr },
  { "vcmp", X86::VCMPSSZrm },
  { "vcmp", X86::VCMPPDZrrib },
  { "vcmp", X86::VCMPPDZrmi },
  { "vcmp", X86::VCMPPSZrrib },
  { "vcmp", X86::VCMPPSZrmi },
  { "vcmppd", X86::VCMPPDrri_alt },
  { "vcmppd", X86::VCMPPDrmi_alt },
  { "vcmppd", X86::VCMPPDYrri_alt },
  { "vcmppd", X86::VCMPPDYrmi_alt },
  { "vcmppd", X86::VCMPPDZrri_alt },
  { "vcmppd", X86::VCMPPDZrmi_alt },
  { "vcmpps", X86::VCMPPSrri_alt },
  { "vcmpps", X86::VCMPPSrmi_alt },
  { "vcmpps", X86::VCMPPSYrri_alt },
  { "vcmpps", X86::VCMPPSYrmi_alt },
  { "vcmpps", X86::VCMPPSZrri_alt },
  { "vcmpps", X86::VCMPPSZrmi_alt },
  { "vcmpsd", X86::VCMPSDrr_alt },
  { "vcmpsd", X86::VCMPSDrm_alt },
  { "vcmpsd", X86::VCMPSDZrri_alt },
  { "vcmpsd", X86::VCMPSDZrmi_alt },
  { "vcmpss", X86::VCMPSSrr_alt },
  { "vcmpss", X86::VCMPSSrm_alt },
  { "vcmpss", X86::VCMPSSZrri_alt },
  { "vcmpss", X86::VCMPSSZrmi_alt },
  { "vcomisd", X86::VCOMISDrr },
  { "vcomisd", X86::VCOMISDrm },
  { "vcomisd", X86::VCOMISDZrr },
  { "vcomisd", X86::VCOMISDZrm },
  { "vcomiss", X86::VCOMISSrr },
  { "vcomiss", X86::VCOMISSrm },
  { "vcomiss", X86::VCOMISSZrr },
  { "vcomiss", X86::VCOMISSZrm },
  { "vcvtdq2pd", X86::VCVTDQ2PDrr },
  { "vcvtdq2pd", X86::VCVTDQ2PDrm },
  { "vcvtdq2pd", X86::VCVTDQ2PDYrr },
  { "vcvtdq2pd", X86::VCVTDQ2PDYrm },
  { "vcvtdq2pd", X86::VCVTDQ2PDZrr },
  { "vcvtdq2pd", X86::VCVTDQ2PDZrm },
  { "vcvtdq2ps", X86::VCVTDQ2PSrr },
  { "vcvtdq2ps", X86::VCVTDQ2PSrm },
  { "vcvtdq2ps", X86::VCVTDQ2PSYrr },
  { "vcvtdq2ps", X86::VCVTDQ2PSYrm },
  { "vcvtdq2ps", X86::VCVTDQ2PSZrr },
  { "vcvtdq2ps", X86::VCVTDQ2PSZrm },
  { "vcvtdq2ps", X86::VCVTDQ2PSZrrb },
  { "vcvtpd2dq", X86::VCVTPD2DQrr },
  { "vcvtpd2dq", X86::VCVTPD2DQYrr },
  { "vcvtpd2dq", X86::VCVTPD2DQYrr },
  { "vcvtpd2dq", X86::VCVTPD2DQYrm },
  { "vcvtpd2dq", X86::VCVTPD2DQZrr },
  { "vcvtpd2dq", X86::VCVTPD2DQZrm },
  { "vcvtpd2dq", X86::VCVTPD2DQZrrb },
  { "vcvtpd2dqx", X86::VCVTPD2DQrr },
  { "vcvtpd2dqx", X86::VCVTPD2DQXrm },
  { "vcvtpd2ps", X86::VCVTPD2PSrr },
  { "vcvtpd2ps", X86::VCVTPD2PSYrr },
  { "vcvtpd2ps", X86::VCVTPD2PSYrr },
  { "vcvtpd2ps", X86::VCVTPD2PSYrm },
  { "vcvtpd2ps", X86::VCVTPD2PSZrr },
  { "vcvtpd2ps", X86::VCVTPD2PSZrm },
  { "vcvtpd2ps", X86::VCVTPD2PSZrrb },
  { "vcvtpd2psx", X86::VCVTPD2PSrr },
  { "vcvtpd2psx", X86::VCVTPD2PSXrm },
  { "vcvtpd2udq", X86::VCVTPD2UDQZrr },
  { "vcvtpd2udq", X86::VCVTPD2UDQZrm },
  { "vcvtpd2udq", X86::VCVTPD2UDQZrrb },
  { "vcvtph2ps", X86::VCVTPH2PSrr },
  { "vcvtph2ps", X86::VCVTPH2PSrm },
  { "vcvtph2ps", X86::VCVTPH2PSYrr },
  { "vcvtph2ps", X86::VCVTPH2PSYrm },
  { "vcvtph2ps", X86::VCVTPH2PSZrr },
  { "vcvtph2ps", X86::VCVTPH2PSZrm },
  { "vcvtps2dq", X86::VCVTPS2DQrr },
  { "vcvtps2dq", X86::VCVTPS2DQrm },
  { "vcvtps2dq", X86::VCVTPS2DQYrr },
  { "vcvtps2dq", X86::VCVTPS2DQYrm },
  { "vcvtps2dq", X86::VCVTPS2DQZrr },
  { "vcvtps2dq", X86::VCVTPS2DQZrm },
  { "vcvtps2dq", X86::VCVTPS2DQZrrb },
  { "vcvtps2pd", X86::VCVTPS2PDrr },
  { "vcvtps2pd", X86::VCVTPS2PDrm },
  { "vcvtps2pd", X86::VCVTPS2PDYrr },
  { "vcvtps2pd", X86::VCVTPS2PDYrm },
  { "vcvtps2pd", X86::VCVTPS2PDZrr },
  { "vcvtps2pd", X86::VCVTPS2PDZrm },
  { "vcvtps2ph", X86::VCVTPS2PHrr },
  { "vcvtps2ph", X86::VCVTPS2PHYrr },
  { "vcvtps2ph", X86::VCVTPS2PHZrr },
  { "vcvtps2ph", X86::VCVTPS2PHYmr },
  { "vcvtps2ph", X86::VCVTPS2PHZmr },
  { "vcvtps2ph", X86::VCVTPS2PHmr },
  { "vcvtps2udq", X86::VCVTPS2UDQZrr },
  { "vcvtps2udq", X86::VCVTPS2UDQZrm },
  { "vcvtps2udq", X86::VCVTPS2UDQZrrb },
  { "vcvtsd2si", X86::VCVTSD2SIrr },
  { "vcvtsd2si", X86::VCVTSD2SIrr },
  { "vcvtsd2si", X86::VCVTSD2SIZrr },
  { "vcvtsd2si", X86::VCVTSD2SIZrm },
  { "vcvtsd2si", X86::VCVTSD2SIrm },
  { "vcvtsd2si", X86::VCVTSD2SIrm },
  { "vcvtsd2si", X86::VCVTSD2SI64rr },
  { "vcvtsd2si", X86::VCVTSD2SI64rr },
  { "vcvtsd2si", X86::VCVTSD2SI64Zrr },
  { "vcvtsd2si", X86::VCVTSD2SI64Zrm },
  { "vcvtsd2si", X86::VCVTSD2SI64rm },
  { "vcvtsd2si", X86::VCVTSD2SI64rm },
  { "vcvtsd2ss", X86::VCVTSD2SSrr },
  { "vcvtsd2ss", X86::VCVTSD2SSrm },
  { "vcvtsd2ss", X86::VCVTSD2SSZrr },
  { "vcvtsd2ss", X86::VCVTSD2SSZrm },
  { "vcvtsd2usi", X86::VCVTSD2USIZrr },
  { "vcvtsd2usi", X86::VCVTSD2USIZrm },
  { "vcvtsd2usi", X86::VCVTSD2USI64Zrr },
  { "vcvtsd2usi", X86::VCVTSD2USI64Zrm },
  { "vcvtsi2sd", X86::VCVTSI2SDrr },
  { "vcvtsi2sd", X86::VCVTSI2SD64rr },
  { "vcvtsi2sd", X86::VCVTSI2SDrm },
  { "vcvtsi2sd", X86::VCVTSI2SDrm },
  { "vcvtsi2sd", X86::VCVTSI2SD64rm },
  { "vcvtsi2sd", X86::VCVTSI2SDZrr },
  { "vcvtsi2sd", X86::VCVTSI642SDZrr },
  { "vcvtsi2sd", X86::VCVTSI2SDZrm },
  { "vcvtsi2sd", X86::VCVTSI642SDZrm },
  { "vcvtsi2ss", X86::VCVTSI2SSrr },
  { "vcvtsi2ss", X86::VCVTSI2SS64rr },
  { "vcvtsi2ss", X86::VCVTSI2SSrm },
  { "vcvtsi2ss", X86::VCVTSI2SSrm },
  { "vcvtsi2ss", X86::VCVTSI2SS64rm },
  { "vcvtsi2ss", X86::VCVTSI2SSZrr },
  { "vcvtsi2ss", X86::VCVTSI642SSZrr },
  { "vcvtsi2ss", X86::VCVTSI2SSZrm },
  { "vcvtsi2ss", X86::VCVTSI642SSZrm },
  { "vcvtss2sd", X86::VCVTSS2SDrr },
  { "vcvtss2sd", X86::VCVTSS2SDrm },
  { "vcvtss2sd", X86::VCVTSS2SDZrr },
  { "vcvtss2sd", X86::VCVTSS2SDZrm },
  { "vcvtss2si", X86::VCVTSS2SIrr },
  { "vcvtss2si", X86::VCVTSS2SIrr },
  { "vcvtss2si", X86::VCVTSS2SIZrr },
  { "vcvtss2si", X86::VCVTSS2SIZrm },
  { "vcvtss2si", X86::VCVTSS2SIrm },
  { "vcvtss2si", X86::VCVTSS2SIrm },
  { "vcvtss2si", X86::VCVTSS2SI64rr },
  { "vcvtss2si", X86::VCVTSS2SI64rr },
  { "vcvtss2si", X86::VCVTSS2SI64Zrr },
  { "vcvtss2si", X86::VCVTSS2SI64Zrm },
  { "vcvtss2si", X86::VCVTSS2SI64rm },
  { "vcvtss2si", X86::VCVTSS2SI64rm },
  { "vcvtss2usi", X86::VCVTSS2USIZrr },
  { "vcvtss2usi", X86::VCVTSS2USIZrm },
  { "vcvtss2usi", X86::VCVTSS2USI64Zrr },
  { "vcvtss2usi", X86::VCVTSS2USI64Zrm },
  { "vcvttpd2dq", X86::VCVTTPD2DQrr },
  { "vcvttpd2dq", X86::VCVTTPD2DQYrr },
  { "vcvttpd2dq", X86::VCVTTPD2DQYrr },
  { "vcvttpd2dq", X86::VCVTTPD2DQYrm },
  { "vcvttpd2dq", X86::VCVTTPD2DQZrr },
  { "vcvttpd2dq", X86::VCVTTPD2DQZrm },
  { "vcvttpd2dqx", X86::VCVTTPD2DQrr },
  { "vcvttpd2dqx", X86::VCVTTPD2DQXrm },
  { "vcvttpd2udq", X86::VCVTTPD2UDQZrr },
  { "vcvttpd2udq", X86::VCVTTPD2UDQZrm },
  { "vcvttps2dq", X86::VCVTTPS2DQrr },
  { "vcvttps2dq", X86::VCVTTPS2DQrm },
  { "vcvttps2dq", X86::VCVTTPS2DQYrr },
  { "vcvttps2dq", X86::VCVTTPS2DQYrm },
  { "vcvttps2dq", X86::VCVTTPS2DQZrr },
  { "vcvttps2dq", X86::VCVTTPS2DQZrm },
  { "vcvttps2udq", X86::VCVTTPS2UDQZrr },
  { "vcvttps2udq", X86::VCVTTPS2UDQZrm },
  { "vcvttsd2si", X86::VCVTTSD2SIrr },
  { "vcvttsd2si", X86::VCVTTSD2SIrr },
  { "vcvttsd2si", X86::VCVTTSD2SIZrr },
  { "vcvttsd2si", X86::VCVTTSD2SIZrm },
  { "vcvttsd2si", X86::VCVTTSD2SIrm },
  { "vcvttsd2si", X86::VCVTTSD2SIrm },
  { "vcvttsd2si", X86::VCVTTSD2SI64rr },
  { "vcvttsd2si", X86::VCVTTSD2SI64rr },
  { "vcvttsd2si", X86::VCVTTSD2SI64Zrr },
  { "vcvttsd2si", X86::VCVTTSD2SI64Zrm },
  { "vcvttsd2si", X86::VCVTTSD2SI64rm },
  { "vcvttsd2si", X86::VCVTTSD2SI64rm },
  { "vcvttsd2usi", X86::VCVTTSD2USIZrr },
  { "vcvttsd2usi", X86::VCVTTSD2USIZrm },
  { "vcvttsd2usi", X86::VCVTTSD2USI64Zrr },
  { "vcvttsd2usi", X86::VCVTTSD2USI64Zrm },
  { "vcvttss2si", X86::VCVTTSS2SIrr },
  { "vcvttss2si", X86::VCVTTSS2SIrr },
  { "vcvttss2si", X86::VCVTTSS2SIZrr },
  { "vcvttss2si", X86::VCVTTSS2SIZrm },
  { "vcvttss2si", X86::VCVTTSS2SIrm },
  { "vcvttss2si", X86::VCVTTSS2SIrm },
  { "vcvttss2si", X86::VCVTTSS2SI64rr },
  { "vcvttss2si", X86::VCVTTSS2SI64rr },
  { "vcvttss2si", X86::VCVTTSS2SI64Zrr },
  { "vcvttss2si", X86::VCVTTSS2SI64Zrm },
  { "vcvttss2si", X86::VCVTTSS2SI64rm },
  { "vcvttss2si", X86::VCVTTSS2SI64rm },
  { "vcvttss2usi", X86::VCVTTSS2USIZrr },
  { "vcvttss2usi", X86::VCVTTSS2USIZrm },
  { "vcvttss2usi", X86::VCVTTSS2USI64Zrr },
  { "vcvttss2usi", X86::VCVTTSS2USI64Zrm },
  { "vcvtudq2pd", X86::VCVTUDQ2PDZrr },
  { "vcvtudq2pd", X86::VCVTUDQ2PDZrm },
  { "vcvtudq2ps", X86::VCVTUDQ2PSZrr },
  { "vcvtudq2ps", X86::VCVTUDQ2PSZrm },
  { "vcvtudq2ps", X86::VCVTUDQ2PSZrrb },
  { "vcvtusi2sd", X86::VCVTUSI2SDZrr },
  { "vcvtusi2sd", X86::VCVTUSI642SDZrr },
  { "vcvtusi2sd", X86::VCVTUSI2SDZrm },
  { "vcvtusi2sd", X86::VCVTUSI642SDZrm },
  { "vcvtusi2ss", X86::VCVTUSI2SSZrr },
  { "vcvtusi2ss", X86::VCVTUSI642SSZrr },
  { "vcvtusi2ss", X86::VCVTUSI2SSZrm },
  { "vcvtusi2ss", X86::VCVTUSI642SSZrm },
  { "vdivpd", X86::VDIVPDrr },
  { "vdivpd", X86::VDIVPDrm },
  { "vdivpd", X86::VDIVPDYrr },
  { "vdivpd", X86::VDIVPDYrm },
  { "vdivpd", X86::VDIVPDZrr },
  { "vdivpd", X86::VDIVPDZrm },
  { "vdivpd", X86::VDIVPDZrmb },
  { "vdivpd", X86::VDIVPDZrrk },
  { "vdivpd", X86::VDIVPDZrmk },
  { "vdivpd", X86::VDIVPDZrrkz },
  { "vdivpd", X86::VDIVPDZrmkz },
  { "vdivpd", X86::VDIVPDZrmbk },
  { "vdivpd", X86::VDIVPDZrmbkz },
  { "vdivps", X86::VDIVPSrr },
  { "vdivps", X86::VDIVPSrm },
  { "vdivps", X86::VDIVPSYrr },
  { "vdivps", X86::VDIVPSYrm },
  { "vdivps", X86::VDIVPSZrr },
  { "vdivps", X86::VDIVPSZrm },
  { "vdivps", X86::VDIVPSZrmb },
  { "vdivps", X86::VDIVPSZrrk },
  { "vdivps", X86::VDIVPSZrmk },
  { "vdivps", X86::VDIVPSZrrkz },
  { "vdivps", X86::VDIVPSZrmkz },
  { "vdivps", X86::VDIVPSZrmbk },
  { "vdivps", X86::VDIVPSZrmbkz },
  { "vdivsd", X86::VDIVSDrr },
  { "vdivsd", X86::VDIVSDrm },
  { "vdivsd", X86::VDIVSDZrr },
  { "vdivsd", X86::VDIVSDZrm },
  { "vdivss", X86::VDIVSSrr },
  { "vdivss", X86::VDIVSSrm },
  { "vdivss", X86::VDIVSSZrr },
  { "vdivss", X86::VDIVSSZrm },
  { "vdppd", X86::VDPPDrri },
  { "vdppd", X86::VDPPDrmi },
  { "vdpps", X86::VDPPSrri },
  { "vdpps", X86::VDPPSrmi },
  { "vdpps", X86::VDPPSYrri },
  { "vdpps", X86::VDPPSYrmi },
  { "verr", X86::VERRr },
  { "verr", X86::VERRm },
  { "verw", X86::VERWr },
  { "verw", X86::VERWm },
  { "vextractf128", X86::VEXTRACTF128rr },
  { "vextractf128", X86::VEXTRACTF128mr },
  { "vextractf32x4", X86::VEXTRACTF32x4rr },
  { "vextractf32x4", X86::VEXTRACTF32x4rm },
  { "vextractf64x4", X86::VEXTRACTF64x4rr },
  { "vextractf64x4", X86::VEXTRACTF64x4rm },
  { "vextracti128", X86::VEXTRACTI128rr },
  { "vextracti128", X86::VEXTRACTI128mr },
  { "vextracti32x4", X86::VEXTRACTI32x4rr },
  { "vextracti32x4", X86::VEXTRACTI32x4rm },
  { "vextracti64x4", X86::VEXTRACTI64x4rr },
  { "vextracti64x4", X86::VEXTRACTI64x4rm },
  { "vextractps", X86::VEXTRACTPSzrr },
  { "vextractps", X86::VEXTRACTPSrr },
  { "vextractps", X86::VEXTRACTPSmr },
  { "vextractps", X86::VEXTRACTPSzmr },
  { "vfmadd132pd", X86::VFMADDPDr132r },
  { "vfmadd132pd", X86::VFMADDPDr132m },
  { "vfmadd132pd", X86::VFMADDPDr132rY },
  { "vfmadd132pd", X86::VFMADDPDr132mY },
  { "vfmadd132pd", X86::VFMADD132PDZm },
  { "vfmadd132pd", X86::VFMADD132PDZmb },
  { "vfmadd132ps", X86::VFMADDPSr132r },
  { "vfmadd132ps", X86::VFMADDPSr132m },
  { "vfmadd132ps", X86::VFMADDPSr132rY },
  { "vfmadd132ps", X86::VFMADDPSr132mY },
  { "vfmadd132ps", X86::VFMADD132PSZm },
  { "vfmadd132ps", X86::VFMADD132PSZmb },
  { "vfmadd132sd", X86::VFMADDSDr132r },
  { "vfmadd132sd", X86::VFMADDSDr132m },
  { "vfmadd132ss", X86::VFMADDSSr132r },
  { "vfmadd132ss", X86::VFMADDSSr132m },
  { "vfmadd213pd", X86::VFMADDPDr213r },
  { "vfmadd213pd", X86::VFMADDPDr213m },
  { "vfmadd213pd", X86::VFMADDPDr213rY },
  { "vfmadd213pd", X86::VFMADDPDr213mY },
  { "vfmadd213pd", X86::VFMADD213PDZr },
  { "vfmadd213pd", X86::VFMADD213PDZm },
  { "vfmadd213pd", X86::VFMADD213PDZmb },
  { "vfmadd213pd", X86::VFMADD213PDZrk },
  { "vfmadd213pd", X86::VFMADD213PDZrkz },
  { "vfmadd213ps", X86::VFMADDPSr213r },
  { "vfmadd213ps", X86::VFMADDPSr213m },
  { "vfmadd213ps", X86::VFMADDPSr213rY },
  { "vfmadd213ps", X86::VFMADDPSr213mY },
  { "vfmadd213ps", X86::VFMADD213PSZr },
  { "vfmadd213ps", X86::VFMADD213PSZm },
  { "vfmadd213ps", X86::VFMADD213PSZmb },
  { "vfmadd213ps", X86::VFMADD213PSZrk },
  { "vfmadd213ps", X86::VFMADD213PSZrkz },
  { "vfmadd213sd", X86::VFMADDSDr213r },
  { "vfmadd213sd", X86::VFMADDSDr213m },
  { "vfmadd213sd", X86::VFMADDSDZr },
  { "vfmadd213sd", X86::VFMADDSDZm },
  { "vfmadd213ss", X86::VFMADDSSr213r },
  { "vfmadd213ss", X86::VFMADDSSr213m },
  { "vfmadd213ss", X86::VFMADDSSZr },
  { "vfmadd213ss", X86::VFMADDSSZm },
  { "vfmadd231pd", X86::VFMADDPDr231r },
  { "vfmadd231pd", X86::VFMADDPDr231m },
  { "vfmadd231pd", X86::VFMADDPDr231rY },
  { "vfmadd231pd", X86::VFMADDPDr231mY },
  { "vfmadd231ps", X86::VFMADDPSr231r },
  { "vfmadd231ps", X86::VFMADDPSr231m },
  { "vfmadd231ps", X86::VFMADDPSr231rY },
  { "vfmadd231ps", X86::VFMADDPSr231mY },
  { "vfmadd231sd", X86::VFMADDSDr231r },
  { "vfmadd231sd", X86::VFMADDSDr231m },
  { "vfmadd231ss", X86::VFMADDSSr231r },
  { "vfmadd231ss", X86::VFMADDSSr231m },
  { "vfmaddpd", X86::VFMADDPD4rr },
  { "vfmaddpd", X86::VFMADDPD4rm },
  { "vfmaddpd", X86::VFMADDPD4mr },
  { "vfmaddpd", X86::VFMADDPD4rrY },
  { "vfmaddpd", X86::VFMADDPD4rmY },
  { "vfmaddpd", X86::VFMADDPD4mrY },
  { "vfmaddps", X86::VFMADDPS4rr },
  { "vfmaddps", X86::VFMADDPS4rm },
  { "vfmaddps", X86::VFMADDPS4mr },
  { "vfmaddps", X86::VFMADDPS4rrY },
  { "vfmaddps", X86::VFMADDPS4rmY },
  { "vfmaddps", X86::VFMADDPS4mrY },
  { "vfmaddsd", X86::VFMADDSD4rr },
  { "vfmaddsd", X86::VFMADDSD4rm },
  { "vfmaddsd", X86::VFMADDSD4mr },
  { "vfmaddss", X86::VFMADDSS4rr },
  { "vfmaddss", X86::VFMADDSS4rm },
  { "vfmaddss", X86::VFMADDSS4mr },
  { "vfmaddsub132pd", X86::VFMADDSUBPDr132r },
  { "vfmaddsub132pd", X86::VFMADDSUBPDr132m },
  { "vfmaddsub132pd", X86::VFMADDSUBPDr132rY },
  { "vfmaddsub132pd", X86::VFMADDSUBPDr132mY },
  { "vfmaddsub132pd", X86::VFMADDSUB132PDZm },
  { "vfmaddsub132pd", X86::VFMADDSUB132PDZmb },
  { "vfmaddsub132ps", X86::VFMADDSUBPSr132r },
  { "vfmaddsub132ps", X86::VFMADDSUBPSr132m },
  { "vfmaddsub132ps", X86::VFMADDSUBPSr132rY },
  { "vfmaddsub132ps", X86::VFMADDSUBPSr132mY },
  { "vfmaddsub132ps", X86::VFMADDSUB132PSZm },
  { "vfmaddsub132ps", X86::VFMADDSUB132PSZmb },
  { "vfmaddsub213pd", X86::VFMADDSUBPDr213r },
  { "vfmaddsub213pd", X86::VFMADDSUBPDr213m },
  { "vfmaddsub213pd", X86::VFMADDSUBPDr213rY },
  { "vfmaddsub213pd", X86::VFMADDSUBPDr213mY },
  { "vfmaddsub213pd", X86::VFMADDSUB213PDZr },
  { "vfmaddsub213pd", X86::VFMADDSUB213PDZm },
  { "vfmaddsub213pd", X86::VFMADDSUB213PDZmb },
  { "vfmaddsub213pd", X86::VFMADDSUB213PDZrk },
  { "vfmaddsub213pd", X86::VFMADDSUB213PDZrkz },
  { "vfmaddsub213ps", X86::VFMADDSUBPSr213r },
  { "vfmaddsub213ps", X86::VFMADDSUBPSr213m },
  { "vfmaddsub213ps", X86::VFMADDSUBPSr213rY },
  { "vfmaddsub213ps", X86::VFMADDSUBPSr213mY },
  { "vfmaddsub213ps", X86::VFMADDSUB213PSZr },
  { "vfmaddsub213ps", X86::VFMADDSUB213PSZm },
  { "vfmaddsub213ps", X86::VFMADDSUB213PSZmb },
  { "vfmaddsub213ps", X86::VFMADDSUB213PSZrk },
  { "vfmaddsub213ps", X86::VFMADDSUB213PSZrkz },
  { "vfmaddsub231pd", X86::VFMADDSUBPDr231r },
  { "vfmaddsub231pd", X86::VFMADDSUBPDr231m },
  { "vfmaddsub231pd", X86::VFMADDSUBPDr231rY },
  { "vfmaddsub231pd", X86::VFMADDSUBPDr231mY },
  { "vfmaddsub231ps", X86::VFMADDSUBPSr231r },
  { "vfmaddsub231ps", X86::VFMADDSUBPSr231m },
  { "vfmaddsub231ps", X86::VFMADDSUBPSr231rY },
  { "vfmaddsub231ps", X86::VFMADDSUBPSr231mY },
  { "vfmaddsubpd", X86::VFMADDSUBPD4rr },
  { "vfmaddsubpd", X86::VFMADDSUBPD4rm },
  { "vfmaddsubpd", X86::VFMADDSUBPD4mr },
  { "vfmaddsubpd", X86::VFMADDSUBPD4rrY },
  { "vfmaddsubpd", X86::VFMADDSUBPD4rmY },
  { "vfmaddsubpd", X86::VFMADDSUBPD4mrY },
  { "vfmaddsubps", X86::VFMADDSUBPS4rr },
  { "vfmaddsubps", X86::VFMADDSUBPS4rm },
  { "vfmaddsubps", X86::VFMADDSUBPS4mr },
  { "vfmaddsubps", X86::VFMADDSUBPS4rrY },
  { "vfmaddsubps", X86::VFMADDSUBPS4rmY },
  { "vfmaddsubps", X86::VFMADDSUBPS4mrY },
  { "vfmsub132pd", X86::VFMSUBPDr132r },
  { "vfmsub132pd", X86::VFMSUBPDr132m },
  { "vfmsub132pd", X86::VFMSUBPDr132rY },
  { "vfmsub132pd", X86::VFMSUBPDr132mY },
  { "vfmsub132pd", X86::VFMSUB132PDZm },
  { "vfmsub132pd", X86::VFMSUB132PDZmb },
  { "vfmsub132ps", X86::VFMSUBPSr132r },
  { "vfmsub132ps", X86::VFMSUBPSr132m },
  { "vfmsub132ps", X86::VFMSUBPSr132rY },
  { "vfmsub132ps", X86::VFMSUBPSr132mY },
  { "vfmsub132ps", X86::VFMSUB132PSZm },
  { "vfmsub132ps", X86::VFMSUB132PSZmb },
  { "vfmsub132sd", X86::VFMSUBSDr132r },
  { "vfmsub132sd", X86::VFMSUBSDr132m },
  { "vfmsub132ss", X86::VFMSUBSSr132r },
  { "vfmsub132ss", X86::VFMSUBSSr132m },
  { "vfmsub213pd", X86::VFMSUBPDr213r },
  { "vfmsub213pd", X86::VFMSUBPDr213m },
  { "vfmsub213pd", X86::VFMSUBPDr213rY },
  { "vfmsub213pd", X86::VFMSUBPDr213mY },
  { "vfmsub213pd", X86::VFMSUB213PDZr },
  { "vfmsub213pd", X86::VFMSUB213PDZm },
  { "vfmsub213pd", X86::VFMSUB213PDZmb },
  { "vfmsub213pd", X86::VFMSUB213PDZrk },
  { "vfmsub213pd", X86::VFMSUB213PDZrkz },
  { "vfmsub213ps", X86::VFMSUBPSr213r },
  { "vfmsub213ps", X86::VFMSUBPSr213m },
  { "vfmsub213ps", X86::VFMSUBPSr213rY },
  { "vfmsub213ps", X86::VFMSUBPSr213mY },
  { "vfmsub213ps", X86::VFMSUB213PSZr },
  { "vfmsub213ps", X86::VFMSUB213PSZm },
  { "vfmsub213ps", X86::VFMSUB213PSZmb },
  { "vfmsub213ps", X86::VFMSUB213PSZrk },
  { "vfmsub213ps", X86::VFMSUB213PSZrkz },
  { "vfmsub213sd", X86::VFMSUBSDr213r },
  { "vfmsub213sd", X86::VFMSUBSDr213m },
  { "vfmsub213sd", X86::VFMSUBSDZr },
  { "vfmsub213sd", X86::VFMSUBSDZm },
  { "vfmsub213ss", X86::VFMSUBSSr213r },
  { "vfmsub213ss", X86::VFMSUBSSr213m },
  { "vfmsub213ss", X86::VFMSUBSSZr },
  { "vfmsub213ss", X86::VFMSUBSSZm },
  { "vfmsub231pd", X86::VFMSUBPDr231r },
  { "vfmsub231pd", X86::VFMSUBPDr231m },
  { "vfmsub231pd", X86::VFMSUBPDr231rY },
  { "vfmsub231pd", X86::VFMSUBPDr231mY },
  { "vfmsub231ps", X86::VFMSUBPSr231r },
  { "vfmsub231ps", X86::VFMSUBPSr231m },
  { "vfmsub231ps", X86::VFMSUBPSr231rY },
  { "vfmsub231ps", X86::VFMSUBPSr231mY },
  { "vfmsub231sd", X86::VFMSUBSDr231r },
  { "vfmsub231sd", X86::VFMSUBSDr231m },
  { "vfmsub231ss", X86::VFMSUBSSr231r },
  { "vfmsub231ss", X86::VFMSUBSSr231m },
  { "vfmsubadd132pd", X86::VFMSUBADDPDr132r },
  { "vfmsubadd132pd", X86::VFMSUBADDPDr132m },
  { "vfmsubadd132pd", X86::VFMSUBADDPDr132rY },
  { "vfmsubadd132pd", X86::VFMSUBADDPDr132mY },
  { "vfmsubadd132pd", X86::VFMSUBADD132PDZm },
  { "vfmsubadd132pd", X86::VFMSUBADD132PDZmb },
  { "vfmsubadd132ps", X86::VFMSUBADDPSr132r },
  { "vfmsubadd132ps", X86::VFMSUBADDPSr132m },
  { "vfmsubadd132ps", X86::VFMSUBADDPSr132rY },
  { "vfmsubadd132ps", X86::VFMSUBADDPSr132mY },
  { "vfmsubadd132ps", X86::VFMSUBADD132PSZm },
  { "vfmsubadd132ps", X86::VFMSUBADD132PSZmb },
  { "vfmsubadd213pd", X86::VFMSUBADDPDr213r },
  { "vfmsubadd213pd", X86::VFMSUBADDPDr213m },
  { "vfmsubadd213pd", X86::VFMSUBADDPDr213rY },
  { "vfmsubadd213pd", X86::VFMSUBADDPDr213mY },
  { "vfmsubadd213pd", X86::VFMSUBADD213PDZr },
  { "vfmsubadd213pd", X86::VFMSUBADD213PDZm },
  { "vfmsubadd213pd", X86::VFMSUBADD213PDZmb },
  { "vfmsubadd213pd", X86::VFMSUBADD213PDZrk },
  { "vfmsubadd213pd", X86::VFMSUBADD213PDZrkz },
  { "vfmsubadd213ps", X86::VFMSUBADDPSr213r },
  { "vfmsubadd213ps", X86::VFMSUBADDPSr213m },
  { "vfmsubadd213ps", X86::VFMSUBADDPSr213rY },
  { "vfmsubadd213ps", X86::VFMSUBADDPSr213mY },
  { "vfmsubadd213ps", X86::VFMSUBADD213PSZr },
  { "vfmsubadd213ps", X86::VFMSUBADD213PSZm },
  { "vfmsubadd213ps", X86::VFMSUBADD213PSZmb },
  { "vfmsubadd213ps", X86::VFMSUBADD213PSZrk },
  { "vfmsubadd213ps", X86::VFMSUBADD213PSZrkz },
  { "vfmsubadd231pd", X86::VFMSUBADDPDr231r },
  { "vfmsubadd231pd", X86::VFMSUBADDPDr231m },
  { "vfmsubadd231pd", X86::VFMSUBADDPDr231rY },
  { "vfmsubadd231pd", X86::VFMSUBADDPDr231mY },
  { "vfmsubadd231ps", X86::VFMSUBADDPSr231r },
  { "vfmsubadd231ps", X86::VFMSUBADDPSr231m },
  { "vfmsubadd231ps", X86::VFMSUBADDPSr231rY },
  { "vfmsubadd231ps", X86::VFMSUBADDPSr231mY },
  { "vfmsubaddpd", X86::VFMSUBADDPD4rr },
  { "vfmsubaddpd", X86::VFMSUBADDPD4rm },
  { "vfmsubaddpd", X86::VFMSUBADDPD4mr },
  { "vfmsubaddpd", X86::VFMSUBADDPD4rrY },
  { "vfmsubaddpd", X86::VFMSUBADDPD4rmY },
  { "vfmsubaddpd", X86::VFMSUBADDPD4mrY },
  { "vfmsubaddps", X86::VFMSUBADDPS4rr },
  { "vfmsubaddps", X86::VFMSUBADDPS4rm },
  { "vfmsubaddps", X86::VFMSUBADDPS4mr },
  { "vfmsubaddps", X86::VFMSUBADDPS4rrY },
  { "vfmsubaddps", X86::VFMSUBADDPS4rmY },
  { "vfmsubaddps", X86::VFMSUBADDPS4mrY },
  { "vfmsubpd", X86::VFMSUBPD4rr },
  { "vfmsubpd", X86::VFMSUBPD4rm },
  { "vfmsubpd", X86::VFMSUBPD4mr },
  { "vfmsubpd", X86::VFMSUBPD4rrY },
  { "vfmsubpd", X86::VFMSUBPD4rmY },
  { "vfmsubpd", X86::VFMSUBPD4mrY },
  { "vfmsubps", X86::VFMSUBPS4rr },
  { "vfmsubps", X86::VFMSUBPS4rm },
  { "vfmsubps", X86::VFMSUBPS4mr },
  { "vfmsubps", X86::VFMSUBPS4rrY },
  { "vfmsubps", X86::VFMSUBPS4rmY },
  { "vfmsubps", X86::VFMSUBPS4mrY },
  { "vfmsubsd", X86::VFMSUBSD4rr },
  { "vfmsubsd", X86::VFMSUBSD4rm },
  { "vfmsubsd", X86::VFMSUBSD4mr },
  { "vfmsubss", X86::VFMSUBSS4rr },
  { "vfmsubss", X86::VFMSUBSS4rm },
  { "vfmsubss", X86::VFMSUBSS4mr },
  { "vfnmadd132pd", X86::VFNMADDPDr132r },
  { "vfnmadd132pd", X86::VFNMADDPDr132m },
  { "vfnmadd132pd", X86::VFNMADDPDr132rY },
  { "vfnmadd132pd", X86::VFNMADDPDr132mY },
  { "vfnmadd132pd", X86::VFNMADD132PDZm },
  { "vfnmadd132pd", X86::VFNMADD132PDZmb },
  { "vfnmadd132ps", X86::VFNMADDPSr132r },
  { "vfnmadd132ps", X86::VFNMADDPSr132m },
  { "vfnmadd132ps", X86::VFNMADDPSr132rY },
  { "vfnmadd132ps", X86::VFNMADDPSr132mY },
  { "vfnmadd132ps", X86::VFNMADD132PSZm },
  { "vfnmadd132ps", X86::VFNMADD132PSZmb },
  { "vfnmadd132sd", X86::VFNMADDSDr132r },
  { "vfnmadd132sd", X86::VFNMADDSDr132m },
  { "vfnmadd132ss", X86::VFNMADDSSr132r },
  { "vfnmadd132ss", X86::VFNMADDSSr132m },
  { "vfnmadd213pd", X86::VFNMADDPDr213r },
  { "vfnmadd213pd", X86::VFNMADDPDr213m },
  { "vfnmadd213pd", X86::VFNMADDPDr213rY },
  { "vfnmadd213pd", X86::VFNMADDPDr213mY },
  { "vfnmadd213pd", X86::VFNMADD213PDZr },
  { "vfnmadd213pd", X86::VFNMADD213PDZm },
  { "vfnmadd213pd", X86::VFNMADD213PDZmb },
  { "vfnmadd213pd", X86::VFNMADD213PDZrk },
  { "vfnmadd213pd", X86::VFNMADD213PDZrkz },
  { "vfnmadd213ps", X86::VFNMADDPSr213r },
  { "vfnmadd213ps", X86::VFNMADDPSr213m },
  { "vfnmadd213ps", X86::VFNMADDPSr213rY },
  { "vfnmadd213ps", X86::VFNMADDPSr213mY },
  { "vfnmadd213ps", X86::VFNMADD213PSZr },
  { "vfnmadd213ps", X86::VFNMADD213PSZm },
  { "vfnmadd213ps", X86::VFNMADD213PSZmb },
  { "vfnmadd213ps", X86::VFNMADD213PSZrk },
  { "vfnmadd213ps", X86::VFNMADD213PSZrkz },
  { "vfnmadd213sd", X86::VFNMADDSDr213r },
  { "vfnmadd213sd", X86::VFNMADDSDr213m },
  { "vfnmadd213sd", X86::VFNMADDSDZr },
  { "vfnmadd213sd", X86::VFNMADDSDZm },
  { "vfnmadd213ss", X86::VFNMADDSSr213r },
  { "vfnmadd213ss", X86::VFNMADDSSr213m },
  { "vfnmadd213ss", X86::VFNMADDSSZr },
  { "vfnmadd213ss", X86::VFNMADDSSZm },
  { "vfnmadd231pd", X86::VFNMADDPDr231r },
  { "vfnmadd231pd", X86::VFNMADDPDr231m },
  { "vfnmadd231pd", X86::VFNMADDPDr231rY },
  { "vfnmadd231pd", X86::VFNMADDPDr231mY },
  { "vfnmadd231ps", X86::VFNMADDPSr231r },
  { "vfnmadd231ps", X86::VFNMADDPSr231m },
  { "vfnmadd231ps", X86::VFNMADDPSr231rY },
  { "vfnmadd231ps", X86::VFNMADDPSr231mY },
  { "vfnmadd231sd", X86::VFNMADDSDr231r },
  { "vfnmadd231sd", X86::VFNMADDSDr231m },
  { "vfnmadd231ss", X86::VFNMADDSSr231r },
  { "vfnmadd231ss", X86::VFNMADDSSr231m },
  { "vfnmaddpd", X86::VFNMADDPD4rr },
  { "vfnmaddpd", X86::VFNMADDPD4rm },
  { "vfnmaddpd", X86::VFNMADDPD4mr },
  { "vfnmaddpd", X86::VFNMADDPD4rrY },
  { "vfnmaddpd", X86::VFNMADDPD4rmY },
  { "vfnmaddpd", X86::VFNMADDPD4mrY },
  { "vfnmaddps", X86::VFNMADDPS4rr },
  { "vfnmaddps", X86::VFNMADDPS4rm },
  { "vfnmaddps", X86::VFNMADDPS4mr },
  { "vfnmaddps", X86::VFNMADDPS4rrY },
  { "vfnmaddps", X86::VFNMADDPS4rmY },
  { "vfnmaddps", X86::VFNMADDPS4mrY },
  { "vfnmaddsd", X86::VFNMADDSD4rr },
  { "vfnmaddsd", X86::VFNMADDSD4rm },
  { "vfnmaddsd", X86::VFNMADDSD4mr },
  { "vfnmaddss", X86::VFNMADDSS4rr },
  { "vfnmaddss", X86::VFNMADDSS4rm },
  { "vfnmaddss", X86::VFNMADDSS4mr },
  { "vfnmsub132pd", X86::VFNMSUBPDr132r },
  { "vfnmsub132pd", X86::VFNMSUBPDr132m },
  { "vfnmsub132pd", X86::VFNMSUBPDr132rY },
  { "vfnmsub132pd", X86::VFNMSUBPDr132mY },
  { "vfnmsub132pd", X86::VFNMSUB132PDZm },
  { "vfnmsub132pd", X86::VFNMSUB132PDZmb },
  { "vfnmsub132ps", X86::VFNMSUBPSr132r },
  { "vfnmsub132ps", X86::VFNMSUBPSr132m },
  { "vfnmsub132ps", X86::VFNMSUBPSr132rY },
  { "vfnmsub132ps", X86::VFNMSUBPSr132mY },
  { "vfnmsub132ps", X86::VFNMSUB132PSZm },
  { "vfnmsub132ps", X86::VFNMSUB132PSZmb },
  { "vfnmsub132sd", X86::VFNMSUBSDr132r },
  { "vfnmsub132sd", X86::VFNMSUBSDr132m },
  { "vfnmsub132ss", X86::VFNMSUBSSr132r },
  { "vfnmsub132ss", X86::VFNMSUBSSr132m },
  { "vfnmsub213pd", X86::VFNMSUBPDr213r },
  { "vfnmsub213pd", X86::VFNMSUBPDr213m },
  { "vfnmsub213pd", X86::VFNMSUBPDr213rY },
  { "vfnmsub213pd", X86::VFNMSUBPDr213mY },
  { "vfnmsub213pd", X86::VFNMSUB213PDZr },
  { "vfnmsub213pd", X86::VFNMSUB213PDZm },
  { "vfnmsub213pd", X86::VFNMSUB213PDZmb },
  { "vfnmsub213pd", X86::VFNMSUB213PDZrk },
  { "vfnmsub213pd", X86::VFNMSUB213PDZrkz },
  { "vfnmsub213ps", X86::VFNMSUBPSr213r },
  { "vfnmsub213ps", X86::VFNMSUBPSr213m },
  { "vfnmsub213ps", X86::VFNMSUBPSr213rY },
  { "vfnmsub213ps", X86::VFNMSUBPSr213mY },
  { "vfnmsub213ps", X86::VFNMSUB213PSZr },
  { "vfnmsub213ps", X86::VFNMSUB213PSZm },
  { "vfnmsub213ps", X86::VFNMSUB213PSZmb },
  { "vfnmsub213ps", X86::VFNMSUB213PSZrk },
  { "vfnmsub213ps", X86::VFNMSUB213PSZrkz },
  { "vfnmsub213sd", X86::VFNMSUBSDr213r },
  { "vfnmsub213sd", X86::VFNMSUBSDr213m },
  { "vfnmsub213sd", X86::VFNMSUBSDZr },
  { "vfnmsub213sd", X86::VFNMSUBSDZm },
  { "vfnmsub213ss", X86::VFNMSUBSSr213r },
  { "vfnmsub213ss", X86::VFNMSUBSSr213m },
  { "vfnmsub213ss", X86::VFNMSUBSSZr },
  { "vfnmsub213ss", X86::VFNMSUBSSZm },
  { "vfnmsub231pd", X86::VFNMSUBPDr231r },
  { "vfnmsub231pd", X86::VFNMSUBPDr231m },
  { "vfnmsub231pd", X86::VFNMSUBPDr231rY },
  { "vfnmsub231pd", X86::VFNMSUBPDr231mY },
  { "vfnmsub231ps", X86::VFNMSUBPSr231r },
  { "vfnmsub231ps", X86::VFNMSUBPSr231m },
  { "vfnmsub231ps", X86::VFNMSUBPSr231rY },
  { "vfnmsub231ps", X86::VFNMSUBPSr231mY },
  { "vfnmsub231sd", X86::VFNMSUBSDr231r },
  { "vfnmsub231sd", X86::VFNMSUBSDr231m },
  { "vfnmsub231ss", X86::VFNMSUBSSr231r },
  { "vfnmsub231ss", X86::VFNMSUBSSr231m },
  { "vfnmsubpd", X86::VFNMSUBPD4rr },
  { "vfnmsubpd", X86::VFNMSUBPD4rm },
  { "vfnmsubpd", X86::VFNMSUBPD4mr },
  { "vfnmsubpd", X86::VFNMSUBPD4rrY },
  { "vfnmsubpd", X86::VFNMSUBPD4rmY },
  { "vfnmsubpd", X86::VFNMSUBPD4mrY },
  { "vfnmsubps", X86::VFNMSUBPS4rr },
  { "vfnmsubps", X86::VFNMSUBPS4rm },
  { "vfnmsubps", X86::VFNMSUBPS4mr },
  { "vfnmsubps", X86::VFNMSUBPS4rrY },
  { "vfnmsubps", X86::VFNMSUBPS4rmY },
  { "vfnmsubps", X86::VFNMSUBPS4mrY },
  { "vfnmsubsd", X86::VFNMSUBSD4rr },
  { "vfnmsubsd", X86::VFNMSUBSD4rm },
  { "vfnmsubsd", X86::VFNMSUBSD4mr },
  { "vfnmsubss", X86::VFNMSUBSS4rr },
  { "vfnmsubss", X86::VFNMSUBSS4rm },
  { "vfnmsubss", X86::VFNMSUBSS4mr },
  { "vfrczpd", X86::VFRCZPDrr },
  { "vfrczpd", X86::VFRCZPDrm },
  { "vfrczpd", X86::VFRCZPDrrY },
  { "vfrczpd", X86::VFRCZPDrmY },
  { "vfrczps", X86::VFRCZPSrr },
  { "vfrczps", X86::VFRCZPSrm },
  { "vfrczps", X86::VFRCZPSrrY },
  { "vfrczps", X86::VFRCZPSrmY },
  { "vfrczsd", X86::VFRCZSDrr },
  { "vfrczsd", X86::VFRCZSDrm },
  { "vfrczss", X86::VFRCZSSrr },
  { "vfrczss", X86::VFRCZSSrm },
  { "vgatherdpd", X86::VGATHERDPDrm },
  { "vgatherdpd", X86::VGATHERDPDYrm },
  { "vgatherdpd", X86::VGATHERDPDZrm },
  { "vgatherdps", X86::VGATHERDPSrm },
  { "vgatherdps", X86::VGATHERDPSYrm },
  { "vgatherdps", X86::VGATHERDPSZrm },
  { "vgatherpf0dpd", X86::VGATHERPF0DPDm },
  { "vgatherpf0dps", X86::VGATHERPF0DPSm },
  { "vgatherpf0qpd", X86::VGATHERPF0QPDm },
  { "vgatherpf0qps", X86::VGATHERPF0QPSm },
  { "vgatherpf1dpd", X86::VGATHERPF1DPDm },
  { "vgatherpf1dps", X86::VGATHERPF1DPSm },
  { "vgatherpf1qpd", X86::VGATHERPF1QPDm },
  { "vgatherpf1qps", X86::VGATHERPF1QPSm },
  { "vgatherqpd", X86::VGATHERQPDrm },
  { "vgatherqpd", X86::VGATHERQPDYrm },
  { "vgatherqpd", X86::VGATHERQPDZrm },
  { "vgatherqps", X86::VGATHERQPSrm },
  { "vgatherqps", X86::VGATHERQPSYrm },
  { "vgatherqps", X86::VGATHERQPSZrm },
  { "vhaddpd", X86::VHADDPDrr },
  { "vhaddpd", X86::VHADDPDrm },
  { "vhaddpd", X86::VHADDPDYrr },
  { "vhaddpd", X86::VHADDPDYrm },
  { "vhaddps", X86::VHADDPSrr },
  { "vhaddps", X86::VHADDPSrm },
  { "vhaddps", X86::VHADDPSYrr },
  { "vhaddps", X86::VHADDPSYrm },
  { "vhsubpd", X86::VHSUBPDrr },
  { "vhsubpd", X86::VHSUBPDrm },
  { "vhsubpd", X86::VHSUBPDYrr },
  { "vhsubpd", X86::VHSUBPDYrm },
  { "vhsubps", X86::VHSUBPSrr },
  { "vhsubps", X86::VHSUBPSrm },
  { "vhsubps", X86::VHSUBPSYrr },
  { "vhsubps", X86::VHSUBPSYrm },
  { "vinsertf128", X86::VINSERTF128rr },
  { "vinsertf128", X86::VINSERTF128rm },
  { "vinsertf32x4", X86::VINSERTF32x4rr },
  { "vinsertf32x4", X86::VINSERTF32x4rm },
  { "vinsertf64x4", X86::VINSERTF64x4rr },
  { "vinsertf64x4", X86::VINSERTF64x4rm },
  { "vinserti128", X86::VINSERTI128rr },
  { "vinserti128", X86::VINSERTI128rm },
  { "vinserti32x4", X86::VINSERTI32x4rr },
  { "vinserti32x4", X86::VINSERTI32x4rm },
  { "vinserti64x4", X86::VINSERTI64x4rr },
  { "vinserti64x4", X86::VINSERTI64x4rm },
  { "vinsertps", X86::VINSERTPSrr },
  { "vinsertps", X86::VINSERTPSrm },
  { "vinsertps", X86::VINSERTPSzrr },
  { "vinsertps", X86::VINSERTPSzrm },
  { "vlddqu", X86::VLDDQUrm },
  { "vlddqu", X86::VLDDQUYrm },
  { "vldmxcsr", X86::VLDMXCSR },
  { "vmaskmovdqu", X86::VMASKMOVDQU },
  { "vmaskmovdqu", X86::VMASKMOVDQU64 },
  { "vmaskmovpd", X86::VMASKMOVPDrm },
  { "vmaskmovpd", X86::VMASKMOVPDYrm },
  { "vmaskmovpd", X86::VMASKMOVPDmr },
  { "vmaskmovpd", X86::VMASKMOVPDYmr },
  { "vmaskmovps", X86::VMASKMOVPSrm },
  { "vmaskmovps", X86::VMASKMOVPSYrm },
  { "vmaskmovps", X86::VMASKMOVPSmr },
  { "vmaskmovps", X86::VMASKMOVPSYmr },
  { "vmaxpd", X86::VMAXPDrr },
  { "vmaxpd", X86::VMAXPDrm },
  { "vmaxpd", X86::VMAXPDYrr },
  { "vmaxpd", X86::VMAXPDYrm },
  { "vmaxpd", X86::VMAXPDZrr },
  { "vmaxpd", X86::VMAXPDZrm },
  { "vmaxpd", X86::VMAXPDZrmb },
  { "vmaxpd", X86::VMAXPDZrrk },
  { "vmaxpd", X86::VMAXPDZrmk },
  { "vmaxpd", X86::VMAXPDZrrkz },
  { "vmaxpd", X86::VMAXPDZrmkz },
  { "vmaxpd", X86::VMAXPDZrmbk },
  { "vmaxpd", X86::VMAXPDZrmbkz },
  { "vmaxps", X86::VMAXPSrr },
  { "vmaxps", X86::VMAXPSrm },
  { "vmaxps", X86::VMAXPSYrr },
  { "vmaxps", X86::VMAXPSYrm },
  { "vmaxps", X86::VMAXPSZrr },
  { "vmaxps", X86::VMAXPSZrm },
  { "vmaxps", X86::VMAXPSZrmb },
  { "vmaxps", X86::VMAXPSZrrk },
  { "vmaxps", X86::VMAXPSZrmk },
  { "vmaxps", X86::VMAXPSZrrkz },
  { "vmaxps", X86::VMAXPSZrmkz },
  { "vmaxps", X86::VMAXPSZrmbk },
  { "vmaxps", X86::VMAXPSZrmbkz },
  { "vmaxsd", X86::VMAXSDrr },
  { "vmaxsd", X86::VMAXSDrm },
  { "vmaxsd", X86::VMAXSDZrr },
  { "vmaxsd", X86::VMAXSDZrm },
  { "vmaxss", X86::VMAXSSrr },
  { "vmaxss", X86::VMAXSSrm },
  { "vmaxss", X86::VMAXSSZrr },
  { "vmaxss", X86::VMAXSSZrm },
  { "vmcall", X86::VMCALL },
  { "vmclear", X86::VMCLEARm },
  { "vmfunc", X86::VMFUNC },
  { "vminpd", X86::VMINPDrr },
  { "vminpd", X86::VMINPDrm },
  { "vminpd", X86::VMINPDYrr },
  { "vminpd", X86::VMINPDYrm },
  { "vminpd", X86::VMINPDZrr },
  { "vminpd", X86::VMINPDZrm },
  { "vminpd", X86::VMINPDZrmb },
  { "vminpd", X86::VMINPDZrrk },
  { "vminpd", X86::VMINPDZrmk },
  { "vminpd", X86::VMINPDZrrkz },
  { "vminpd", X86::VMINPDZrmkz },
  { "vminpd", X86::VMINPDZrmbk },
  { "vminpd", X86::VMINPDZrmbkz },
  { "vminps", X86::VMINPSrr },
  { "vminps", X86::VMINPSrm },
  { "vminps", X86::VMINPSYrr },
  { "vminps", X86::VMINPSYrm },
  { "vminps", X86::VMINPSZrr },
  { "vminps", X86::VMINPSZrm },
  { "vminps", X86::VMINPSZrmb },
  { "vminps", X86::VMINPSZrrk },
  { "vminps", X86::VMINPSZrmk },
  { "vminps", X86::VMINPSZrrkz },
  { "vminps", X86::VMINPSZrmkz },
  { "vminps", X86::VMINPSZrmbk },
  { "vminps", X86::VMINPSZrmbkz },
  { "vminsd", X86::VMINSDrr },
  { "vminsd", X86::VMINSDrm },
  { "vminsd", X86::VMINSDZrr },
  { "vminsd", X86::VMINSDZrm },
  { "vminss", X86::VMINSSrr },
  { "vminss", X86::VMINSSrm },
  { "vminss", X86::VMINSSZrr },
  { "vminss", X86::VMINSSZrm },
  { "vmlaunch", X86::VMLAUNCH },
  { "vmload", X86::VMLOAD32 },
  { "vmload", X86::VMLOAD64 },
  { "vmmcall", X86::VMMCALL },
  { "vmovapd", X86::VMOVAPDrr },
  { "vmovapd", X86::VMOVAPDrm },
  { "vmovapd", X86::VMOVAPDZ128rr },
  { "vmovapd", X86::VMOVAPDZ128rr_alt },
  { "vmovapd", X86::VMOVAPDZ128rm },
  { "vmovapd", X86::VMOVAPDYrr },
  { "vmovapd", X86::VMOVAPDYrm },
  { "vmovapd", X86::VMOVAPDZ256rr },
  { "vmovapd", X86::VMOVAPDZ256rr_alt },
  { "vmovapd", X86::VMOVAPDZ256rm },
  { "vmovapd", X86::VMOVAPDZrr },
  { "vmovapd", X86::VMOVAPDZrr_alt },
  { "vmovapd", X86::VMOVAPDZrm },
  { "vmovapd", X86::VMOVAPDmr },
  { "vmovapd", X86::VMOVAPDZ128mr },
  { "vmovapd", X86::VMOVAPDYmr },
  { "vmovapd", X86::VMOVAPDZ256mr },
  { "vmovapd", X86::VMOVAPDZmr },
  { "vmovapd", X86::VMOVAPDZ128rrk },
  { "vmovapd", X86::VMOVAPDZ128rrk_alt },
  { "vmovapd", X86::VMOVAPDZ128rmk },
  { "vmovapd", X86::VMOVAPDZ256rrk },
  { "vmovapd", X86::VMOVAPDZ256rrk_alt },
  { "vmovapd", X86::VMOVAPDZ256rmk },
  { "vmovapd", X86::VMOVAPDZrrk },
  { "vmovapd", X86::VMOVAPDZrrk_alt },
  { "vmovapd", X86::VMOVAPDZrmk },
  { "vmovapd", X86::VMOVAPDZ128mrk },
  { "vmovapd", X86::VMOVAPDZ256mrk },
  { "vmovapd", X86::VMOVAPDZmrk },
  { "vmovapd", X86::VMOVAPDZ128rrkz },
  { "vmovapd", X86::VMOVAPDZ128rrkz_alt },
  { "vmovapd", X86::VMOVAPDZ128rmkz },
  { "vmovapd", X86::VMOVAPDZ256rrkz },
  { "vmovapd", X86::VMOVAPDZ256rrkz_alt },
  { "vmovapd", X86::VMOVAPDZ256rmkz },
  { "vmovapd", X86::VMOVAPDZrrkz },
  { "vmovapd", X86::VMOVAPDZrrkz_alt },
  { "vmovapd", X86::VMOVAPDZrmkz },
  { "vmovaps", X86::VMOVAPSrr },
  { "vmovaps", X86::VMOVAPSrm },
  { "vmovaps", X86::VMOVAPSZ128rr },
  { "vmovaps", X86::VMOVAPSZ128rr_alt },
  { "vmovaps", X86::VMOVAPSZ128rm },
  { "vmovaps", X86::VMOVAPSYrr },
  { "vmovaps", X86::VMOVAPSYrm },
  { "vmovaps", X86::VMOVAPSZ256rr },
  { "vmovaps", X86::VMOVAPSZ256rr_alt },
  { "vmovaps", X86::VMOVAPSZ256rm },
  { "vmovaps", X86::VMOVAPSZrr },
  { "vmovaps", X86::VMOVAPSZrr_alt },
  { "vmovaps", X86::VMOVAPSZrm },
  { "vmovaps", X86::VMOVAPSmr },
  { "vmovaps", X86::VMOVAPSZ128mr },
  { "vmovaps", X86::VMOVAPSYmr },
  { "vmovaps", X86::VMOVAPSZ256mr },
  { "vmovaps", X86::VMOVAPSZmr },
  { "vmovaps", X86::VMOVAPSZ128rrk },
  { "vmovaps", X86::VMOVAPSZ128rrk_alt },
  { "vmovaps", X86::VMOVAPSZ128rmk },
  { "vmovaps", X86::VMOVAPSZ256rrk },
  { "vmovaps", X86::VMOVAPSZ256rrk_alt },
  { "vmovaps", X86::VMOVAPSZ256rmk },
  { "vmovaps", X86::VMOVAPSZrrk },
  { "vmovaps", X86::VMOVAPSZrrk_alt },
  { "vmovaps", X86::VMOVAPSZrmk },
  { "vmovaps", X86::VMOVAPSZ128mrk },
  { "vmovaps", X86::VMOVAPSZ256mrk },
  { "vmovaps", X86::VMOVAPSZmrk },
  { "vmovaps", X86::VMOVAPSZ128rrkz },
  { "vmovaps", X86::VMOVAPSZ128rrkz_alt },
  { "vmovaps", X86::VMOVAPSZ128rmkz },
  { "vmovaps", X86::VMOVAPSZ256rrkz },
  { "vmovaps", X86::VMOVAPSZ256rrkz_alt },
  { "vmovaps", X86::VMOVAPSZ256rmkz },
  { "vmovaps", X86::VMOVAPSZrrkz },
  { "vmovaps", X86::VMOVAPSZrrkz_alt },
  { "vmovaps", X86::VMOVAPSZrmkz },
  { "vmovd", X86::VMOVPDI2DIrr },
  { "vmovd", X86::VMOVPDI2DIZrr },
  { "vmovd", X86::VMOVPQIto64rr },
  { "vmovd", X86::VMOVDI2PDIrr },
  { "vmovd", X86::VMOV64toPQIrr },
  { "vmovd", X86::VMOVDI2PDIrm },
  { "vmovd", X86::VMOVDI2PDIZrr },
  { "vmovd", X86::VMOVDI2PDIZrm },
  { "vmovd", X86::VMOVPDI2DImr },
  { "vmovd", X86::VMOVPDI2DIZmr },
  { "vmovddup", X86::VMOVDDUPrr },
  { "vmovddup", X86::VMOVDDUPrm },
  { "vmovddup", X86::VMOVDDUPYrr },
  { "vmovddup", X86::VMOVDDUPYrm },
  { "vmovddup", X86::VMOVDDUPZrr },
  { "vmovddup", X86::VMOVDDUPZrm },
  { "vmovdqa", X86::VMOVDQArr },
  { "vmovdqa", X86::VMOVDQArm },
  { "vmovdqa", X86::VMOVDQAYrr },
  { "vmovdqa", X86::VMOVDQAYrm },
  { "vmovdqa", X86::VMOVDQAmr },
  { "vmovdqa", X86::VMOVDQAYmr },
  { "vmovdqa32", X86::VMOVDQA32Z128rr },
  { "vmovdqa32", X86::VMOVDQA32Z128rr_alt },
  { "vmovdqa32", X86::VMOVDQA32Z128rm },
  { "vmovdqa32", X86::VMOVDQA32Z256rr },
  { "vmovdqa32", X86::VMOVDQA32Z256rr_alt },
  { "vmovdqa32", X86::VMOVDQA32Z256rm },
  { "vmovdqa32", X86::VMOVDQA32Zrr },
  { "vmovdqa32", X86::VMOVDQA32Zrr_alt },
  { "vmovdqa32", X86::VMOVDQA32Zrm },
  { "vmovdqa32", X86::VMOVDQA32Z128mr },
  { "vmovdqa32", X86::VMOVDQA32Z256mr },
  { "vmovdqa32", X86::VMOVDQA32Zmr },
  { "vmovdqa32", X86::VMOVDQA32Z128rrk },
  { "vmovdqa32", X86::VMOVDQA32Z128rrk_alt },
  { "vmovdqa32", X86::VMOVDQA32Z128rmk },
  { "vmovdqa32", X86::VMOVDQA32Z256rrk },
  { "vmovdqa32", X86::VMOVDQA32Z256rrk_alt },
  { "vmovdqa32", X86::VMOVDQA32Z256rmk },
  { "vmovdqa32", X86::VMOVDQA32Zrrk },
  { "vmovdqa32", X86::VMOVDQA32Zrrk_alt },
  { "vmovdqa32", X86::VMOVDQA32Zrmk },
  { "vmovdqa32", X86::VMOVDQA32Z128mrk },
  { "vmovdqa32", X86::VMOVDQA32Z256mrk },
  { "vmovdqa32", X86::VMOVDQA32Zmrk },
  { "vmovdqa32", X86::VMOVDQA32Z128rrkz },
  { "vmovdqa32", X86::VMOVDQA32Z128rrkz_alt },
  { "vmovdqa32", X86::VMOVDQA32Z128rmkz },
  { "vmovdqa32", X86::VMOVDQA32Z256rrkz },
  { "vmovdqa32", X86::VMOVDQA32Z256rrkz_alt },
  { "vmovdqa32", X86::VMOVDQA32Z256rmkz },
  { "vmovdqa32", X86::VMOVDQA32Zrrkz },
  { "vmovdqa32", X86::VMOVDQA32Zrrkz_alt },
  { "vmovdqa32", X86::VMOVDQA32Zrmkz },
  { "vmovdqa64", X86::VMOVDQA64Z128rr },
  { "vmovdqa64", X86::VMOVDQA64Z128rr_alt },
  { "vmovdqa64", X86::VMOVDQA64Z128rm },
  { "vmovdqa64", X86::VMOVDQA64Z256rr },
  { "vmovdqa64", X86::VMOVDQA64Z256rr_alt },
  { "vmovdqa64", X86::VMOVDQA64Z256rm },
  { "vmovdqa64", X86::VMOVDQA64Zrr },
  { "vmovdqa64", X86::VMOVDQA64Zrr_alt },
  { "vmovdqa64", X86::VMOVDQA64Zrm },
  { "vmovdqa64", X86::VMOVDQA64Z128mr },
  { "vmovdqa64", X86::VMOVDQA64Z256mr },
  { "vmovdqa64", X86::VMOVDQA64Zmr },
  { "vmovdqa64", X86::VMOVDQA64Z128rrk },
  { "vmovdqa64", X86::VMOVDQA64Z128rrk_alt },
  { "vmovdqa64", X86::VMOVDQA64Z128rmk },
  { "vmovdqa64", X86::VMOVDQA64Z256rrk },
  { "vmovdqa64", X86::VMOVDQA64Z256rrk_alt },
  { "vmovdqa64", X86::VMOVDQA64Z256rmk },
  { "vmovdqa64", X86::VMOVDQA64Zrrk },
  { "vmovdqa64", X86::VMOVDQA64Zrrk_alt },
  { "vmovdqa64", X86::VMOVDQA64Zrmk },
  { "vmovdqa64", X86::VMOVDQA64Z128mrk },
  { "vmovdqa64", X86::VMOVDQA64Z256mrk },
  { "vmovdqa64", X86::VMOVDQA64Zmrk },
  { "vmovdqa64", X86::VMOVDQA64Z128rrkz },
  { "vmovdqa64", X86::VMOVDQA64Z128rrkz_alt },
  { "vmovdqa64", X86::VMOVDQA64Z128rmkz },
  { "vmovdqa64", X86::VMOVDQA64Z256rrkz },
  { "vmovdqa64", X86::VMOVDQA64Z256rrkz_alt },
  { "vmovdqa64", X86::VMOVDQA64Z256rmkz },
  { "vmovdqa64", X86::VMOVDQA64Zrrkz },
  { "vmovdqa64", X86::VMOVDQA64Zrrkz_alt },
  { "vmovdqa64", X86::VMOVDQA64Zrmkz },
  { "vmovdqu", X86::VMOVDQUrr },
  { "vmovdqu", X86::VMOVDQUrm },
  { "vmovdqu", X86::VMOVDQUYrr },
  { "vmovdqu", X86::VMOVDQUYrm },
  { "vmovdqu", X86::VMOVDQUmr },
  { "vmovdqu", X86::VMOVDQUYmr },
  { "vmovdqu16", X86::VMOVDQU16Z128rr },
  { "vmovdqu16", X86::VMOVDQU16Z128rr_alt },
  { "vmovdqu16", X86::VMOVDQU16Z128rm },
  { "vmovdqu16", X86::VMOVDQU16Z256rr },
  { "vmovdqu16", X86::VMOVDQU16Z256rr_alt },
  { "vmovdqu16", X86::VMOVDQU16Z256rm },
  { "vmovdqu16", X86::VMOVDQU16Zrr },
  { "vmovdqu16", X86::VMOVDQU16Zrr_alt },
  { "vmovdqu16", X86::VMOVDQU16Zrm },
  { "vmovdqu16", X86::VMOVDQU16Z128mr },
  { "vmovdqu16", X86::VMOVDQU16Z256mr },
  { "vmovdqu16", X86::VMOVDQU16Zmr },
  { "vmovdqu16", X86::VMOVDQU16Z128rrk },
  { "vmovdqu16", X86::VMOVDQU16Z128rrk_alt },
  { "vmovdqu16", X86::VMOVDQU16Z128rmk },
  { "vmovdqu16", X86::VMOVDQU16Z256rrk },
  { "vmovdqu16", X86::VMOVDQU16Z256rrk_alt },
  { "vmovdqu16", X86::VMOVDQU16Z256rmk },
  { "vmovdqu16", X86::VMOVDQU16Zrrk },
  { "vmovdqu16", X86::VMOVDQU16Zrrk_alt },
  { "vmovdqu16", X86::VMOVDQU16Zrmk },
  { "vmovdqu16", X86::VMOVDQU16Z128mrk },
  { "vmovdqu16", X86::VMOVDQU16Z256mrk },
  { "vmovdqu16", X86::VMOVDQU16Zmrk },
  { "vmovdqu16", X86::VMOVDQU16Z128rrkz },
  { "vmovdqu16", X86::VMOVDQU16Z128rrkz_alt },
  { "vmovdqu16", X86::VMOVDQU16Z128rmkz },
  { "vmovdqu16", X86::VMOVDQU16Z256rrkz },
  { "vmovdqu16", X86::VMOVDQU16Z256rrkz_alt },
  { "vmovdqu16", X86::VMOVDQU16Z256rmkz },
  { "vmovdqu16", X86::VMOVDQU16Zrrkz },
  { "vmovdqu16", X86::VMOVDQU16Zrrkz_alt },
  { "vmovdqu16", X86::VMOVDQU16Zrmkz },
  { "vmovdqu32", X86::VMOVDQU32Z128rr },
  { "vmovdqu32", X86::VMOVDQU32Z128rr_alt },
  { "vmovdqu32", X86::VMOVDQU32Z128rm },
  { "vmovdqu32", X86::VMOVDQU32Z256rr },
  { "vmovdqu32", X86::VMOVDQU32Z256rr_alt },
  { "vmovdqu32", X86::VMOVDQU32Z256rm },
  { "vmovdqu32", X86::VMOVDQU32Zrr },
  { "vmovdqu32", X86::VMOVDQU32Zrr_alt },
  { "vmovdqu32", X86::VMOVDQU32Zrm },
  { "vmovdqu32", X86::VMOVDQU32Z128mr },
  { "vmovdqu32", X86::VMOVDQU32Z256mr },
  { "vmovdqu32", X86::VMOVDQU32Zmr },
  { "vmovdqu32", X86::VMOVDQU32Z128rrk },
  { "vmovdqu32", X86::VMOVDQU32Z128rrk_alt },
  { "vmovdqu32", X86::VMOVDQU32Z128rmk },
  { "vmovdqu32", X86::VMOVDQU32Z256rrk },
  { "vmovdqu32", X86::VMOVDQU32Z256rrk_alt },
  { "vmovdqu32", X86::VMOVDQU32Z256rmk },
  { "vmovdqu32", X86::VMOVDQU32Zrrk },
  { "vmovdqu32", X86::VMOVDQU32Zrrk_alt },
  { "vmovdqu32", X86::VMOVDQU32Zrmk },
  { "vmovdqu32", X86::VMOVDQU32Z128mrk },
  { "vmovdqu32", X86::VMOVDQU32Z256mrk },
  { "vmovdqu32", X86::VMOVDQU32Zmrk },
  { "vmovdqu32", X86::VMOVDQU32Z128rrkz },
  { "vmovdqu32", X86::VMOVDQU32Z128rrkz_alt },
  { "vmovdqu32", X86::VMOVDQU32Z128rmkz },
  { "vmovdqu32", X86::VMOVDQU32Z256rrkz },
  { "vmovdqu32", X86::VMOVDQU32Z256rrkz_alt },
  { "vmovdqu32", X86::VMOVDQU32Z256rmkz },
  { "vmovdqu32", X86::VMOVDQU32Zrrkz },
  { "vmovdqu32", X86::VMOVDQU32Zrrkz_alt },
  { "vmovdqu32", X86::VMOVDQU32Zrmkz },
  { "vmovdqu64", X86::VMOVDQU64Z128rr },
  { "vmovdqu64", X86::VMOVDQU64Z128rr_alt },
  { "vmovdqu64", X86::VMOVDQU64Z128rm },
  { "vmovdqu64", X86::VMOVDQU64Z256rr },
  { "vmovdqu64", X86::VMOVDQU64Z256rr_alt },
  { "vmovdqu64", X86::VMOVDQU64Z256rm },
  { "vmovdqu64", X86::VMOVDQU64Zrr },
  { "vmovdqu64", X86::VMOVDQU64Zrr_alt },
  { "vmovdqu64", X86::VMOVDQU64Zrm },
  { "vmovdqu64", X86::VMOVDQU64Z128mr },
  { "vmovdqu64", X86::VMOVDQU64Z256mr },
  { "vmovdqu64", X86::VMOVDQU64Zmr },
  { "vmovdqu64", X86::VMOVDQU64Z128rrk },
  { "vmovdqu64", X86::VMOVDQU64Z128rrk_alt },
  { "vmovdqu64", X86::VMOVDQU64Z128rmk },
  { "vmovdqu64", X86::VMOVDQU64Z256rrk },
  { "vmovdqu64", X86::VMOVDQU64Z256rrk_alt },
  { "vmovdqu64", X86::VMOVDQU64Z256rmk },
  { "vmovdqu64", X86::VMOVDQU64Zrrk },
  { "vmovdqu64", X86::VMOVDQU64Zrrk_alt },
  { "vmovdqu64", X86::VMOVDQU64Zrmk },
  { "vmovdqu64", X86::VMOVDQU64Z128mrk },
  { "vmovdqu64", X86::VMOVDQU64Z256mrk },
  { "vmovdqu64", X86::VMOVDQU64Zmrk },
  { "vmovdqu64", X86::VMOVDQU64Z128rrkz },
  { "vmovdqu64", X86::VMOVDQU64Z128rrkz_alt },
  { "vmovdqu64", X86::VMOVDQU64Z128rmkz },
  { "vmovdqu64", X86::VMOVDQU64Z256rrkz },
  { "vmovdqu64", X86::VMOVDQU64Z256rrkz_alt },
  { "vmovdqu64", X86::VMOVDQU64Z256rmkz },
  { "vmovdqu64", X86::VMOVDQU64Zrrkz },
  { "vmovdqu64", X86::VMOVDQU64Zrrkz_alt },
  { "vmovdqu64", X86::VMOVDQU64Zrmkz },
  { "vmovdqu8", X86::VMOVDQU8Z128rr },
  { "vmovdqu8", X86::VMOVDQU8Z128rr_alt },
  { "vmovdqu8", X86::VMOVDQU8Z128rm },
  { "vmovdqu8", X86::VMOVDQU8Z256rr },
  { "vmovdqu8", X86::VMOVDQU8Z256rr_alt },
  { "vmovdqu8", X86::VMOVDQU8Z256rm },
  { "vmovdqu8", X86::VMOVDQU8Zrr },
  { "vmovdqu8", X86::VMOVDQU8Zrr_alt },
  { "vmovdqu8", X86::VMOVDQU8Zrm },
  { "vmovdqu8", X86::VMOVDQU8Z128mr },
  { "vmovdqu8", X86::VMOVDQU8Z256mr },
  { "vmovdqu8", X86::VMOVDQU8Zmr },
  { "vmovdqu8", X86::VMOVDQU8Z128rrk },
  { "vmovdqu8", X86::VMOVDQU8Z128rrk_alt },
  { "vmovdqu8", X86::VMOVDQU8Z128rmk },
  { "vmovdqu8", X86::VMOVDQU8Z256rrk },
  { "vmovdqu8", X86::VMOVDQU8Z256rrk_alt },
  { "vmovdqu8", X86::VMOVDQU8Z256rmk },
  { "vmovdqu8", X86::VMOVDQU8Zrrk },
  { "vmovdqu8", X86::VMOVDQU8Zrrk_alt },
  { "vmovdqu8", X86::VMOVDQU8Zrmk },
  { "vmovdqu8", X86::VMOVDQU8Z128mrk },
  { "vmovdqu8", X86::VMOVDQU8Z256mrk },
  { "vmovdqu8", X86::VMOVDQU8Zmrk },
  { "vmovdqu8", X86::VMOVDQU8Z128rrkz },
  { "vmovdqu8", X86::VMOVDQU8Z128rrkz_alt },
  { "vmovdqu8", X86::VMOVDQU8Z128rmkz },
  { "vmovdqu8", X86::VMOVDQU8Z256rrkz },
  { "vmovdqu8", X86::VMOVDQU8Z256rrkz_alt },
  { "vmovdqu8", X86::VMOVDQU8Z256rmkz },
  { "vmovdqu8", X86::VMOVDQU8Zrrkz },
  { "vmovdqu8", X86::VMOVDQU8Zrrkz_alt },
  { "vmovdqu8", X86::VMOVDQU8Zrmkz },
  { "vmovhlps", X86::VMOVHLPSrr },
  { "vmovhlps", X86::VMOVHLPSZrr },
  { "vmovhpd", X86::VMOVHPDmr },
  { "vmovhpd", X86::VMOVHPDrm },
  { "vmovhps", X86::VMOVHPSmr },
  { "vmovhps", X86::VMOVHPSrm },
  { "vmovlhps", X86::VMOVLHPSrr },
  { "vmovlhps", X86::VMOVLHPSZrr },
  { "vmovlpd", X86::VMOVLPDmr },
  { "vmovlpd", X86::VMOVLPDrm },
  { "vmovlps", X86::VMOVLPSmr },
  { "vmovlps", X86::VMOVLPSrm },
  { "vmovmskpd", X86::VMOVMSKPDrr },
  { "vmovmskpd", X86::VMOVMSKPDYrr },
  { "vmovmskps", X86::VMOVMSKPSrr },
  { "vmovmskps", X86::VMOVMSKPSYrr },
  { "vmovntdq", X86::VMOVNTDQmr },
  { "vmovntdq", X86::VMOVNTDQZ128mr },
  { "vmovntdq", X86::VMOVNTDQYmr },
  { "vmovntdq", X86::VMOVNTDQZ256mr },
  { "vmovntdq", X86::VMOVNTDQZmr },
  { "vmovntdqa", X86::VMOVNTDQArm },
  { "vmovntdqa", X86::VMOVNTDQAZ128rm },
  { "vmovntdqa", X86::VMOVNTDQAYrm },
  { "vmovntdqa", X86::VMOVNTDQAZ256rm },
  { "vmovntdqa", X86::VMOVNTDQAZrm },
  { "vmovntpd", X86::VMOVNTPDmr },
  { "vmovntpd", X86::VMOVNTPDZ128mr },
  { "vmovntpd", X86::VMOVNTPDYmr },
  { "vmovntpd", X86::VMOVNTPDZ256mr },
  { "vmovntpd", X86::VMOVNTPDZmr },
  { "vmovntps", X86::VMOVNTPSmr },
  { "vmovntps", X86::VMOVNTPSZ128mr },
  { "vmovntps", X86::VMOVNTPSYmr },
  { "vmovntps", X86::VMOVNTPSZ256mr },
  { "vmovntps", X86::VMOVNTPSZmr },
  { "vmovq", X86::VMOVPQIto64rr },
  { "vmovq", X86::VMOVPQIto64Zrr },
  { "vmovq", X86::VMOV64toPQIrr },
  { "vmovq", X86::VMOVZPQILo2PQIrr },
  { "vmovq", X86::VMOVQI2PQIrm },
  { "vmovq", X86::VMOV64toPQIZrr },
  { "vmovq", X86::VMOVZPQILo2PQIZrr },
  { "vmovq", X86::VMOVZPQILo2PQIZrm },
  { "vmovq", X86::VMOVQI2PQIZrm },
  { "vmovq", X86::VMOVSDto64Zmr },
  { "vmovq", X86::VMOVPQI2QImr },
  { "vmovq", X86::VMOVPQIto64Zmr },
  { "vmovsd", X86::VMOVSDrm },
  { "vmovsd", X86::VMOVSDZrm },
  { "vmovsd", X86::VMOVSDmr },
  { "vmovsd", X86::VMOVSDZmr },
  { "vmovsd", X86::VMOVSDrr },
  { "vmovsd", X86::VMOVSDZrr },
  { "vmovsd", X86::VMOVSDZmrk },
  { "vmovsd", X86::VMOVSDZrrk },
  { "vmovshdup", X86::VMOVSHDUPrr },
  { "vmovshdup", X86::VMOVSHDUPrm },
  { "vmovshdup", X86::VMOVSHDUPYrr },
  { "vmovshdup", X86::VMOVSHDUPYrm },
  { "vmovshdup", X86::VMOVSHDUPZrr },
  { "vmovshdup", X86::VMOVSHDUPZrm },
  { "vmovsldup", X86::VMOVSLDUPrr },
  { "vmovsldup", X86::VMOVSLDUPrm },
  { "vmovsldup", X86::VMOVSLDUPYrr },
  { "vmovsldup", X86::VMOVSLDUPYrm },
  { "vmovsldup", X86::VMOVSLDUPZrr },
  { "vmovsldup", X86::VMOVSLDUPZrm },
  { "vmovss", X86::VMOVSSrm },
  { "vmovss", X86::VMOVSSZrm },
  { "vmovss", X86::VMOVSSmr },
  { "vmovss", X86::VMOVSSZmr },
  { "vmovss", X86::VMOVSSrr },
  { "vmovss", X86::VMOVSSZrr },
  { "vmovss", X86::VMOVSSZmrk },
  { "vmovss", X86::VMOVSSZrrk },
  { "vmovupd", X86::VMOVUPDrr },
  { "vmovupd", X86::VMOVUPDrm },
  { "vmovupd", X86::VMOVUPDZ128rr },
  { "vmovupd", X86::VMOVUPDZ128rr_alt },
  { "vmovupd", X86::VMOVUPDZ128rm },
  { "vmovupd", X86::VMOVUPDYrr },
  { "vmovupd", X86::VMOVUPDYrm },
  { "vmovupd", X86::VMOVUPDZ256rr },
  { "vmovupd", X86::VMOVUPDZ256rr_alt },
  { "vmovupd", X86::VMOVUPDZ256rm },
  { "vmovupd", X86::VMOVUPDZrr },
  { "vmovupd", X86::VMOVUPDZrr_alt },
  { "vmovupd", X86::VMOVUPDZrm },
  { "vmovupd", X86::VMOVUPDmr },
  { "vmovupd", X86::VMOVUPDZ128mr },
  { "vmovupd", X86::VMOVUPDYmr },
  { "vmovupd", X86::VMOVUPDZ256mr },
  { "vmovupd", X86::VMOVUPDZmr },
  { "vmovupd", X86::VMOVUPDZ128rrk },
  { "vmovupd", X86::VMOVUPDZ128rrk_alt },
  { "vmovupd", X86::VMOVUPDZ128rmk },
  { "vmovupd", X86::VMOVUPDZ256rrk },
  { "vmovupd", X86::VMOVUPDZ256rrk_alt },
  { "vmovupd", X86::VMOVUPDZ256rmk },
  { "vmovupd", X86::VMOVUPDZrrk },
  { "vmovupd", X86::VMOVUPDZrrk_alt },
  { "vmovupd", X86::VMOVUPDZrmk },
  { "vmovupd", X86::VMOVUPDZ128mrk },
  { "vmovupd", X86::VMOVUPDZ256mrk },
  { "vmovupd", X86::VMOVUPDZmrk },
  { "vmovupd", X86::VMOVUPDZ128rrkz },
  { "vmovupd", X86::VMOVUPDZ128rrkz_alt },
  { "vmovupd", X86::VMOVUPDZ128rmkz },
  { "vmovupd", X86::VMOVUPDZ256rrkz },
  { "vmovupd", X86::VMOVUPDZ256rrkz_alt },
  { "vmovupd", X86::VMOVUPDZ256rmkz },
  { "vmovupd", X86::VMOVUPDZrrkz },
  { "vmovupd", X86::VMOVUPDZrrkz_alt },
  { "vmovupd", X86::VMOVUPDZrmkz },
  { "vmovups", X86::VMOVUPSrr },
  { "vmovups", X86::VMOVUPSrm },
  { "vmovups", X86::VMOVUPSZ128rr },
  { "vmovups", X86::VMOVUPSZ128rr_alt },
  { "vmovups", X86::VMOVUPSZ128rm },
  { "vmovups", X86::VMOVUPSYrr },
  { "vmovups", X86::VMOVUPSYrm },
  { "vmovups", X86::VMOVUPSZ256rr },
  { "vmovups", X86::VMOVUPSZ256rr_alt },
  { "vmovups", X86::VMOVUPSZ256rm },
  { "vmovups", X86::VMOVUPSZrr },
  { "vmovups", X86::VMOVUPSZrr_alt },
  { "vmovups", X86::VMOVUPSZrm },
  { "vmovups", X86::VMOVUPSmr },
  { "vmovups", X86::VMOVUPSZ128mr },
  { "vmovups", X86::VMOVUPSYmr },
  { "vmovups", X86::VMOVUPSZ256mr },
  { "vmovups", X86::VMOVUPSZmr },
  { "vmovups", X86::VMOVUPSZ128rrk },
  { "vmovups", X86::VMOVUPSZ128rrk_alt },
  { "vmovups", X86::VMOVUPSZ128rmk },
  { "vmovups", X86::VMOVUPSZ256rrk },
  { "vmovups", X86::VMOVUPSZ256rrk_alt },
  { "vmovups", X86::VMOVUPSZ256rmk },
  { "vmovups", X86::VMOVUPSZrrk },
  { "vmovups", X86::VMOVUPSZrrk_alt },
  { "vmovups", X86::VMOVUPSZrmk },
  { "vmovups", X86::VMOVUPSZ128mrk },
  { "vmovups", X86::VMOVUPSZ256mrk },
  { "vmovups", X86::VMOVUPSZmrk },
  { "vmovups", X86::VMOVUPSZ128rrkz },
  { "vmovups", X86::VMOVUPSZ128rrkz_alt },
  { "vmovups", X86::VMOVUPSZ128rmkz },
  { "vmovups", X86::VMOVUPSZ256rrkz },
  { "vmovups", X86::VMOVUPSZ256rrkz_alt },
  { "vmovups", X86::VMOVUPSZ256rmkz },
  { "vmovups", X86::VMOVUPSZrrkz },
  { "vmovups", X86::VMOVUPSZrrkz_alt },
  { "vmovups", X86::VMOVUPSZrmkz },
  { "vmpsadbw", X86::VMPSADBWrri },
  { "vmpsadbw", X86::VMPSADBWrmi },
  { "vmpsadbw", X86::VMPSADBWYrri },
  { "vmpsadbw", X86::VMPSADBWYrmi },
  { "vmptrld", X86::VMPTRLDm },
  { "vmptrst", X86::VMPTRSTm },
  { "vmread", X86::VMREAD32rr },
  { "vmread", X86::VMREAD64rr },
  { "vmread", X86::VMREAD32rm },
  { "vmread", X86::VMREAD64rm },
  { "vmresume", X86::VMRESUME },
  { "vmrun", X86::VMRUN32 },
  { "vmrun", X86::VMRUN64 },
  { "vmsave", X86::VMSAVE32 },
  { "vmsave", X86::VMSAVE64 },
  { "vmulpd", X86::VMULPDrr },
  { "vmulpd", X86::VMULPDrm },
  { "vmulpd", X86::VMULPDYrr },
  { "vmulpd", X86::VMULPDYrm },
  { "vmulpd", X86::VMULPDZrr },
  { "vmulpd", X86::VMULPDZrm },
  { "vmulpd", X86::VMULPDZrmb },
  { "vmulpd", X86::VMULPDZrrk },
  { "vmulpd", X86::VMULPDZrmk },
  { "vmulpd", X86::VMULPDZrrkz },
  { "vmulpd", X86::VMULPDZrmkz },
  { "vmulpd", X86::VMULPDZrmbk },
  { "vmulpd", X86::VMULPDZrmbkz },
  { "vmulps", X86::VMULPSrr },
  { "vmulps", X86::VMULPSrm },
  { "vmulps", X86::VMULPSYrr },
  { "vmulps", X86::VMULPSYrm },
  { "vmulps", X86::VMULPSZrr },
  { "vmulps", X86::VMULPSZrm },
  { "vmulps", X86::VMULPSZrmb },
  { "vmulps", X86::VMULPSZrrk },
  { "vmulps", X86::VMULPSZrmk },
  { "vmulps", X86::VMULPSZrrkz },
  { "vmulps", X86::VMULPSZrmkz },
  { "vmulps", X86::VMULPSZrmbk },
  { "vmulps", X86::VMULPSZrmbkz },
  { "vmulsd", X86::VMULSDrr },
  { "vmulsd", X86::VMULSDrm },
  { "vmulsd", X86::VMULSDZrr },
  { "vmulsd", X86::VMULSDZrm },
  { "vmulss", X86::VMULSSrr },
  { "vmulss", X86::VMULSSrm },
  { "vmulss", X86::VMULSSZrr },
  { "vmulss", X86::VMULSSZrm },
  { "vmwrite", X86::VMWRITE32rr },
  { "vmwrite", X86::VMWRITE32rm },
  { "vmwrite", X86::VMWRITE64rr },
  { "vmwrite", X86::VMWRITE64rm },
  { "vmxoff", X86::VMXOFF },
  { "vmxon", X86::VMXON },
  { "vorpd", X86::VORPDrr },
  { "vorpd", X86::VORPDrm },
  { "vorpd", X86::VORPDYrr },
  { "vorpd", X86::VORPDYrm },
  { "vorps", X86::VORPSrr },
  { "vorps", X86::VORPSrm },
  { "vorps", X86::VORPSYrr },
  { "vorps", X86::VORPSYrm },
  { "vpabsb", X86::VPABSBrr128 },
  { "vpabsb", X86::VPABSBrm128 },
  { "vpabsb", X86::VPABSBrr256 },
  { "vpabsb", X86::VPABSBrm256 },
  { "vpabsd", X86::VPABSDrr128 },
  { "vpabsd", X86::VPABSDrm128 },
  { "vpabsd", X86::VPABSDrr256 },
  { "vpabsd", X86::VPABSDrm256 },
  { "vpabsd", X86::VPABSDZrr },
  { "vpabsd", X86::VPABSDZrm },
  { "vpabsd", X86::VPABSDZrmb },
  { "vpabsd", X86::VPABSDZrrk },
  { "vpabsd", X86::VPABSDZrmk },
  { "vpabsd", X86::VPABSDZrrkz },
  { "vpabsd", X86::VPABSDZrmkz },
  { "vpabsd", X86::VPABSDZrmbk },
  { "vpabsd", X86::VPABSDZrmbkz },
  { "vpabsq", X86::VPABSQZrr },
  { "vpabsq", X86::VPABSQZrm },
  { "vpabsq", X86::VPABSQZrmb },
  { "vpabsq", X86::VPABSQZrrk },
  { "vpabsq", X86::VPABSQZrmk },
  { "vpabsq", X86::VPABSQZrrkz },
  { "vpabsq", X86::VPABSQZrmkz },
  { "vpabsq", X86::VPABSQZrmbk },
  { "vpabsq", X86::VPABSQZrmbkz },
  { "vpabsw", X86::VPABSWrr128 },
  { "vpabsw", X86::VPABSWrm128 },
  { "vpabsw", X86::VPABSWrr256 },
  { "vpabsw", X86::VPABSWrm256 },
  { "vpackssdw", X86::VPACKSSDWrr },
  { "vpackssdw", X86::VPACKSSDWrm },
  { "vpackssdw", X86::VPACKSSDWYrr },
  { "vpackssdw", X86::VPACKSSDWYrm },
  { "vpacksswb", X86::VPACKSSWBrr },
  { "vpacksswb", X86::VPACKSSWBrm },
  { "vpacksswb", X86::VPACKSSWBYrr },
  { "vpacksswb", X86::VPACKSSWBYrm },
  { "vpackusdw", X86::VPACKUSDWrr },
  { "vpackusdw", X86::VPACKUSDWrm },
  { "vpackusdw", X86::VPACKUSDWYrr },
  { "vpackusdw", X86::VPACKUSDWYrm },
  { "vpackuswb", X86::VPACKUSWBrr },
  { "vpackuswb", X86::VPACKUSWBrm },
  { "vpackuswb", X86::VPACKUSWBYrr },
  { "vpackuswb", X86::VPACKUSWBYrm },
  { "vpaddb", X86::VPADDBrr },
  { "vpaddb", X86::VPADDBrm },
  { "vpaddb", X86::VPADDBYrr },
  { "vpaddb", X86::VPADDBYrm },
  { "vpaddd", X86::VPADDDrr },
  { "vpaddd", X86::VPADDDrm },
  { "vpaddd", X86::VPADDDYrr },
  { "vpaddd", X86::VPADDDYrm },
  { "vpaddd", X86::VPADDDZrr },
  { "vpaddd", X86::VPADDDZrm },
  { "vpaddd", X86::VPADDDZrmb },
  { "vpaddd", X86::VPADDDZrrk },
  { "vpaddd", X86::VPADDDZrmk },
  { "vpaddd", X86::VPADDDZrrkz },
  { "vpaddd", X86::VPADDDZrmkz },
  { "vpaddd", X86::VPADDDZrmbk },
  { "vpaddd", X86::VPADDDZrmbkz },
  { "vpaddq", X86::VPADDQrr },
  { "vpaddq", X86::VPADDQrm },
  { "vpaddq", X86::VPADDQYrr },
  { "vpaddq", X86::VPADDQYrm },
  { "vpaddq", X86::VPADDQZrr },
  { "vpaddq", X86::VPADDQZrm },
  { "vpaddq", X86::VPADDQZrmb },
  { "vpaddq", X86::VPADDQZrrk },
  { "vpaddq", X86::VPADDQZrmk },
  { "vpaddq", X86::VPADDQZrrkz },
  { "vpaddq", X86::VPADDQZrmkz },
  { "vpaddq", X86::VPADDQZrmbk },
  { "vpaddq", X86::VPADDQZrmbkz },
  { "vpaddsb", X86::VPADDSBrr },
  { "vpaddsb", X86::VPADDSBrm },
  { "vpaddsb", X86::VPADDSBYrr },
  { "vpaddsb", X86::VPADDSBYrm },
  { "vpaddsw", X86::VPADDSWrr },
  { "vpaddsw", X86::VPADDSWrm },
  { "vpaddsw", X86::VPADDSWYrr },
  { "vpaddsw", X86::VPADDSWYrm },
  { "vpaddusb", X86::VPADDUSBrr },
  { "vpaddusb", X86::VPADDUSBrm },
  { "vpaddusb", X86::VPADDUSBYrr },
  { "vpaddusb", X86::VPADDUSBYrm },
  { "vpaddusw", X86::VPADDUSWrr },
  { "vpaddusw", X86::VPADDUSWrm },
  { "vpaddusw", X86::VPADDUSWYrr },
  { "vpaddusw", X86::VPADDUSWYrm },
  { "vpaddw", X86::VPADDWrr },
  { "vpaddw", X86::VPADDWrm },
  { "vpaddw", X86::VPADDWYrr },
  { "vpaddw", X86::VPADDWYrm },
  { "vpalignr", X86::VPALIGNR128rr },
  { "vpalignr", X86::VPALIGNR128rm },
  { "vpalignr", X86::VPALIGNR256rr },
  { "vpalignr", X86::VPALIGNR256rm },
  { "vpand", X86::VPANDrr },
  { "vpand", X86::VPANDrm },
  { "vpand", X86::VPANDYrr },
  { "vpand", X86::VPANDYrm },
  { "vpandd", X86::VPANDDZrr },
  { "vpandd", X86::VPANDDZrm },
  { "vpandd", X86::VPANDDZrmb },
  { "vpandd", X86::VPANDDZrrk },
  { "vpandd", X86::VPANDDZrmk },
  { "vpandd", X86::VPANDDZrrkz },
  { "vpandd", X86::VPANDDZrmkz },
  { "vpandd", X86::VPANDDZrmbk },
  { "vpandd", X86::VPANDDZrmbkz },
  { "vpandn", X86::VPANDNrr },
  { "vpandn", X86::VPANDNrm },
  { "vpandn", X86::VPANDNYrr },
  { "vpandn", X86::VPANDNYrm },
  { "vpandnd", X86::VPANDNDZrr },
  { "vpandnd", X86::VPANDNDZrm },
  { "vpandnd", X86::VPANDNDZrmb },
  { "vpandnd", X86::VPANDNDZrrk },
  { "vpandnd", X86::VPANDNDZrmk },
  { "vpandnd", X86::VPANDNDZrrkz },
  { "vpandnd", X86::VPANDNDZrmkz },
  { "vpandnd", X86::VPANDNDZrmbk },
  { "vpandnd", X86::VPANDNDZrmbkz },
  { "vpandnq", X86::VPANDNQZrr },
  { "vpandnq", X86::VPANDNQZrm },
  { "vpandnq", X86::VPANDNQZrmb },
  { "vpandnq", X86::VPANDNQZrrk },
  { "vpandnq", X86::VPANDNQZrmk },
  { "vpandnq", X86::VPANDNQZrrkz },
  { "vpandnq", X86::VPANDNQZrmkz },
  { "vpandnq", X86::VPANDNQZrmbk },
  { "vpandnq", X86::VPANDNQZrmbkz },
  { "vpandq", X86::VPANDQZrr },
  { "vpandq", X86::VPANDQZrm },
  { "vpandq", X86::VPANDQZrmb },
  { "vpandq", X86::VPANDQZrrk },
  { "vpandq", X86::VPANDQZrmk },
  { "vpandq", X86::VPANDQZrrkz },
  { "vpandq", X86::VPANDQZrmkz },
  { "vpandq", X86::VPANDQZrmbk },
  { "vpandq", X86::VPANDQZrmbkz },
  { "vpavgb", X86::VPAVGBrr },
  { "vpavgb", X86::VPAVGBrm },
  { "vpavgb", X86::VPAVGBYrr },
  { "vpavgb", X86::VPAVGBYrm },
  { "vpavgw", X86::VPAVGWrr },
  { "vpavgw", X86::VPAVGWrm },
  { "vpavgw", X86::VPAVGWYrr },
  { "vpavgw", X86::VPAVGWYrm },
  { "vpblendd", X86::VPBLENDDrri },
  { "vpblendd", X86::VPBLENDDrmi },
  { "vpblendd", X86::VPBLENDDYrri },
  { "vpblendd", X86::VPBLENDDYrmi },
  { "vpblendmd", X86::VPBLENDMDZrr },
  { "vpblendmd", X86::VPBLENDMDZrm },
  { "vpblendmq", X86::VPBLENDMQZrr },
  { "vpblendmq", X86::VPBLENDMQZrm },
  { "vpblendvb", X86::VPBLENDVBrr },
  { "vpblendvb", X86::VPBLENDVBrm },
  { "vpblendvb", X86::VPBLENDVBYrr },
  { "vpblendvb", X86::VPBLENDVBYrm },
  { "vpblendw", X86::VPBLENDWrri },
  { "vpblendw", X86::VPBLENDWrmi },
  { "vpblendw", X86::VPBLENDWYrri },
  { "vpblendw", X86::VPBLENDWYrmi },
  { "vpbroadcastb", X86::VPBROADCASTBrr },
  { "vpbroadcastb", X86::VPBROADCASTBrm },
  { "vpbroadcastb", X86::VPBROADCASTBYrr },
  { "vpbroadcastb", X86::VPBROADCASTBYrm },
  { "vpbroadcastd", X86::VPBROADCASTDrr },
  { "vpbroadcastd", X86::VPBROADCASTDrm },
  { "vpbroadcastd", X86::VPBROADCASTDYrr },
  { "vpbroadcastd", X86::VPBROADCASTDYrm },
  { "vpbroadcastd", X86::VPBROADCASTDrZrr },
  { "vpbroadcastd", X86::VPBROADCASTDZrr },
  { "vpbroadcastd", X86::VPBROADCASTDZrm },
  { "vpbroadcastd", X86::VPBROADCASTDrZkrr },
  { "vpbroadcastd", X86::VPBROADCASTDZkrr },
  { "vpbroadcastd", X86::VPBROADCASTDZkrm },
  { "vpbroadcastmb2q", X86::VPBROADCASTMB2Qrr },
  { "vpbroadcastmw2d", X86::VPBROADCASTMW2Drr },
  { "vpbroadcastq", X86::VPBROADCASTQrr },
  { "vpbroadcastq", X86::VPBROADCASTQrm },
  { "vpbroadcastq", X86::VPBROADCASTQYrr },
  { "vpbroadcastq", X86::VPBROADCASTQYrm },
  { "vpbroadcastq", X86::VPBROADCASTQrZrr },
  { "vpbroadcastq", X86::VPBROADCASTQZrr },
  { "vpbroadcastq", X86::VPBROADCASTQZrm },
  { "vpbroadcastq", X86::VPBROADCASTQrZkrr },
  { "vpbroadcastq", X86::VPBROADCASTQZkrr },
  { "vpbroadcastq", X86::VPBROADCASTQZkrm },
  { "vpbroadcastw", X86::VPBROADCASTWrr },
  { "vpbroadcastw", X86::VPBROADCASTWrm },
  { "vpbroadcastw", X86::VPBROADCASTWYrr },
  { "vpbroadcastw", X86::VPBROADCASTWYrm },
  { "vpclmulhqhqdq", X86::VPCLMULQDQrr },
  { "vpclmulhqhqdq", X86::VPCLMULQDQrm },
  { "vpclmulhqlqdq", X86::VPCLMULQDQrr },
  { "vpclmulhqlqdq", X86::VPCLMULQDQrm },
  { "vpclmullqhqdq", X86::VPCLMULQDQrr },
  { "vpclmullqhqdq", X86::VPCLMULQDQrm },
  { "vpclmullqlqdq", X86::VPCLMULQDQrr },
  { "vpclmullqlqdq", X86::VPCLMULQDQrm },
  { "vpclmulqdq", X86::VPCLMULQDQrr },
  { "vpclmulqdq", X86::VPCLMULQDQrm },
  { "vpcmov", X86::VPCMOVrr },
  { "vpcmov", X86::VPCMOVrm },
  { "vpcmov", X86::VPCMOVmr },
  { "vpcmov", X86::VPCMOVrrY },
  { "vpcmov", X86::VPCMOVrmY },
  { "vpcmov", X86::VPCMOVmrY },
  { "vpcmp", X86::VPCMPBZ128rri },
  { "vpcmp", X86::VPCMPBZ128rmi },
  { "vpcmp", X86::VPCMPBZ256rri },
  { "vpcmp", X86::VPCMPBZ256rmi },
  { "vpcmp", X86::VPCMPBZrri },
  { "vpcmp", X86::VPCMPBZrmi },
  { "vpcmp", X86::VPCMPDZ128rri },
  { "vpcmp", X86::VPCMPDZ128rmi },
  { "vpcmp", X86::VPCMPDZ256rri },
  { "vpcmp", X86::VPCMPDZ256rmi },
  { "vpcmp", X86::VPCMPDZrri },
  { "vpcmp", X86::VPCMPDZrmi },
  { "vpcmp", X86::VPCMPQZ128rri },
  { "vpcmp", X86::VPCMPQZ128rmi },
  { "vpcmp", X86::VPCMPQZ256rri },
  { "vpcmp", X86::VPCMPQZ256rmi },
  { "vpcmp", X86::VPCMPQZrri },
  { "vpcmp", X86::VPCMPQZrmi },
  { "vpcmp", X86::VPCMPUBZ128rri },
  { "vpcmp", X86::VPCMPUBZ128rmi },
  { "vpcmp", X86::VPCMPUBZ256rri },
  { "vpcmp", X86::VPCMPUBZ256rmi },
  { "vpcmp", X86::VPCMPUBZrri },
  { "vpcmp", X86::VPCMPUBZrmi },
  { "vpcmp", X86::VPCMPUDZ128rri },
  { "vpcmp", X86::VPCMPUDZ128rmi },
  { "vpcmp", X86::VPCMPUDZ256rri },
  { "vpcmp", X86::VPCMPUDZ256rmi },
  { "vpcmp", X86::VPCMPUDZrri },
  { "vpcmp", X86::VPCMPUDZrmi },
  { "vpcmp", X86::VPCMPUQZ128rri },
  { "vpcmp", X86::VPCMPUQZ128rmi },
  { "vpcmp", X86::VPCMPUQZ256rri },
  { "vpcmp", X86::VPCMPUQZ256rmi },
  { "vpcmp", X86::VPCMPUQZrri },
  { "vpcmp", X86::VPCMPUQZrmi },
  { "vpcmp", X86::VPCMPUWZ128rri },
  { "vpcmp", X86::VPCMPUWZ128rmi },
  { "vpcmp", X86::VPCMPUWZ256rri },
  { "vpcmp", X86::VPCMPUWZ256rmi },
  { "vpcmp", X86::VPCMPUWZrri },
  { "vpcmp", X86::VPCMPUWZrmi },
  { "vpcmp", X86::VPCMPWZ128rri },
  { "vpcmp", X86::VPCMPWZ128rmi },
  { "vpcmp", X86::VPCMPWZ256rri },
  { "vpcmp", X86::VPCMPWZ256rmi },
  { "vpcmp", X86::VPCMPWZrri },
  { "vpcmp", X86::VPCMPWZrmi },
  { "vpcmp", X86::VPCMPDZ128rmib },
  { "vpcmp", X86::VPCMPDZ256rmib },
  { "vpcmp", X86::VPCMPDZrmib },
  { "vpcmp", X86::VPCMPQZ128rmib },
  { "vpcmp", X86::VPCMPQZ256rmib },
  { "vpcmp", X86::VPCMPQZrmib },
  { "vpcmp", X86::VPCMPUDZ128rmib },
  { "vpcmp", X86::VPCMPUDZ256rmib },
  { "vpcmp", X86::VPCMPUDZrmib },
  { "vpcmp", X86::VPCMPUQZ128rmib },
  { "vpcmp", X86::VPCMPUQZ256rmib },
  { "vpcmp", X86::VPCMPUQZrmib },
  { "vpcmp", X86::VPCMPBZ128rrik },
  { "vpcmp", X86::VPCMPBZ128rmik },
  { "vpcmp", X86::VPCMPBZ256rrik },
  { "vpcmp", X86::VPCMPBZ256rmik },
  { "vpcmp", X86::VPCMPBZrrik },
  { "vpcmp", X86::VPCMPBZrmik },
  { "vpcmp", X86::VPCMPDZ128rrik },
  { "vpcmp", X86::VPCMPDZ128rmik },
  { "vpcmp", X86::VPCMPDZ256rrik },
  { "vpcmp", X86::VPCMPDZ256rmik },
  { "vpcmp", X86::VPCMPDZrrik },
  { "vpcmp", X86::VPCMPDZrmik },
  { "vpcmp", X86::VPCMPQZ128rrik },
  { "vpcmp", X86::VPCMPQZ128rmik },
  { "vpcmp", X86::VPCMPQZ256rrik },
  { "vpcmp", X86::VPCMPQZ256rmik },
  { "vpcmp", X86::VPCMPQZrrik },
  { "vpcmp", X86::VPCMPQZrmik },
  { "vpcmp", X86::VPCMPUBZ128rrik },
  { "vpcmp", X86::VPCMPUBZ128rmik },
  { "vpcmp", X86::VPCMPUBZ256rrik },
  { "vpcmp", X86::VPCMPUBZ256rmik },
  { "vpcmp", X86::VPCMPUBZrrik },
  { "vpcmp", X86::VPCMPUBZrmik },
  { "vpcmp", X86::VPCMPUDZ128rrik },
  { "vpcmp", X86::VPCMPUDZ128rmik },
  { "vpcmp", X86::VPCMPUDZ256rrik },
  { "vpcmp", X86::VPCMPUDZ256rmik },
  { "vpcmp", X86::VPCMPUDZrrik },
  { "vpcmp", X86::VPCMPUDZrmik },
  { "vpcmp", X86::VPCMPUQZ128rrik },
  { "vpcmp", X86::VPCMPUQZ128rmik },
  { "vpcmp", X86::VPCMPUQZ256rrik },
  { "vpcmp", X86::VPCMPUQZ256rmik },
  { "vpcmp", X86::VPCMPUQZrrik },
  { "vpcmp", X86::VPCMPUQZrmik },
  { "vpcmp", X86::VPCMPUWZ128rrik },
  { "vpcmp", X86::VPCMPUWZ128rmik },
  { "vpcmp", X86::VPCMPUWZ256rrik },
  { "vpcmp", X86::VPCMPUWZ256rmik },
  { "vpcmp", X86::VPCMPUWZrrik },
  { "vpcmp", X86::VPCMPUWZrmik },
  { "vpcmp", X86::VPCMPWZ128rrik },
  { "vpcmp", X86::VPCMPWZ128rmik },
  { "vpcmp", X86::VPCMPWZ256rrik },
  { "vpcmp", X86::VPCMPWZ256rmik },
  { "vpcmp", X86::VPCMPWZrrik },
  { "vpcmp", X86::VPCMPWZrmik },
  { "vpcmp", X86::VPCMPDZ128rmibk },
  { "vpcmp", X86::VPCMPDZ256rmibk },
  { "vpcmp", X86::VPCMPDZrmibk },
  { "vpcmp", X86::VPCMPQZ128rmibk },
  { "vpcmp", X86::VPCMPQZ256rmibk },
  { "vpcmp", X86::VPCMPQZrmibk },
  { "vpcmp", X86::VPCMPUDZ128rmibk },
  { "vpcmp", X86::VPCMPUDZ256rmibk },
  { "vpcmp", X86::VPCMPUDZrmibk },
  { "vpcmp", X86::VPCMPUQZ128rmibk },
  { "vpcmp", X86::VPCMPUQZ256rmibk },
  { "vpcmp", X86::VPCMPUQZrmibk },
  { "vpcmpb", X86::VPCMPBZ128rri_alt },
  { "vpcmpb", X86::VPCMPBZ128rmi_alt },
  { "vpcmpb", X86::VPCMPBZ256rri_alt },
  { "vpcmpb", X86::VPCMPBZ256rmi_alt },
  { "vpcmpb", X86::VPCMPBZrri_alt },
  { "vpcmpb", X86::VPCMPBZrmi_alt },
  { "vpcmpb", X86::VPCMPBZ128rrik_alt },
  { "vpcmpb", X86::VPCMPBZ128rmik_alt },
  { "vpcmpb", X86::VPCMPBZ256rrik_alt },
  { "vpcmpb", X86::VPCMPBZ256rmik_alt },
  { "vpcmpb", X86::VPCMPBZrrik_alt },
  { "vpcmpb", X86::VPCMPBZrmik_alt },
  { "vpcmpd", X86::VPCMPDZ128rri_alt },
  { "vpcmpd", X86::VPCMPDZ128rmi_alt },
  { "vpcmpd", X86::VPCMPDZ256rri_alt },
  { "vpcmpd", X86::VPCMPDZ256rmi_alt },
  { "vpcmpd", X86::VPCMPDZrri_alt },
  { "vpcmpd", X86::VPCMPDZrmi_alt },
  { "vpcmpd", X86::VPCMPDZ128rmib_alt },
  { "vpcmpd", X86::VPCMPDZ256rmib_alt },
  { "vpcmpd", X86::VPCMPDZrmib_alt },
  { "vpcmpd", X86::VPCMPDZ128rrik_alt },
  { "vpcmpd", X86::VPCMPDZ128rmik_alt },
  { "vpcmpd", X86::VPCMPDZ256rrik_alt },
  { "vpcmpd", X86::VPCMPDZ256rmik_alt },
  { "vpcmpd", X86::VPCMPDZrrik_alt },
  { "vpcmpd", X86::VPCMPDZrmik_alt },
  { "vpcmpd", X86::VPCMPDZ128rmibk_alt },
  { "vpcmpd", X86::VPCMPDZ256rmibk_alt },
  { "vpcmpd", X86::VPCMPDZrmibk_alt },
  { "vpcmpeqb", X86::VPCMPEQBrr },
  { "vpcmpeqb", X86::VPCMPEQBrm },
  { "vpcmpeqb", X86::VPCMPEQBYrr },
  { "vpcmpeqb", X86::VPCMPEQBYrm },
  { "vpcmpeqb", X86::VPCMPEQBZ128rr },
  { "vpcmpeqb", X86::VPCMPEQBZ128rm },
  { "vpcmpeqb", X86::VPCMPEQBZ256rr },
  { "vpcmpeqb", X86::VPCMPEQBZ256rm },
  { "vpcmpeqb", X86::VPCMPEQBZrr },
  { "vpcmpeqb", X86::VPCMPEQBZrm },
  { "vpcmpeqb", X86::VPCMPEQBZ128rrk },
  { "vpcmpeqb", X86::VPCMPEQBZ128rmk },
  { "vpcmpeqb", X86::VPCMPEQBZ256rrk },
  { "vpcmpeqb", X86::VPCMPEQBZ256rmk },
  { "vpcmpeqb", X86::VPCMPEQBZrrk },
  { "vpcmpeqb", X86::VPCMPEQBZrmk },
  { "vpcmpeqd", X86::VPCMPEQDrr },
  { "vpcmpeqd", X86::VPCMPEQDrm },
  { "vpcmpeqd", X86::VPCMPEQDYrr },
  { "vpcmpeqd", X86::VPCMPEQDYrm },
  { "vpcmpeqd", X86::VPCMPEQDZ128rr },
  { "vpcmpeqd", X86::VPCMPEQDZ128rm },
  { "vpcmpeqd", X86::VPCMPEQDZ256rr },
  { "vpcmpeqd", X86::VPCMPEQDZ256rm },
  { "vpcmpeqd", X86::VPCMPEQDZrr },
  { "vpcmpeqd", X86::VPCMPEQDZrm },
  { "vpcmpeqd", X86::VPCMPEQDZ128rmb },
  { "vpcmpeqd", X86::VPCMPEQDZ256rmb },
  { "vpcmpeqd", X86::VPCMPEQDZrmb },
  { "vpcmpeqd", X86::VPCMPEQDZ128rrk },
  { "vpcmpeqd", X86::VPCMPEQDZ128rmk },
  { "vpcmpeqd", X86::VPCMPEQDZ256rrk },
  { "vpcmpeqd", X86::VPCMPEQDZ256rmk },
  { "vpcmpeqd", X86::VPCMPEQDZrrk },
  { "vpcmpeqd", X86::VPCMPEQDZrmk },
  { "vpcmpeqd", X86::VPCMPEQDZ128rmbk },
  { "vpcmpeqd", X86::VPCMPEQDZ256rmbk },
  { "vpcmpeqd", X86::VPCMPEQDZrmbk },
  { "vpcmpeqq", X86::VPCMPEQQrr },
  { "vpcmpeqq", X86::VPCMPEQQrm },
  { "vpcmpeqq", X86::VPCMPEQQYrr },
  { "vpcmpeqq", X86::VPCMPEQQYrm },
  { "vpcmpeqq", X86::VPCMPEQQZ128rr },
  { "vpcmpeqq", X86::VPCMPEQQZ128rm },
  { "vpcmpeqq", X86::VPCMPEQQZ256rr },
  { "vpcmpeqq", X86::VPCMPEQQZ256rm },
  { "vpcmpeqq", X86::VPCMPEQQZrr },
  { "vpcmpeqq", X86::VPCMPEQQZrm },
  { "vpcmpeqq", X86::VPCMPEQQZ128rmb },
  { "vpcmpeqq", X86::VPCMPEQQZ256rmb },
  { "vpcmpeqq", X86::VPCMPEQQZrmb },
  { "vpcmpeqq", X86::VPCMPEQQZ128rrk },
  { "vpcmpeqq", X86::VPCMPEQQZ128rmk },
  { "vpcmpeqq", X86::VPCMPEQQZ256rrk },
  { "vpcmpeqq", X86::VPCMPEQQZ256rmk },
  { "vpcmpeqq", X86::VPCMPEQQZrrk },
  { "vpcmpeqq", X86::VPCMPEQQZrmk },
  { "vpcmpeqq", X86::VPCMPEQQZ128rmbk },
  { "vpcmpeqq", X86::VPCMPEQQZ256rmbk },
  { "vpcmpeqq", X86::VPCMPEQQZrmbk },
  { "vpcmpeqw", X86::VPCMPEQWrr },
  { "vpcmpeqw", X86::VPCMPEQWrm },
  { "vpcmpeqw", X86::VPCMPEQWYrr },
  { "vpcmpeqw", X86::VPCMPEQWYrm },
  { "vpcmpeqw", X86::VPCMPEQWZ128rr },
  { "vpcmpeqw", X86::VPCMPEQWZ128rm },
  { "vpcmpeqw", X86::VPCMPEQWZ256rr },
  { "vpcmpeqw", X86::VPCMPEQWZ256rm },
  { "vpcmpeqw", X86::VPCMPEQWZrr },
  { "vpcmpeqw", X86::VPCMPEQWZrm },
  { "vpcmpeqw", X86::VPCMPEQWZ128rrk },
  { "vpcmpeqw", X86::VPCMPEQWZ128rmk },
  { "vpcmpeqw", X86::VPCMPEQWZ256rrk },
  { "vpcmpeqw", X86::VPCMPEQWZ256rmk },
  { "vpcmpeqw", X86::VPCMPEQWZrrk },
  { "vpcmpeqw", X86::VPCMPEQWZrmk },
  { "vpcmpestri", X86::VPCMPESTRIrr },
  { "vpcmpestri", X86::VPCMPESTRIrm },
  { "vpcmpestrm", X86::VPCMPESTRM128rr },
  { "vpcmpestrm", X86::VPCMPESTRM128rm },
  { "vpcmpgtb", X86::VPCMPGTBrr },
  { "vpcmpgtb", X86::VPCMPGTBrm },
  { "vpcmpgtb", X86::VPCMPGTBYrr },
  { "vpcmpgtb", X86::VPCMPGTBYrm },
  { "vpcmpgtb", X86::VPCMPGTBZ128rr },
  { "vpcmpgtb", X86::VPCMPGTBZ128rm },
  { "vpcmpgtb", X86::VPCMPGTBZ256rr },
  { "vpcmpgtb", X86::VPCMPGTBZ256rm },
  { "vpcmpgtb", X86::VPCMPGTBZrr },
  { "vpcmpgtb", X86::VPCMPGTBZrm },
  { "vpcmpgtb", X86::VPCMPGTBZ128rrk },
  { "vpcmpgtb", X86::VPCMPGTBZ128rmk },
  { "vpcmpgtb", X86::VPCMPGTBZ256rrk },
  { "vpcmpgtb", X86::VPCMPGTBZ256rmk },
  { "vpcmpgtb", X86::VPCMPGTBZrrk },
  { "vpcmpgtb", X86::VPCMPGTBZrmk },
  { "vpcmpgtd", X86::VPCMPGTDrr },
  { "vpcmpgtd", X86::VPCMPGTDrm },
  { "vpcmpgtd", X86::VPCMPGTDYrr },
  { "vpcmpgtd", X86::VPCMPGTDYrm },
  { "vpcmpgtd", X86::VPCMPGTDZ128rr },
  { "vpcmpgtd", X86::VPCMPGTDZ128rm },
  { "vpcmpgtd", X86::VPCMPGTDZ256rr },
  { "vpcmpgtd", X86::VPCMPGTDZ256rm },
  { "vpcmpgtd", X86::VPCMPGTDZrr },
  { "vpcmpgtd", X86::VPCMPGTDZrm },
  { "vpcmpgtd", X86::VPCMPGTDZ128rmb },
  { "vpcmpgtd", X86::VPCMPGTDZ256rmb },
  { "vpcmpgtd", X86::VPCMPGTDZrmb },
  { "vpcmpgtd", X86::VPCMPGTDZ128rrk },
  { "vpcmpgtd", X86::VPCMPGTDZ128rmk },
  { "vpcmpgtd", X86::VPCMPGTDZ256rrk },
  { "vpcmpgtd", X86::VPCMPGTDZ256rmk },
  { "vpcmpgtd", X86::VPCMPGTDZrrk },
  { "vpcmpgtd", X86::VPCMPGTDZrmk },
  { "vpcmpgtd", X86::VPCMPGTDZ128rmbk },
  { "vpcmpgtd", X86::VPCMPGTDZ256rmbk },
  { "vpcmpgtd", X86::VPCMPGTDZrmbk },
  { "vpcmpgtq", X86::VPCMPGTQrr },
  { "vpcmpgtq", X86::VPCMPGTQrm },
  { "vpcmpgtq", X86::VPCMPGTQYrr },
  { "vpcmpgtq", X86::VPCMPGTQYrm },
  { "vpcmpgtq", X86::VPCMPGTQZ128rr },
  { "vpcmpgtq", X86::VPCMPGTQZ128rm },
  { "vpcmpgtq", X86::VPCMPGTQZ256rr },
  { "vpcmpgtq", X86::VPCMPGTQZ256rm },
  { "vpcmpgtq", X86::VPCMPGTQZrr },
  { "vpcmpgtq", X86::VPCMPGTQZrm },
  { "vpcmpgtq", X86::VPCMPGTQZ128rmb },
  { "vpcmpgtq", X86::VPCMPGTQZ256rmb },
  { "vpcmpgtq", X86::VPCMPGTQZrmb },
  { "vpcmpgtq", X86::VPCMPGTQZ128rrk },
  { "vpcmpgtq", X86::VPCMPGTQZ128rmk },
  { "vpcmpgtq", X86::VPCMPGTQZ256rrk },
  { "vpcmpgtq", X86::VPCMPGTQZ256rmk },
  { "vpcmpgtq", X86::VPCMPGTQZrrk },
  { "vpcmpgtq", X86::VPCMPGTQZrmk },
  { "vpcmpgtq", X86::VPCMPGTQZ128rmbk },
  { "vpcmpgtq", X86::VPCMPGTQZ256rmbk },
  { "vpcmpgtq", X86::VPCMPGTQZrmbk },
  { "vpcmpgtw", X86::VPCMPGTWrr },
  { "vpcmpgtw", X86::VPCMPGTWrm },
  { "vpcmpgtw", X86::VPCMPGTWYrr },
  { "vpcmpgtw", X86::VPCMPGTWYrm },
  { "vpcmpgtw", X86::VPCMPGTWZ128rr },
  { "vpcmpgtw", X86::VPCMPGTWZ128rm },
  { "vpcmpgtw", X86::VPCMPGTWZ256rr },
  { "vpcmpgtw", X86::VPCMPGTWZ256rm },
  { "vpcmpgtw", X86::VPCMPGTWZrr },
  { "vpcmpgtw", X86::VPCMPGTWZrm },
  { "vpcmpgtw", X86::VPCMPGTWZ128rrk },
  { "vpcmpgtw", X86::VPCMPGTWZ128rmk },
  { "vpcmpgtw", X86::VPCMPGTWZ256rrk },
  { "vpcmpgtw", X86::VPCMPGTWZ256rmk },
  { "vpcmpgtw", X86::VPCMPGTWZrrk },
  { "vpcmpgtw", X86::VPCMPGTWZrmk },
  { "vpcmpistri", X86::VPCMPISTRIrr },
  { "vpcmpistri", X86::VPCMPISTRIrm },
  { "vpcmpistrm", X86::VPCMPISTRM128rr },
  { "vpcmpistrm", X86::VPCMPISTRM128rm },
  { "vpcmpq", X86::VPCMPQZ128rri_alt },
  { "vpcmpq", X86::VPCMPQZ128rmi_alt },
  { "vpcmpq", X86::VPCMPQZ256rri_alt },
  { "vpcmpq", X86::VPCMPQZ256rmi_alt },
  { "vpcmpq", X86::VPCMPQZrri_alt },
  { "vpcmpq", X86::VPCMPQZrmi_alt },
  { "vpcmpq", X86::VPCMPQZ128rmib_alt },
  { "vpcmpq", X86::VPCMPQZ256rmib_alt },
  { "vpcmpq", X86::VPCMPQZrmib_alt },
  { "vpcmpq", X86::VPCMPQZ128rrik_alt },
  { "vpcmpq", X86::VPCMPQZ128rmik_alt },
  { "vpcmpq", X86::VPCMPQZ256rrik_alt },
  { "vpcmpq", X86::VPCMPQZ256rmik_alt },
  { "vpcmpq", X86::VPCMPQZrrik_alt },
  { "vpcmpq", X86::VPCMPQZrmik_alt },
  { "vpcmpq", X86::VPCMPQZ128rmibk_alt },
  { "vpcmpq", X86::VPCMPQZ256rmibk_alt },
  { "vpcmpq", X86::VPCMPQZrmibk_alt },
  { "vpcmpub", X86::VPCMPUBZ128rri_alt },
  { "vpcmpub", X86::VPCMPUBZ128rmi_alt },
  { "vpcmpub", X86::VPCMPUBZ256rri_alt },
  { "vpcmpub", X86::VPCMPUBZ256rmi_alt },
  { "vpcmpub", X86::VPCMPUBZrri_alt },
  { "vpcmpub", X86::VPCMPUBZrmi_alt },
  { "vpcmpub", X86::VPCMPUBZ128rrik_alt },
  { "vpcmpub", X86::VPCMPUBZ128rmik_alt },
  { "vpcmpub", X86::VPCMPUBZ256rrik_alt },
  { "vpcmpub", X86::VPCMPUBZ256rmik_alt },
  { "vpcmpub", X86::VPCMPUBZrrik_alt },
  { "vpcmpub", X86::VPCMPUBZrmik_alt },
  { "vpcmpud", X86::VPCMPUDZ128rri_alt },
  { "vpcmpud", X86::VPCMPUDZ128rmi_alt },
  { "vpcmpud", X86::VPCMPUDZ256rri_alt },
  { "vpcmpud", X86::VPCMPUDZ256rmi_alt },
  { "vpcmpud", X86::VPCMPUDZrri_alt },
  { "vpcmpud", X86::VPCMPUDZrmi_alt },
  { "vpcmpud", X86::VPCMPUDZ128rmib_alt },
  { "vpcmpud", X86::VPCMPUDZ256rmib_alt },
  { "vpcmpud", X86::VPCMPUDZrmib_alt },
  { "vpcmpud", X86::VPCMPUDZ128rrik_alt },
  { "vpcmpud", X86::VPCMPUDZ128rmik_alt },
  { "vpcmpud", X86::VPCMPUDZ256rrik_alt },
  { "vpcmpud", X86::VPCMPUDZ256rmik_alt },
  { "vpcmpud", X86::VPCMPUDZrrik_alt },
  { "vpcmpud", X86::VPCMPUDZrmik_alt },
  { "vpcmpud", X86::VPCMPUDZ128rmibk_alt },
  { "vpcmpud", X86::VPCMPUDZ256rmibk_alt },
  { "vpcmpud", X86::VPCMPUDZrmibk_alt },
  { "vpcmpuq", X86::VPCMPUQZ128rri_alt },
  { "vpcmpuq", X86::VPCMPUQZ128rmi_alt },
  { "vpcmpuq", X86::VPCMPUQZ256rri_alt },
  { "vpcmpuq", X86::VPCMPUQZ256rmi_alt },
  { "vpcmpuq", X86::VPCMPUQZrri_alt },
  { "vpcmpuq", X86::VPCMPUQZrmi_alt },
  { "vpcmpuq", X86::VPCMPUQZ128rmib_alt },
  { "vpcmpuq", X86::VPCMPUQZ256rmib_alt },
  { "vpcmpuq", X86::VPCMPUQZrmib_alt },
  { "vpcmpuq", X86::VPCMPUQZ128rrik_alt },
  { "vpcmpuq", X86::VPCMPUQZ128rmik_alt },
  { "vpcmpuq", X86::VPCMPUQZ256rrik_alt },
  { "vpcmpuq", X86::VPCMPUQZ256rmik_alt },
  { "vpcmpuq", X86::VPCMPUQZrrik_alt },
  { "vpcmpuq", X86::VPCMPUQZrmik_alt },
  { "vpcmpuq", X86::VPCMPUQZ128rmibk_alt },
  { "vpcmpuq", X86::VPCMPUQZ256rmibk_alt },
  { "vpcmpuq", X86::VPCMPUQZrmibk_alt },
  { "vpcmpuw", X86::VPCMPUWZ128rri_alt },
  { "vpcmpuw", X86::VPCMPUWZ128rmi_alt },
  { "vpcmpuw", X86::VPCMPUWZ256rri_alt },
  { "vpcmpuw", X86::VPCMPUWZ256rmi_alt },
  { "vpcmpuw", X86::VPCMPUWZrri_alt },
  { "vpcmpuw", X86::VPCMPUWZrmi_alt },
  { "vpcmpuw", X86::VPCMPUWZ128rrik_alt },
  { "vpcmpuw", X86::VPCMPUWZ128rmik_alt },
  { "vpcmpuw", X86::VPCMPUWZ256rrik_alt },
  { "vpcmpuw", X86::VPCMPUWZ256rmik_alt },
  { "vpcmpuw", X86::VPCMPUWZrrik_alt },
  { "vpcmpuw", X86::VPCMPUWZrmik_alt },
  { "vpcmpw", X86::VPCMPWZ128rri_alt },
  { "vpcmpw", X86::VPCMPWZ128rmi_alt },
  { "vpcmpw", X86::VPCMPWZ256rri_alt },
  { "vpcmpw", X86::VPCMPWZ256rmi_alt },
  { "vpcmpw", X86::VPCMPWZrri_alt },
  { "vpcmpw", X86::VPCMPWZrmi_alt },
  { "vpcmpw", X86::VPCMPWZ128rrik_alt },
  { "vpcmpw", X86::VPCMPWZ128rmik_alt },
  { "vpcmpw", X86::VPCMPWZ256rrik_alt },
  { "vpcmpw", X86::VPCMPWZ256rmik_alt },
  { "vpcmpw", X86::VPCMPWZrrik_alt },
  { "vpcmpw", X86::VPCMPWZrmik_alt },
  { "vpcomb", X86::VPCOMBri },
  { "vpcomb", X86::VPCOMBmi },
  { "vpcomd", X86::VPCOMDri },
  { "vpcomd", X86::VPCOMDmi },
  { "vpcomq", X86::VPCOMQri },
  { "vpcomq", X86::VPCOMQmi },
  { "vpcomub", X86::VPCOMUBri },
  { "vpcomub", X86::VPCOMUBmi },
  { "vpcomud", X86::VPCOMUDri },
  { "vpcomud", X86::VPCOMUDmi },
  { "vpcomuq", X86::VPCOMUQri },
  { "vpcomuq", X86::VPCOMUQmi },
  { "vpcomuw", X86::VPCOMUWri },
  { "vpcomuw", X86::VPCOMUWmi },
  { "vpcomw", X86::VPCOMWri },
  { "vpcomw", X86::VPCOMWmi },
  { "vpconflictd", X86::VPCONFLICTDrr },
  { "vpconflictd", X86::VPCONFLICTDrm },
  { "vpconflictd", X86::VPCONFLICTDrmb },
  { "vpconflictd", X86::VPCONFLICTDrrk },
  { "vpconflictd", X86::VPCONFLICTDrmk },
  { "vpconflictd", X86::VPCONFLICTDrrkz },
  { "vpconflictd", X86::VPCONFLICTDrmkz },
  { "vpconflictd", X86::VPCONFLICTDrmbk },
  { "vpconflictd", X86::VPCONFLICTDrmbkz },
  { "vpconflictq", X86::VPCONFLICTQrr },
  { "vpconflictq", X86::VPCONFLICTQrm },
  { "vpconflictq", X86::VPCONFLICTQrmb },
  { "vpconflictq", X86::VPCONFLICTQrrk },
  { "vpconflictq", X86::VPCONFLICTQrmk },
  { "vpconflictq", X86::VPCONFLICTQrrkz },
  { "vpconflictq", X86::VPCONFLICTQrmkz },
  { "vpconflictq", X86::VPCONFLICTQrmbk },
  { "vpconflictq", X86::VPCONFLICTQrmbkz },
  { "vperm2f128", X86::VPERM2F128rr },
  { "vperm2f128", X86::VPERM2F128rm },
  { "vperm2i128", X86::VPERM2I128rr },
  { "vperm2i128", X86::VPERM2I128rm },
  { "vpermd", X86::VPERMDYrr },
  { "vpermd", X86::VPERMDYrm },
  { "vpermd", X86::VPERMDZrr },
  { "vpermd", X86::VPERMDZrm },
  { "vpermi2d", X86::VPERMI2Drr },
  { "vpermi2d", X86::VPERMI2Drm },
  { "vpermi2d", X86::VPERMI2Drrk },
  { "vpermi2d", X86::VPERMI2Drmk },
  { "vpermi2d", X86::VPERMI2Drrkz },
  { "vpermi2d", X86::VPERMI2Drmkz },
  { "vpermi2pd", X86::VPERMI2PDrr },
  { "vpermi2pd", X86::VPERMI2PDrm },
  { "vpermi2pd", X86::VPERMI2PDrrk },
  { "vpermi2pd", X86::VPERMI2PDrmk },
  { "vpermi2pd", X86::VPERMI2PDrrkz },
  { "vpermi2pd", X86::VPERMI2PDrmkz },
  { "vpermi2ps", X86::VPERMI2PSrr },
  { "vpermi2ps", X86::VPERMI2PSrm },
  { "vpermi2ps", X86::VPERMI2PSrrk },
  { "vpermi2ps", X86::VPERMI2PSrmk },
  { "vpermi2ps", X86::VPERMI2PSrrkz },
  { "vpermi2ps", X86::VPERMI2PSrmkz },
  { "vpermi2q", X86::VPERMI2Qrr },
  { "vpermi2q", X86::VPERMI2Qrm },
  { "vpermi2q", X86::VPERMI2Qrrk },
  { "vpermi2q", X86::VPERMI2Qrmk },
  { "vpermi2q", X86::VPERMI2Qrrkz },
  { "vpermi2q", X86::VPERMI2Qrmkz },
  { "vpermil2pd", X86::VPERMIL2PDrr },
  { "vpermil2pd", X86::VPERMIL2PDrm },
  { "vpermil2pd", X86::VPERMIL2PDmr },
  { "vpermil2pd", X86::VPERMIL2PDrrY },
  { "vpermil2pd", X86::VPERMIL2PDrmY },
  { "vpermil2pd", X86::VPERMIL2PDmrY },
  { "vpermil2ps", X86::VPERMIL2PSrr },
  { "vpermil2ps", X86::VPERMIL2PSrm },
  { "vpermil2ps", X86::VPERMIL2PSmr },
  { "vpermil2ps", X86::VPERMIL2PSrrY },
  { "vpermil2ps", X86::VPERMIL2PSrmY },
  { "vpermil2ps", X86::VPERMIL2PSmrY },
  { "vpermilpd", X86::VPERMILPDrr },
  { "vpermilpd", X86::VPERMILPDri },
  { "vpermilpd", X86::VPERMILPDrm },
  { "vpermilpd", X86::VPERMILPDmi },
  { "vpermilpd", X86::VPERMILPDYrr },
  { "vpermilpd", X86::VPERMILPDYri },
  { "vpermilpd", X86::VPERMILPDYrm },
  { "vpermilpd", X86::VPERMILPDYmi },
  { "vpermilpd", X86::VPERMILPDZri },
  { "vpermilpd", X86::VPERMILPDZmi },
  { "vpermilps", X86::VPERMILPSrr },
  { "vpermilps", X86::VPERMILPSri },
  { "vpermilps", X86::VPERMILPSrm },
  { "vpermilps", X86::VPERMILPSmi },
  { "vpermilps", X86::VPERMILPSYrr },
  { "vpermilps", X86::VPERMILPSYri },
  { "vpermilps", X86::VPERMILPSYrm },
  { "vpermilps", X86::VPERMILPSYmi },
  { "vpermilps", X86::VPERMILPSZri },
  { "vpermilps", X86::VPERMILPSZmi },
  { "vpermpd", X86::VPERMPDYri },
  { "vpermpd", X86::VPERMPDYmi },
  { "vpermpd", X86::VPERMPDZrr },
  { "vpermpd", X86::VPERMPDZri },
  { "vpermpd", X86::VPERMPDZrm },
  { "vpermpd", X86::VPERMPDZmi },
  { "vpermps", X86::VPERMPSYrr },
  { "vpermps", X86::VPERMPSYrm },
  { "vpermps", X86::VPERMPSZrr },
  { "vpermps", X86::VPERMPSZrm },
  { "vpermq", X86::VPERMQYri },
  { "vpermq", X86::VPERMQYmi },
  { "vpermq", X86::VPERMQZrr },
  { "vpermq", X86::VPERMQZri },
  { "vpermq", X86::VPERMQZrm },
  { "vpermq", X86::VPERMQZmi },
  { "vpermt2d", X86::VPERMT2Drr },
  { "vpermt2d", X86::VPERMT2Drm },
  { "vpermt2d", X86::VPERMT2Drrk },
  { "vpermt2d", X86::VPERMT2Drmk },
  { "vpermt2d", X86::VPERMT2Drrkz },
  { "vpermt2d", X86::VPERMT2Drmkz },
  { "vpermt2pd", X86::VPERMT2PDrr },
  { "vpermt2pd", X86::VPERMT2PDrm },
  { "vpermt2pd", X86::VPERMT2PDrrk },
  { "vpermt2pd", X86::VPERMT2PDrmk },
  { "vpermt2pd", X86::VPERMT2PDrrkz },
  { "vpermt2pd", X86::VPERMT2PDrmkz },
  { "vpermt2ps", X86::VPERMT2PSrr },
  { "vpermt2ps", X86::VPERMT2PSrm },
  { "vpermt2ps", X86::VPERMT2PSrrk },
  { "vpermt2ps", X86::VPERMT2PSrmk },
  { "vpermt2ps", X86::VPERMT2PSrrkz },
  { "vpermt2ps", X86::VPERMT2PSrmkz },
  { "vpermt2q", X86::VPERMT2Qrr },
  { "vpermt2q", X86::VPERMT2Qrm },
  { "vpermt2q", X86::VPERMT2Qrrk },
  { "vpermt2q", X86::VPERMT2Qrmk },
  { "vpermt2q", X86::VPERMT2Qrrkz },
  { "vpermt2q", X86::VPERMT2Qrmkz },
  { "vpextrb", X86::VPEXTRBrr },
  { "vpextrb", X86::VPEXTRBmr },
  { "vpextrd", X86::VPEXTRDrr },
  { "vpextrd", X86::VPEXTRDmr },
  { "vpextrq", X86::VPEXTRQrr },
  { "vpextrq", X86::VPEXTRQmr },
  { "vpextrw", X86::VPEXTRWri },
  { "vpextrw", X86::VPEXTRWmr },
  { "vpgatherdd", X86::VPGATHERDDrm },
  { "vpgatherdd", X86::VPGATHERDDYrm },
  { "vpgatherdd", X86::VPGATHERDDZrm },
  { "vpgatherdq", X86::VPGATHERDQrm },
  { "vpgatherdq", X86::VPGATHERDQYrm },
  { "vpgatherdq", X86::VPGATHERDQZrm },
  { "vpgatherqd", X86::VPGATHERQDrm },
  { "vpgatherqd", X86::VPGATHERQDYrm },
  { "vpgatherqd", X86::VPGATHERQDZrm },
  { "vpgatherqq", X86::VPGATHERQQrm },
  { "vpgatherqq", X86::VPGATHERQQYrm },
  { "vpgatherqq", X86::VPGATHERQQZrm },
  { "vphaddbd", X86::VPHADDBDrr },
  { "vphaddbd", X86::VPHADDBDrm },
  { "vphaddbq", X86::VPHADDBQrr },
  { "vphaddbq", X86::VPHADDBQrm },
  { "vphaddbw", X86::VPHADDBWrr },
  { "vphaddbw", X86::VPHADDBWrm },
  { "vphaddd", X86::VPHADDDrr },
  { "vphaddd", X86::VPHADDDrm },
  { "vphaddd", X86::VPHADDDYrr },
  { "vphaddd", X86::VPHADDDYrm },
  { "vphadddq", X86::VPHADDDQrr },
  { "vphadddq", X86::VPHADDDQrm },
  { "vphaddsw", X86::VPHADDSWrr128 },
  { "vphaddsw", X86::VPHADDSWrm128 },
  { "vphaddsw", X86::VPHADDSWrr256 },
  { "vphaddsw", X86::VPHADDSWrm256 },
  { "vphaddubd", X86::VPHADDUBDrr },
  { "vphaddubd", X86::VPHADDUBDrm },
  { "vphaddubq", X86::VPHADDUBQrr },
  { "vphaddubq", X86::VPHADDUBQrm },
  { "vphaddubw", X86::VPHADDUBWrr },
  { "vphaddubw", X86::VPHADDUBWrm },
  { "vphaddudq", X86::VPHADDUDQrr },
  { "vphaddudq", X86::VPHADDUDQrm },
  { "vphadduwd", X86::VPHADDUWDrr },
  { "vphadduwd", X86::VPHADDUWDrm },
  { "vphadduwq", X86::VPHADDUWQrr },
  { "vphadduwq", X86::VPHADDUWQrm },
  { "vphaddw", X86::VPHADDWrr },
  { "vphaddw", X86::VPHADDWrm },
  { "vphaddw", X86::VPHADDWYrr },
  { "vphaddw", X86::VPHADDWYrm },
  { "vphaddwd", X86::VPHADDWDrr },
  { "vphaddwd", X86::VPHADDWDrm },
  { "vphaddwq", X86::VPHADDWQrr },
  { "vphaddwq", X86::VPHADDWQrm },
  { "vphminposuw", X86::VPHMINPOSUWrr128 },
  { "vphminposuw", X86::VPHMINPOSUWrm128 },
  { "vphsubbw", X86::VPHSUBBWrr },
  { "vphsubbw", X86::VPHSUBBWrm },
  { "vphsubd", X86::VPHSUBDrr },
  { "vphsubd", X86::VPHSUBDrm },
  { "vphsubd", X86::VPHSUBDYrr },
  { "vphsubd", X86::VPHSUBDYrm },
  { "vphsubdq", X86::VPHSUBDQrr },
  { "vphsubdq", X86::VPHSUBDQrm },
  { "vphsubsw", X86::VPHSUBSWrr128 },
  { "vphsubsw", X86::VPHSUBSWrm128 },
  { "vphsubsw", X86::VPHSUBSWrr256 },
  { "vphsubsw", X86::VPHSUBSWrm256 },
  { "vphsubw", X86::VPHSUBWrr },
  { "vphsubw", X86::VPHSUBWrm },
  { "vphsubw", X86::VPHSUBWYrr },
  { "vphsubw", X86::VPHSUBWYrm },
  { "vphsubwd", X86::VPHSUBWDrr },
  { "vphsubwd", X86::VPHSUBWDrm },
  { "vpinsrb", X86::VPINSRBrr },
  { "vpinsrb", X86::VPINSRBrm },
  { "vpinsrd", X86::VPINSRDrr },
  { "vpinsrd", X86::VPINSRDrm },
  { "vpinsrq", X86::VPINSRQrr },
  { "vpinsrq", X86::VPINSRQrm },
  { "vpinsrw", X86::VPINSRWrri },
  { "vpinsrw", X86::VPINSRWrmi },
  { "vplzcntd", X86::VPLZCNTDrr },
  { "vplzcntd", X86::VPLZCNTDrm },
  { "vplzcntd", X86::VPLZCNTDrmb },
  { "vplzcntd", X86::VPLZCNTDrrk },
  { "vplzcntd", X86::VPLZCNTDrmk },
  { "vplzcntd", X86::VPLZCNTDrrkz },
  { "vplzcntd", X86::VPLZCNTDrmkz },
  { "vplzcntd", X86::VPLZCNTDrmbk },
  { "vplzcntd", X86::VPLZCNTDrmbkz },
  { "vplzcntq", X86::VPLZCNTQrr },
  { "vplzcntq", X86::VPLZCNTQrm },
  { "vplzcntq", X86::VPLZCNTQrmb },
  { "vplzcntq", X86::VPLZCNTQrrk },
  { "vplzcntq", X86::VPLZCNTQrmk },
  { "vplzcntq", X86::VPLZCNTQrrkz },
  { "vplzcntq", X86::VPLZCNTQrmkz },
  { "vplzcntq", X86::VPLZCNTQrmbk },
  { "vplzcntq", X86::VPLZCNTQrmbkz },
  { "vpmacsdd", X86::VPMACSDDrr },
  { "vpmacsdd", X86::VPMACSDDrm },
  { "vpmacsdqh", X86::VPMACSDQHrr },
  { "vpmacsdqh", X86::VPMACSDQHrm },
  { "vpmacsdql", X86::VPMACSDQLrr },
  { "vpmacsdql", X86::VPMACSDQLrm },
  { "vpmacssdd", X86::VPMACSSDDrr },
  { "vpmacssdd", X86::VPMACSSDDrm },
  { "vpmacssdqh", X86::VPMACSSDQHrr },
  { "vpmacssdqh", X86::VPMACSSDQHrm },
  { "vpmacssdql", X86::VPMACSSDQLrr },
  { "vpmacssdql", X86::VPMACSSDQLrm },
  { "vpmacsswd", X86::VPMACSSWDrr },
  { "vpmacsswd", X86::VPMACSSWDrm },
  { "vpmacssww", X86::VPMACSSWWrr },
  { "vpmacssww", X86::VPMACSSWWrm },
  { "vpmacswd", X86::VPMACSWDrr },
  { "vpmacswd", X86::VPMACSWDrm },
  { "vpmacsww", X86::VPMACSWWrr },
  { "vpmacsww", X86::VPMACSWWrm },
  { "vpmadcsswd", X86::VPMADCSSWDrr },
  { "vpmadcsswd", X86::VPMADCSSWDrm },
  { "vpmadcswd", X86::VPMADCSWDrr },
  { "vpmadcswd", X86::VPMADCSWDrm },
  { "vpmaddubsw", X86::VPMADDUBSWrr128 },
  { "vpmaddubsw", X86::VPMADDUBSWrm128 },
  { "vpmaddubsw", X86::VPMADDUBSWrr256 },
  { "vpmaddubsw", X86::VPMADDUBSWrm256 },
  { "vpmaddwd", X86::VPMADDWDrr },
  { "vpmaddwd", X86::VPMADDWDrm },
  { "vpmaddwd", X86::VPMADDWDYrr },
  { "vpmaddwd", X86::VPMADDWDYrm },
  { "vpmaskmovd", X86::VPMASKMOVDrm },
  { "vpmaskmovd", X86::VPMASKMOVDYrm },
  { "vpmaskmovd", X86::VPMASKMOVDmr },
  { "vpmaskmovd", X86::VPMASKMOVDYmr },
  { "vpmaskmovq", X86::VPMASKMOVQrm },
  { "vpmaskmovq", X86::VPMASKMOVQYrm },
  { "vpmaskmovq", X86::VPMASKMOVQmr },
  { "vpmaskmovq", X86::VPMASKMOVQYmr },
  { "vpmaxsb", X86::VPMAXSBrr },
  { "vpmaxsb", X86::VPMAXSBrm },
  { "vpmaxsb", X86::VPMAXSBYrr },
  { "vpmaxsb", X86::VPMAXSBYrm },
  { "vpmaxsd", X86::VPMAXSDrr },
  { "vpmaxsd", X86::VPMAXSDrm },
  { "vpmaxsd", X86::VPMAXSDYrr },
  { "vpmaxsd", X86::VPMAXSDYrm },
  { "vpmaxsd", X86::VPMAXSDZrr },
  { "vpmaxsd", X86::VPMAXSDZrm },
  { "vpmaxsd", X86::VPMAXSDZrmb },
  { "vpmaxsd", X86::VPMAXSDZrrk },
  { "vpmaxsd", X86::VPMAXSDZrmk },
  { "vpmaxsd", X86::VPMAXSDZrrkz },
  { "vpmaxsd", X86::VPMAXSDZrmkz },
  { "vpmaxsd", X86::VPMAXSDZrmbk },
  { "vpmaxsd", X86::VPMAXSDZrmbkz },
  { "vpmaxsq", X86::VPMAXSQZrr },
  { "vpmaxsq", X86::VPMAXSQZrm },
  { "vpmaxsq", X86::VPMAXSQZrmb },
  { "vpmaxsq", X86::VPMAXSQZrrk },
  { "vpmaxsq", X86::VPMAXSQZrmk },
  { "vpmaxsq", X86::VPMAXSQZrrkz },
  { "vpmaxsq", X86::VPMAXSQZrmkz },
  { "vpmaxsq", X86::VPMAXSQZrmbk },
  { "vpmaxsq", X86::VPMAXSQZrmbkz },
  { "vpmaxsw", X86::VPMAXSWrr },
  { "vpmaxsw", X86::VPMAXSWrm },
  { "vpmaxsw", X86::VPMAXSWYrr },
  { "vpmaxsw", X86::VPMAXSWYrm },
  { "vpmaxub", X86::VPMAXUBrr },
  { "vpmaxub", X86::VPMAXUBrm },
  { "vpmaxub", X86::VPMAXUBYrr },
  { "vpmaxub", X86::VPMAXUBYrm },
  { "vpmaxud", X86::VPMAXUDrr },
  { "vpmaxud", X86::VPMAXUDrm },
  { "vpmaxud", X86::VPMAXUDYrr },
  { "vpmaxud", X86::VPMAXUDYrm },
  { "vpmaxud", X86::VPMAXUDZrr },
  { "vpmaxud", X86::VPMAXUDZrm },
  { "vpmaxud", X86::VPMAXUDZrmb },
  { "vpmaxud", X86::VPMAXUDZrrk },
  { "vpmaxud", X86::VPMAXUDZrmk },
  { "vpmaxud", X86::VPMAXUDZrrkz },
  { "vpmaxud", X86::VPMAXUDZrmkz },
  { "vpmaxud", X86::VPMAXUDZrmbk },
  { "vpmaxud", X86::VPMAXUDZrmbkz },
  { "vpmaxuq", X86::VPMAXUQZrr },
  { "vpmaxuq", X86::VPMAXUQZrm },
  { "vpmaxuq", X86::VPMAXUQZrmb },
  { "vpmaxuq", X86::VPMAXUQZrrk },
  { "vpmaxuq", X86::VPMAXUQZrmk },
  { "vpmaxuq", X86::VPMAXUQZrrkz },
  { "vpmaxuq", X86::VPMAXUQZrmkz },
  { "vpmaxuq", X86::VPMAXUQZrmbk },
  { "vpmaxuq", X86::VPMAXUQZrmbkz },
  { "vpmaxuw", X86::VPMAXUWrr },
  { "vpmaxuw", X86::VPMAXUWrm },
  { "vpmaxuw", X86::VPMAXUWYrr },
  { "vpmaxuw", X86::VPMAXUWYrm },
  { "vpminsb", X86::VPMINSBrr },
  { "vpminsb", X86::VPMINSBrm },
  { "vpminsb", X86::VPMINSBYrr },
  { "vpminsb", X86::VPMINSBYrm },
  { "vpminsd", X86::VPMINSDrr },
  { "vpminsd", X86::VPMINSDrm },
  { "vpminsd", X86::VPMINSDYrr },
  { "vpminsd", X86::VPMINSDYrm },
  { "vpminsd", X86::VPMINSDZrr },
  { "vpminsd", X86::VPMINSDZrm },
  { "vpminsd", X86::VPMINSDZrmb },
  { "vpminsd", X86::VPMINSDZrrk },
  { "vpminsd", X86::VPMINSDZrmk },
  { "vpminsd", X86::VPMINSDZrrkz },
  { "vpminsd", X86::VPMINSDZrmkz },
  { "vpminsd", X86::VPMINSDZrmbk },
  { "vpminsd", X86::VPMINSDZrmbkz },
  { "vpminsq", X86::VPMINSQZrr },
  { "vpminsq", X86::VPMINSQZrm },
  { "vpminsq", X86::VPMINSQZrmb },
  { "vpminsq", X86::VPMINSQZrrk },
  { "vpminsq", X86::VPMINSQZrmk },
  { "vpminsq", X86::VPMINSQZrrkz },
  { "vpminsq", X86::VPMINSQZrmkz },
  { "vpminsq", X86::VPMINSQZrmbk },
  { "vpminsq", X86::VPMINSQZrmbkz },
  { "vpminsw", X86::VPMINSWrr },
  { "vpminsw", X86::VPMINSWrm },
  { "vpminsw", X86::VPMINSWYrr },
  { "vpminsw", X86::VPMINSWYrm },
  { "vpminub", X86::VPMINUBrr },
  { "vpminub", X86::VPMINUBrm },
  { "vpminub", X86::VPMINUBYrr },
  { "vpminub", X86::VPMINUBYrm },
  { "vpminud", X86::VPMINUDrr },
  { "vpminud", X86::VPMINUDrm },
  { "vpminud", X86::VPMINUDYrr },
  { "vpminud", X86::VPMINUDYrm },
  { "vpminud", X86::VPMINUDZrr },
  { "vpminud", X86::VPMINUDZrm },
  { "vpminud", X86::VPMINUDZrmb },
  { "vpminud", X86::VPMINUDZrrk },
  { "vpminud", X86::VPMINUDZrmk },
  { "vpminud", X86::VPMINUDZrrkz },
  { "vpminud", X86::VPMINUDZrmkz },
  { "vpminud", X86::VPMINUDZrmbk },
  { "vpminud", X86::VPMINUDZrmbkz },
  { "vpminuq", X86::VPMINUQZrr },
  { "vpminuq", X86::VPMINUQZrm },
  { "vpminuq", X86::VPMINUQZrmb },
  { "vpminuq", X86::VPMINUQZrrk },
  { "vpminuq", X86::VPMINUQZrmk },
  { "vpminuq", X86::VPMINUQZrrkz },
  { "vpminuq", X86::VPMINUQZrmkz },
  { "vpminuq", X86::VPMINUQZrmbk },
  { "vpminuq", X86::VPMINUQZrmbkz },
  { "vpminuw", X86::VPMINUWrr },
  { "vpminuw", X86::VPMINUWrm },
  { "vpminuw", X86::VPMINUWYrr },
  { "vpminuw", X86::VPMINUWYrm },
  { "vpmovdb", X86::VPMOVDBrr },
  { "vpmovdb", X86::VPMOVDBmr },
  { "vpmovdb", X86::VPMOVDBrrk },
  { "vpmovdb", X86::VPMOVDBmrk },
  { "vpmovdb", X86::VPMOVDBrrkz },
  { "vpmovdw", X86::VPMOVDWrr },
  { "vpmovdw", X86::VPMOVDWmr },
  { "vpmovdw", X86::VPMOVDWrrk },
  { "vpmovdw", X86::VPMOVDWmrk },
  { "vpmovdw", X86::VPMOVDWrrkz },
  { "vpmovmskb", X86::VPMOVMSKBrr },
  { "vpmovmskb", X86::VPMOVMSKBYrr },
  { "vpmovqb", X86::VPMOVQBrr },
  { "vpmovqb", X86::VPMOVQBmr },
  { "vpmovqb", X86::VPMOVQBrrk },
  { "vpmovqb", X86::VPMOVQBmrk },
  { "vpmovqb", X86::VPMOVQBrrkz },
  { "vpmovqd", X86::VPMOVQDrr },
  { "vpmovqd", X86::VPMOVQDmr },
  { "vpmovqd", X86::VPMOVQDrrk },
  { "vpmovqd", X86::VPMOVQDmrk },
  { "vpmovqd", X86::VPMOVQDrrkz },
  { "vpmovqw", X86::VPMOVQWrr },
  { "vpmovqw", X86::VPMOVQWmr },
  { "vpmovqw", X86::VPMOVQWrrk },
  { "vpmovqw", X86::VPMOVQWmrk },
  { "vpmovqw", X86::VPMOVQWrrkz },
  { "vpmovsdb", X86::VPMOVSDBrr },
  { "vpmovsdb", X86::VPMOVSDBmr },
  { "vpmovsdb", X86::VPMOVSDBrrk },
  { "vpmovsdb", X86::VPMOVSDBmrk },
  { "vpmovsdb", X86::VPMOVSDBrrkz },
  { "vpmovsdw", X86::VPMOVSDWrr },
  { "vpmovsdw", X86::VPMOVSDWmr },
  { "vpmovsdw", X86::VPMOVSDWrrk },
  { "vpmovsdw", X86::VPMOVSDWmrk },
  { "vpmovsdw", X86::VPMOVSDWrrkz },
  { "vpmovsqb", X86::VPMOVSQBrr },
  { "vpmovsqb", X86::VPMOVSQBmr },
  { "vpmovsqb", X86::VPMOVSQBrrk },
  { "vpmovsqb", X86::VPMOVSQBmrk },
  { "vpmovsqb", X86::VPMOVSQBrrkz },
  { "vpmovsqd", X86::VPMOVSQDrr },
  { "vpmovsqd", X86::VPMOVSQDmr },
  { "vpmovsqd", X86::VPMOVSQDrrk },
  { "vpmovsqd", X86::VPMOVSQDmrk },
  { "vpmovsqd", X86::VPMOVSQDrrkz },
  { "vpmovsqw", X86::VPMOVSQWrr },
  { "vpmovsqw", X86::VPMOVSQWmr },
  { "vpmovsqw", X86::VPMOVSQWrrk },
  { "vpmovsqw", X86::VPMOVSQWmrk },
  { "vpmovsqw", X86::VPMOVSQWrrkz },
  { "vpmovsxbd", X86::VPMOVSXBDrr },
  { "vpmovsxbd", X86::VPMOVSXBDrm },
  { "vpmovsxbd", X86::VPMOVSXBDYrr },
  { "vpmovsxbd", X86::VPMOVSXBDYrm },
  { "vpmovsxbd", X86::VPMOVSXBDZrr },
  { "vpmovsxbd", X86::VPMOVSXBDZrm },
  { "vpmovsxbd", X86::VPMOVSXBDZrrk },
  { "vpmovsxbd", X86::VPMOVSXBDZrmk },
  { "vpmovsxbd", X86::VPMOVSXBDZrrkz },
  { "vpmovsxbd", X86::VPMOVSXBDZrmkz },
  { "vpmovsxbq", X86::VPMOVSXBQrr },
  { "vpmovsxbq", X86::VPMOVSXBQrm },
  { "vpmovsxbq", X86::VPMOVSXBQYrr },
  { "vpmovsxbq", X86::VPMOVSXBQYrm },
  { "vpmovsxbq", X86::VPMOVSXBQZrr },
  { "vpmovsxbq", X86::VPMOVSXBQZrm },
  { "vpmovsxbq", X86::VPMOVSXBQZrrk },
  { "vpmovsxbq", X86::VPMOVSXBQZrmk },
  { "vpmovsxbq", X86::VPMOVSXBQZrrkz },
  { "vpmovsxbq", X86::VPMOVSXBQZrmkz },
  { "vpmovsxbw", X86::VPMOVSXBWrr },
  { "vpmovsxbw", X86::VPMOVSXBWrm },
  { "vpmovsxbw", X86::VPMOVSXBWYrr },
  { "vpmovsxbw", X86::VPMOVSXBWYrm },
  { "vpmovsxdq", X86::VPMOVSXDQrr },
  { "vpmovsxdq", X86::VPMOVSXDQrm },
  { "vpmovsxdq", X86::VPMOVSXDQYrr },
  { "vpmovsxdq", X86::VPMOVSXDQYrm },
  { "vpmovsxdq", X86::VPMOVSXDQZrr },
  { "vpmovsxdq", X86::VPMOVSXDQZrm },
  { "vpmovsxdq", X86::VPMOVSXDQZrrk },
  { "vpmovsxdq", X86::VPMOVSXDQZrmk },
  { "vpmovsxdq", X86::VPMOVSXDQZrrkz },
  { "vpmovsxdq", X86::VPMOVSXDQZrmkz },
  { "vpmovsxwd", X86::VPMOVSXWDrr },
  { "vpmovsxwd", X86::VPMOVSXWDrm },
  { "vpmovsxwd", X86::VPMOVSXWDYrr },
  { "vpmovsxwd", X86::VPMOVSXWDYrm },
  { "vpmovsxwd", X86::VPMOVSXWDZrr },
  { "vpmovsxwd", X86::VPMOVSXWDZrm },
  { "vpmovsxwd", X86::VPMOVSXWDZrrk },
  { "vpmovsxwd", X86::VPMOVSXWDZrmk },
  { "vpmovsxwd", X86::VPMOVSXWDZrrkz },
  { "vpmovsxwd", X86::VPMOVSXWDZrmkz },
  { "vpmovsxwq", X86::VPMOVSXWQrr },
  { "vpmovsxwq", X86::VPMOVSXWQrm },
  { "vpmovsxwq", X86::VPMOVSXWQYrr },
  { "vpmovsxwq", X86::VPMOVSXWQYrm },
  { "vpmovsxwq", X86::VPMOVSXWQZrr },
  { "vpmovsxwq", X86::VPMOVSXWQZrm },
  { "vpmovsxwq", X86::VPMOVSXWQZrrk },
  { "vpmovsxwq", X86::VPMOVSXWQZrmk },
  { "vpmovsxwq", X86::VPMOVSXWQZrrkz },
  { "vpmovsxwq", X86::VPMOVSXWQZrmkz },
  { "vpmovusdb", X86::VPMOVUSDBrr },
  { "vpmovusdb", X86::VPMOVUSDBmr },
  { "vpmovusdb", X86::VPMOVUSDBrrk },
  { "vpmovusdb", X86::VPMOVUSDBmrk },
  { "vpmovusdb", X86::VPMOVUSDBrrkz },
  { "vpmovusdw", X86::VPMOVUSDWrr },
  { "vpmovusdw", X86::VPMOVUSDWmr },
  { "vpmovusdw", X86::VPMOVUSDWrrk },
  { "vpmovusdw", X86::VPMOVUSDWmrk },
  { "vpmovusdw", X86::VPMOVUSDWrrkz },
  { "vpmovusqb", X86::VPMOVUSQBrr },
  { "vpmovusqb", X86::VPMOVUSQBmr },
  { "vpmovusqb", X86::VPMOVUSQBrrk },
  { "vpmovusqb", X86::VPMOVUSQBmrk },
  { "vpmovusqb", X86::VPMOVUSQBrrkz },
  { "vpmovusqd", X86::VPMOVUSQDrr },
  { "vpmovusqd", X86::VPMOVUSQDmr },
  { "vpmovusqd", X86::VPMOVUSQDrrk },
  { "vpmovusqd", X86::VPMOVUSQDmrk },
  { "vpmovusqd", X86::VPMOVUSQDrrkz },
  { "vpmovusqw", X86::VPMOVUSQWrr },
  { "vpmovusqw", X86::VPMOVUSQWmr },
  { "vpmovusqw", X86::VPMOVUSQWrrk },
  { "vpmovusqw", X86::VPMOVUSQWmrk },
  { "vpmovusqw", X86::VPMOVUSQWrrkz },
  { "vpmovzxbd", X86::VPMOVZXBDrr },
  { "vpmovzxbd", X86::VPMOVZXBDrm },
  { "vpmovzxbd", X86::VPMOVZXBDYrr },
  { "vpmovzxbd", X86::VPMOVZXBDYrm },
  { "vpmovzxbd", X86::VPMOVZXBDZrr },
  { "vpmovzxbd", X86::VPMOVZXBDZrm },
  { "vpmovzxbd", X86::VPMOVZXBDZrrk },
  { "vpmovzxbd", X86::VPMOVZXBDZrmk },
  { "vpmovzxbd", X86::VPMOVZXBDZrrkz },
  { "vpmovzxbd", X86::VPMOVZXBDZrmkz },
  { "vpmovzxbq", X86::VPMOVZXBQrr },
  { "vpmovzxbq", X86::VPMOVZXBQrm },
  { "vpmovzxbq", X86::VPMOVZXBQYrr },
  { "vpmovzxbq", X86::VPMOVZXBQYrm },
  { "vpmovzxbq", X86::VPMOVZXBQZrr },
  { "vpmovzxbq", X86::VPMOVZXBQZrm },
  { "vpmovzxbq", X86::VPMOVZXBQZrrk },
  { "vpmovzxbq", X86::VPMOVZXBQZrmk },
  { "vpmovzxbq", X86::VPMOVZXBQZrrkz },
  { "vpmovzxbq", X86::VPMOVZXBQZrmkz },
  { "vpmovzxbw", X86::VPMOVZXBWrr },
  { "vpmovzxbw", X86::VPMOVZXBWrm },
  { "vpmovzxbw", X86::VPMOVZXBWYrr },
  { "vpmovzxbw", X86::VPMOVZXBWYrm },
  { "vpmovzxdq", X86::VPMOVZXDQrr },
  { "vpmovzxdq", X86::VPMOVZXDQrm },
  { "vpmovzxdq", X86::VPMOVZXDQYrr },
  { "vpmovzxdq", X86::VPMOVZXDQYrm },
  { "vpmovzxdq", X86::VPMOVZXDQZrr },
  { "vpmovzxdq", X86::VPMOVZXDQZrm },
  { "vpmovzxdq", X86::VPMOVZXDQZrrk },
  { "vpmovzxdq", X86::VPMOVZXDQZrmk },
  { "vpmovzxdq", X86::VPMOVZXDQZrrkz },
  { "vpmovzxdq", X86::VPMOVZXDQZrmkz },
  { "vpmovzxwd", X86::VPMOVZXWDrr },
  { "vpmovzxwd", X86::VPMOVZXWDrm },
  { "vpmovzxwd", X86::VPMOVZXWDYrr },
  { "vpmovzxwd", X86::VPMOVZXWDYrm },
  { "vpmovzxwd", X86::VPMOVZXWDZrr },
  { "vpmovzxwd", X86::VPMOVZXWDZrm },
  { "vpmovzxwd", X86::VPMOVZXWDZrrk },
  { "vpmovzxwd", X86::VPMOVZXWDZrmk },
  { "vpmovzxwd", X86::VPMOVZXWDZrrkz },
  { "vpmovzxwd", X86::VPMOVZXWDZrmkz },
  { "vpmovzxwq", X86::VPMOVZXWQrr },
  { "vpmovzxwq", X86::VPMOVZXWQrm },
  { "vpmovzxwq", X86::VPMOVZXWQYrr },
  { "vpmovzxwq", X86::VPMOVZXWQYrm },
  { "vpmovzxwq", X86::VPMOVZXWQZrr },
  { "vpmovzxwq", X86::VPMOVZXWQZrm },
  { "vpmovzxwq", X86::VPMOVZXWQZrrk },
  { "vpmovzxwq", X86::VPMOVZXWQZrmk },
  { "vpmovzxwq", X86::VPMOVZXWQZrrkz },
  { "vpmovzxwq", X86::VPMOVZXWQZrmkz },
  { "vpmuldq", X86::VPMULDQrr },
  { "vpmuldq", X86::VPMULDQrm },
  { "vpmuldq", X86::VPMULDQYrr },
  { "vpmuldq", X86::VPMULDQYrm },
  { "vpmuldq", X86::VPMULDQZrr },
  { "vpmuldq", X86::VPMULDQZrm },
  { "vpmuldq", X86::VPMULDQZrmb },
  { "vpmuldq", X86::VPMULDQZrrk },
  { "vpmuldq", X86::VPMULDQZrmk },
  { "vpmuldq", X86::VPMULDQZrrkz },
  { "vpmuldq", X86::VPMULDQZrmkz },
  { "vpmuldq", X86::VPMULDQZrmbk },
  { "vpmuldq", X86::VPMULDQZrmbkz },
  { "vpmulhrsw", X86::VPMULHRSWrr128 },
  { "vpmulhrsw", X86::VPMULHRSWrm128 },
  { "vpmulhrsw", X86::VPMULHRSWrr256 },
  { "vpmulhrsw", X86::VPMULHRSWrm256 },
  { "vpmulhuw", X86::VPMULHUWrr },
  { "vpmulhuw", X86::VPMULHUWrm },
  { "vpmulhuw", X86::VPMULHUWYrr },
  { "vpmulhuw", X86::VPMULHUWYrm },
  { "vpmulhw", X86::VPMULHWrr },
  { "vpmulhw", X86::VPMULHWrm },
  { "vpmulhw", X86::VPMULHWYrr },
  { "vpmulhw", X86::VPMULHWYrm },
  { "vpmulld", X86::VPMULLDrr },
  { "vpmulld", X86::VPMULLDrm },
  { "vpmulld", X86::VPMULLDYrr },
  { "vpmulld", X86::VPMULLDYrm },
  { "vpmulld", X86::VPMULLDZrr },
  { "vpmulld", X86::VPMULLDZrm },
  { "vpmulld", X86::VPMULLDZrmb },
  { "vpmulld", X86::VPMULLDZrrk },
  { "vpmulld", X86::VPMULLDZrmk },
  { "vpmulld", X86::VPMULLDZrrkz },
  { "vpmulld", X86::VPMULLDZrmkz },
  { "vpmulld", X86::VPMULLDZrmbk },
  { "vpmulld", X86::VPMULLDZrmbkz },
  { "vpmullw", X86::VPMULLWrr },
  { "vpmullw", X86::VPMULLWrm },
  { "vpmullw", X86::VPMULLWYrr },
  { "vpmullw", X86::VPMULLWYrm },
  { "vpmuludq", X86::VPMULUDQrr },
  { "vpmuludq", X86::VPMULUDQrm },
  { "vpmuludq", X86::VPMULUDQYrr },
  { "vpmuludq", X86::VPMULUDQYrm },
  { "vpmuludq", X86::VPMULUDQZrr },
  { "vpmuludq", X86::VPMULUDQZrm },
  { "vpmuludq", X86::VPMULUDQZrmb },
  { "vpmuludq", X86::VPMULUDQZrrk },
  { "vpmuludq", X86::VPMULUDQZrmk },
  { "vpmuludq", X86::VPMULUDQZrrkz },
  { "vpmuludq", X86::VPMULUDQZrmkz },
  { "vpmuludq", X86::VPMULUDQZrmbk },
  { "vpmuludq", X86::VPMULUDQZrmbkz },
  { "vpor", X86::VPORrr },
  { "vpor", X86::VPORrm },
  { "vpor", X86::VPORYrr },
  { "vpor", X86::VPORYrm },
  { "vpord", X86::VPORDZrr },
  { "vpord", X86::VPORDZrm },
  { "vpord", X86::VPORDZrmb },
  { "vpord", X86::VPORDZrrk },
  { "vpord", X86::VPORDZrmk },
  { "vpord", X86::VPORDZrrkz },
  { "vpord", X86::VPORDZrmkz },
  { "vpord", X86::VPORDZrmbk },
  { "vpord", X86::VPORDZrmbkz },
  { "vporq", X86::VPORQZrr },
  { "vporq", X86::VPORQZrm },
  { "vporq", X86::VPORQZrmb },
  { "vporq", X86::VPORQZrrk },
  { "vporq", X86::VPORQZrmk },
  { "vporq", X86::VPORQZrrkz },
  { "vporq", X86::VPORQZrmkz },
  { "vporq", X86::VPORQZrmbk },
  { "vporq", X86::VPORQZrmbkz },
  { "vpperm", X86::VPPERMrr },
  { "vpperm", X86::VPPERMrm },
  { "vpperm", X86::VPPERMmr },
  { "vprotb", X86::VPROTBrr },
  { "vprotb", X86::VPROTBri },
  { "vprotb", X86::VPROTBrm },
  { "vprotb", X86::VPROTBmr },
  { "vprotb", X86::VPROTBmi },
  { "vprotd", X86::VPROTDrr },
  { "vprotd", X86::VPROTDri },
  { "vprotd", X86::VPROTDrm },
  { "vprotd", X86::VPROTDmr },
  { "vprotd", X86::VPROTDmi },
  { "vprotq", X86::VPROTQrr },
  { "vprotq", X86::VPROTQri },
  { "vprotq", X86::VPROTQrm },
  { "vprotq", X86::VPROTQmr },
  { "vprotq", X86::VPROTQmi },
  { "vprotw", X86::VPROTWrr },
  { "vprotw", X86::VPROTWri },
  { "vprotw", X86::VPROTWrm },
  { "vprotw", X86::VPROTWmr },
  { "vprotw", X86::VPROTWmi },
  { "vpsadbw", X86::VPSADBWrr },
  { "vpsadbw", X86::VPSADBWrm },
  { "vpsadbw", X86::VPSADBWYrr },
  { "vpsadbw", X86::VPSADBWYrm },
  { "vpscatterdd", X86::VPSCATTERDDZmr },
  { "vpscatterdq", X86::VPSCATTERDQZmr },
  { "vpscatterqd", X86::VPSCATTERQDZmr },
  { "vpscatterqq", X86::VPSCATTERQQZmr },
  { "vpshab", X86::VPSHABrr },
  { "vpshab", X86::VPSHABrm },
  { "vpshab", X86::VPSHABmr },
  { "vpshad", X86::VPSHADrr },
  { "vpshad", X86::VPSHADrm },
  { "vpshad", X86::VPSHADmr },
  { "vpshaq", X86::VPSHAQrr },
  { "vpshaq", X86::VPSHAQrm },
  { "vpshaq", X86::VPSHAQmr },
  { "vpshaw", X86::VPSHAWrr },
  { "vpshaw", X86::VPSHAWrm },
  { "vpshaw", X86::VPSHAWmr },
  { "vpshlb", X86::VPSHLBrr },
  { "vpshlb", X86::VPSHLBrm },
  { "vpshlb", X86::VPSHLBmr },
  { "vpshld", X86::VPSHLDrr },
  { "vpshld", X86::VPSHLDrm },
  { "vpshld", X86::VPSHLDmr },
  { "vpshlq", X86::VPSHLQrr },
  { "vpshlq", X86::VPSHLQrm },
  { "vpshlq", X86::VPSHLQmr },
  { "vpshlw", X86::VPSHLWrr },
  { "vpshlw", X86::VPSHLWrm },
  { "vpshlw", X86::VPSHLWmr },
  { "vpshufb", X86::VPSHUFBrr },
  { "vpshufb", X86::VPSHUFBrm },
  { "vpshufb", X86::VPSHUFBYrr },
  { "vpshufb", X86::VPSHUFBYrm },
  { "vpshufd", X86::VPSHUFDri },
  { "vpshufd", X86::VPSHUFDmi },
  { "vpshufd", X86::VPSHUFDYri },
  { "vpshufd", X86::VPSHUFDYmi },
  { "vpshufd", X86::VPSHUFDZri },
  { "vpshufd", X86::VPSHUFDZmi },
  { "vpshufhw", X86::VPSHUFHWri },
  { "vpshufhw", X86::VPSHUFHWmi },
  { "vpshufhw", X86::VPSHUFHWYri },
  { "vpshufhw", X86::VPSHUFHWYmi },
  { "vpshuflw", X86::VPSHUFLWri },
  { "vpshuflw", X86::VPSHUFLWmi },
  { "vpshuflw", X86::VPSHUFLWYri },
  { "vpshuflw", X86::VPSHUFLWYmi },
  { "vpsignb", X86::VPSIGNBrr },
  { "vpsignb", X86::VPSIGNBrm },
  { "vpsignb", X86::VPSIGNBYrr },
  { "vpsignb", X86::VPSIGNBYrm },
  { "vpsignd", X86::VPSIGNDrr },
  { "vpsignd", X86::VPSIGNDrm },
  { "vpsignd", X86::VPSIGNDYrr },
  { "vpsignd", X86::VPSIGNDYrm },
  { "vpsignw", X86::VPSIGNWrr },
  { "vpsignw", X86::VPSIGNWrm },
  { "vpsignw", X86::VPSIGNWYrr },
  { "vpsignw", X86::VPSIGNWYrm },
  { "vpslld", X86::VPSLLDrr },
  { "vpslld", X86::VPSLLDri },
  { "vpslld", X86::VPSLLDrm },
  { "vpslld", X86::VPSLLDYrr },
  { "vpslld", X86::VPSLLDYri },
  { "vpslld", X86::VPSLLDYrm },
  { "vpslld", X86::VPSLLDZrr },
  { "vpslld", X86::VPSLLDZri },
  { "vpslld", X86::VPSLLDZrm },
  { "vpslld", X86::VPSLLDZmi },
  { "vpslld", X86::VPSLLDZrrk },
  { "vpslld", X86::VPSLLDZrik },
  { "vpslld", X86::VPSLLDZrmk },
  { "vpslld", X86::VPSLLDZmik },
  { "vpslldq", X86::VPSLLDQri },
  { "vpslldq", X86::VPSLLDQYri },
  { "vpsllq", X86::VPSLLQrr },
  { "vpsllq", X86::VPSLLQri },
  { "vpsllq", X86::VPSLLQrm },
  { "vpsllq", X86::VPSLLQYrr },
  { "vpsllq", X86::VPSLLQYri },
  { "vpsllq", X86::VPSLLQYrm },
  { "vpsllq", X86::VPSLLQZrr },
  { "vpsllq", X86::VPSLLQZri },
  { "vpsllq", X86::VPSLLQZrm },
  { "vpsllq", X86::VPSLLQZmi },
  { "vpsllq", X86::VPSLLQZrrk },
  { "vpsllq", X86::VPSLLQZrik },
  { "vpsllq", X86::VPSLLQZrmk },
  { "vpsllq", X86::VPSLLQZmik },
  { "vpsllvd", X86::VPSLLVDrr },
  { "vpsllvd", X86::VPSLLVDrm },
  { "vpsllvd", X86::VPSLLVDYrr },
  { "vpsllvd", X86::VPSLLVDYrm },
  { "vpsllvd", X86::VPSLLVDZrr },
  { "vpsllvd", X86::VPSLLVDZrm },
  { "vpsllvq", X86::VPSLLVQrr },
  { "vpsllvq", X86::VPSLLVQrm },
  { "vpsllvq", X86::VPSLLVQYrr },
  { "vpsllvq", X86::VPSLLVQYrm },
  { "vpsllvq", X86::VPSLLVQZrr },
  { "vpsllvq", X86::VPSLLVQZrm },
  { "vpsllw", X86::VPSLLWrr },
  { "vpsllw", X86::VPSLLWri },
  { "vpsllw", X86::VPSLLWrm },
  { "vpsllw", X86::VPSLLWYrr },
  { "vpsllw", X86::VPSLLWYri },
  { "vpsllw", X86::VPSLLWYrm },
  { "vpsrad", X86::VPSRADrr },
  { "vpsrad", X86::VPSRADri },
  { "vpsrad", X86::VPSRADrm },
  { "vpsrad", X86::VPSRADYrr },
  { "vpsrad", X86::VPSRADYri },
  { "vpsrad", X86::VPSRADYrm },
  { "vpsrad", X86::VPSRADZrr },
  { "vpsrad", X86::VPSRADZri },
  { "vpsrad", X86::VPSRADZrm },
  { "vpsrad", X86::VPSRADZmi },
  { "vpsrad", X86::VPSRADZrrk },
  { "vpsrad", X86::VPSRADZrik },
  { "vpsrad", X86::VPSRADZrmk },
  { "vpsrad", X86::VPSRADZmik },
  { "vpsraq", X86::VPSRAQZrr },
  { "vpsraq", X86::VPSRAQZri },
  { "vpsraq", X86::VPSRAQZrm },
  { "vpsraq", X86::VPSRAQZmi },
  { "vpsraq", X86::VPSRAQZrrk },
  { "vpsraq", X86::VPSRAQZrik },
  { "vpsraq", X86::VPSRAQZrmk },
  { "vpsraq", X86::VPSRAQZmik },
  { "vpsravd", X86::VPSRAVDrr },
  { "vpsravd", X86::VPSRAVDrm },
  { "vpsravd", X86::VPSRAVDYrr },
  { "vpsravd", X86::VPSRAVDYrm },
  { "vpsravd", X86::VPSRAVDZrr },
  { "vpsravd", X86::VPSRAVDZrm },
  { "vpsravq", X86::VPSRAVQZrr },
  { "vpsravq", X86::VPSRAVQZrm },
  { "vpsraw", X86::VPSRAWrr },
  { "vpsraw", X86::VPSRAWri },
  { "vpsraw", X86::VPSRAWrm },
  { "vpsraw", X86::VPSRAWYrr },
  { "vpsraw", X86::VPSRAWYri },
  { "vpsraw", X86::VPSRAWYrm },
  { "vpsrld", X86::VPSRLDrr },
  { "vpsrld", X86::VPSRLDri },
  { "vpsrld", X86::VPSRLDrm },
  { "vpsrld", X86::VPSRLDYrr },
  { "vpsrld", X86::VPSRLDYri },
  { "vpsrld", X86::VPSRLDYrm },
  { "vpsrld", X86::VPSRLDZrr },
  { "vpsrld", X86::VPSRLDZri },
  { "vpsrld", X86::VPSRLDZrm },
  { "vpsrld", X86::VPSRLDZmi },
  { "vpsrld", X86::VPSRLDZrrk },
  { "vpsrld", X86::VPSRLDZrik },
  { "vpsrld", X86::VPSRLDZrmk },
  { "vpsrld", X86::VPSRLDZmik },
  { "vpsrldq", X86::VPSRLDQri },
  { "vpsrldq", X86::VPSRLDQYri },
  { "vpsrlq", X86::VPSRLQrr },
  { "vpsrlq", X86::VPSRLQri },
  { "vpsrlq", X86::VPSRLQrm },
  { "vpsrlq", X86::VPSRLQYrr },
  { "vpsrlq", X86::VPSRLQYri },
  { "vpsrlq", X86::VPSRLQYrm },
  { "vpsrlq", X86::VPSRLQZrr },
  { "vpsrlq", X86::VPSRLQZri },
  { "vpsrlq", X86::VPSRLQZrm },
  { "vpsrlq", X86::VPSRLQZmi },
  { "vpsrlq", X86::VPSRLQZrrk },
  { "vpsrlq", X86::VPSRLQZrik },
  { "vpsrlq", X86::VPSRLQZrmk },
  { "vpsrlq", X86::VPSRLQZmik },
  { "vpsrlvd", X86::VPSRLVDrr },
  { "vpsrlvd", X86::VPSRLVDrm },
  { "vpsrlvd", X86::VPSRLVDYrr },
  { "vpsrlvd", X86::VPSRLVDYrm },
  { "vpsrlvd", X86::VPSRLVDZrr },
  { "vpsrlvd", X86::VPSRLVDZrm },
  { "vpsrlvq", X86::VPSRLVQrr },
  { "vpsrlvq", X86::VPSRLVQrm },
  { "vpsrlvq", X86::VPSRLVQYrr },
  { "vpsrlvq", X86::VPSRLVQYrm },
  { "vpsrlvq", X86::VPSRLVQZrr },
  { "vpsrlvq", X86::VPSRLVQZrm },
  { "vpsrlw", X86::VPSRLWrr },
  { "vpsrlw", X86::VPSRLWri },
  { "vpsrlw", X86::VPSRLWrm },
  { "vpsrlw", X86::VPSRLWYrr },
  { "vpsrlw", X86::VPSRLWYri },
  { "vpsrlw", X86::VPSRLWYrm },
  { "vpsubb", X86::VPSUBBrr },
  { "vpsubb", X86::VPSUBBrm },
  { "vpsubb", X86::VPSUBBYrr },
  { "vpsubb", X86::VPSUBBYrm },
  { "vpsubd", X86::VPSUBDrr },
  { "vpsubd", X86::VPSUBDrm },
  { "vpsubd", X86::VPSUBDYrr },
  { "vpsubd", X86::VPSUBDYrm },
  { "vpsubd", X86::VPSUBDZrr },
  { "vpsubd", X86::VPSUBDZrm },
  { "vpsubd", X86::VPSUBDZrmb },
  { "vpsubd", X86::VPSUBDZrrk },
  { "vpsubd", X86::VPSUBDZrmk },
  { "vpsubd", X86::VPSUBDZrrkz },
  { "vpsubd", X86::VPSUBDZrmkz },
  { "vpsubd", X86::VPSUBDZrmbk },
  { "vpsubd", X86::VPSUBDZrmbkz },
  { "vpsubq", X86::VPSUBQrr },
  { "vpsubq", X86::VPSUBQrm },
  { "vpsubq", X86::VPSUBQYrr },
  { "vpsubq", X86::VPSUBQYrm },
  { "vpsubq", X86::VPSUBQZrr },
  { "vpsubq", X86::VPSUBQZrm },
  { "vpsubq", X86::VPSUBQZrmb },
  { "vpsubq", X86::VPSUBQZrrk },
  { "vpsubq", X86::VPSUBQZrmk },
  { "vpsubq", X86::VPSUBQZrrkz },
  { "vpsubq", X86::VPSUBQZrmkz },
  { "vpsubq", X86::VPSUBQZrmbk },
  { "vpsubq", X86::VPSUBQZrmbkz },
  { "vpsubsb", X86::VPSUBSBrr },
  { "vpsubsb", X86::VPSUBSBrm },
  { "vpsubsb", X86::VPSUBSBYrr },
  { "vpsubsb", X86::VPSUBSBYrm },
  { "vpsubsw", X86::VPSUBSWrr },
  { "vpsubsw", X86::VPSUBSWrm },
  { "vpsubsw", X86::VPSUBSWYrr },
  { "vpsubsw", X86::VPSUBSWYrm },
  { "vpsubusb", X86::VPSUBUSBrr },
  { "vpsubusb", X86::VPSUBUSBrm },
  { "vpsubusb", X86::VPSUBUSBYrr },
  { "vpsubusb", X86::VPSUBUSBYrm },
  { "vpsubusw", X86::VPSUBUSWrr },
  { "vpsubusw", X86::VPSUBUSWrm },
  { "vpsubusw", X86::VPSUBUSWYrr },
  { "vpsubusw", X86::VPSUBUSWYrm },
  { "vpsubw", X86::VPSUBWrr },
  { "vpsubw", X86::VPSUBWrm },
  { "vpsubw", X86::VPSUBWYrr },
  { "vpsubw", X86::VPSUBWYrm },
  { "vptest", X86::VPTESTrr },
  { "vptest", X86::VPTESTrm },
  { "vptest", X86::VPTESTYrr },
  { "vptest", X86::VPTESTYrm },
  { "vptestmd", X86::VPTESTMDZrr },
  { "vptestmd", X86::VPTESTMDZrm },
  { "vptestmq", X86::VPTESTMQZrr },
  { "vptestmq", X86::VPTESTMQZrm },
  { "vptestnmd", X86::VPTESTNMDZrr },
  { "vptestnmd", X86::VPTESTNMDZrm },
  { "vptestnmq", X86::VPTESTNMQZrr },
  { "vptestnmq", X86::VPTESTNMQZrm },
  { "vpunpckhbw", X86::VPUNPCKHBWrr },
  { "vpunpckhbw", X86::VPUNPCKHBWrm },
  { "vpunpckhbw", X86::VPUNPCKHBWYrr },
  { "vpunpckhbw", X86::VPUNPCKHBWYrm },
  { "vpunpckhdq", X86::VPUNPCKHDQrr },
  { "vpunpckhdq", X86::VPUNPCKHDQrm },
  { "vpunpckhdq", X86::VPUNPCKHDQYrr },
  { "vpunpckhdq", X86::VPUNPCKHDQYrm },
  { "vpunpckhdq", X86::VPUNPCKHDQZrr },
  { "vpunpckhdq", X86::VPUNPCKHDQZrm },
  { "vpunpckhqdq", X86::VPUNPCKHQDQrr },
  { "vpunpckhqdq", X86::VPUNPCKHQDQrm },
  { "vpunpckhqdq", X86::VPUNPCKHQDQYrr },
  { "vpunpckhqdq", X86::VPUNPCKHQDQYrm },
  { "vpunpckhqdq", X86::VPUNPCKHQDQZrr },
  { "vpunpckhqdq", X86::VPUNPCKHQDQZrm },
  { "vpunpckhwd", X86::VPUNPCKHWDrr },
  { "vpunpckhwd", X86::VPUNPCKHWDrm },
  { "vpunpckhwd", X86::VPUNPCKHWDYrr },
  { "vpunpckhwd", X86::VPUNPCKHWDYrm },
  { "vpunpcklbw", X86::VPUNPCKLBWrr },
  { "vpunpcklbw", X86::VPUNPCKLBWrm },
  { "vpunpcklbw", X86::VPUNPCKLBWYrr },
  { "vpunpcklbw", X86::VPUNPCKLBWYrm },
  { "vpunpckldq", X86::VPUNPCKLDQrr },
  { "vpunpckldq", X86::VPUNPCKLDQrm },
  { "vpunpckldq", X86::VPUNPCKLDQYrr },
  { "vpunpckldq", X86::VPUNPCKLDQYrm },
  { "vpunpckldq", X86::VPUNPCKLDQZrr },
  { "vpunpckldq", X86::VPUNPCKLDQZrm },
  { "vpunpcklqdq", X86::VPUNPCKLQDQrr },
  { "vpunpcklqdq", X86::VPUNPCKLQDQrm },
  { "vpunpcklqdq", X86::VPUNPCKLQDQYrr },
  { "vpunpcklqdq", X86::VPUNPCKLQDQYrm },
  { "vpunpcklqdq", X86::VPUNPCKLQDQZrr },
  { "vpunpcklqdq", X86::VPUNPCKLQDQZrm },
  { "vpunpcklwd", X86::VPUNPCKLWDrr },
  { "vpunpcklwd", X86::VPUNPCKLWDrm },
  { "vpunpcklwd", X86::VPUNPCKLWDYrr },
  { "vpunpcklwd", X86::VPUNPCKLWDYrm },
  { "vpxor", X86::VPXORrr },
  { "vpxor", X86::VPXORrm },
  { "vpxor", X86::VPXORYrr },
  { "vpxor", X86::VPXORYrm },
  { "vpxord", X86::VPXORDZrr },
  { "vpxord", X86::VPXORDZrm },
  { "vpxord", X86::VPXORDZrmb },
  { "vpxord", X86::VPXORDZrrk },
  { "vpxord", X86::VPXORDZrmk },
  { "vpxord", X86::VPXORDZrrkz },
  { "vpxord", X86::VPXORDZrmkz },
  { "vpxord", X86::VPXORDZrmbk },
  { "vpxord", X86::VPXORDZrmbkz },
  { "vpxorq", X86::VPXORQZrr },
  { "vpxorq", X86::VPXORQZrm },
  { "vpxorq", X86::VPXORQZrmb },
  { "vpxorq", X86::VPXORQZrrk },
  { "vpxorq", X86::VPXORQZrmk },
  { "vpxorq", X86::VPXORQZrrkz },
  { "vpxorq", X86::VPXORQZrmkz },
  { "vpxorq", X86::VPXORQZrmbk },
  { "vpxorq", X86::VPXORQZrmbkz },
  { "vrcp14pd", X86::VRCP14PDZr },
  { "vrcp14pd", X86::VRCP14PDZm },
  { "vrcp14ps", X86::VRCP14PSZr },
  { "vrcp14ps", X86::VRCP14PSZm },
  { "vrcp14sd", X86::VRCP14SDrr },
  { "vrcp14sd", X86::VRCP14SDrm },
  { "vrcp14ss", X86::VRCP14SSrr },
  { "vrcp14ss", X86::VRCP14SSrm },
  { "vrcp28pd", X86::VRCP28PDZr },
  { "vrcp28pd", X86::VRCP28PDZm },
  { "vrcp28pd", X86::VRCP28PDZrb },
  { "vrcp28ps", X86::VRCP28PSZr },
  { "vrcp28ps", X86::VRCP28PSZm },
  { "vrcp28ps", X86::VRCP28PSZrb },
  { "vrcp28sd", X86::VRCP28SDrr },
  { "vrcp28sd", X86::VRCP28SDrm },
  { "vrcp28sd", X86::VRCP28SDrrb },
  { "vrcp28ss", X86::VRCP28SSrr },
  { "vrcp28ss", X86::VRCP28SSrm },
  { "vrcp28ss", X86::VRCP28SSrrb },
  { "vrcpps", X86::VRCPPSr },
  { "vrcpps", X86::VRCPPSm },
  { "vrcpps", X86::VRCPPSYr },
  { "vrcpps", X86::VRCPPSYm },
  { "vrcpss", X86::VRCPSSr },
  { "vrcpss", X86::VRCPSSm },
  { "vrndscalepd", X86::VRNDSCALEPDZr },
  { "vrndscalepd", X86::VRNDSCALEPDZm },
  { "vrndscaleps", X86::VRNDSCALEPSZr },
  { "vrndscaleps", X86::VRNDSCALEPSZm },
  { "vrndscalesd", X86::VRNDSCALESDr },
  { "vrndscalesd", X86::VRNDSCALESDm },
  { "vrndscaless", X86::VRNDSCALESSr },
  { "vrndscaless", X86::VRNDSCALESSm },
  { "vroundpd", X86::VROUNDPDr },
  { "vroundpd", X86::VROUNDPDm },
  { "vroundpd", X86::VROUNDYPDr },
  { "vroundpd", X86::VROUNDYPDm },
  { "vroundps", X86::VROUNDPSr },
  { "vroundps", X86::VROUNDPSm },
  { "vroundps", X86::VROUNDYPSr },
  { "vroundps", X86::VROUNDYPSm },
  { "vroundsd", X86::VROUNDSDr },
  { "vroundsd", X86::VROUNDSDm },
  { "vroundss", X86::VROUNDSSr },
  { "vroundss", X86::VROUNDSSm },
  { "vrsqrt14pd", X86::VRSQRT14PDZr },
  { "vrsqrt14pd", X86::VRSQRT14PDZm },
  { "vrsqrt14ps", X86::VRSQRT14PSZr },
  { "vrsqrt14ps", X86::VRSQRT14PSZm },
  { "vrsqrt14sd", X86::VRSQRT14SDrr },
  { "vrsqrt14sd", X86::VRSQRT14SDrm },
  { "vrsqrt14ss", X86::VRSQRT14SSrr },
  { "vrsqrt14ss", X86::VRSQRT14SSrm },
  { "vrsqrt28pd", X86::VRSQRT28PDZr },
  { "vrsqrt28pd", X86::VRSQRT28PDZm },
  { "vrsqrt28pd", X86::VRSQRT28PDZrb },
  { "vrsqrt28ps", X86::VRSQRT28PSZr },
  { "vrsqrt28ps", X86::VRSQRT28PSZm },
  { "vrsqrt28ps", X86::VRSQRT28PSZrb },
  { "vrsqrt28sd", X86::VRSQRT28SDrr },
  { "vrsqrt28sd", X86::VRSQRT28SDrm },
  { "vrsqrt28sd", X86::VRSQRT28SDrrb },
  { "vrsqrt28ss", X86::VRSQRT28SSrr },
  { "vrsqrt28ss", X86::VRSQRT28SSrm },
  { "vrsqrt28ss", X86::VRSQRT28SSrrb },
  { "vrsqrtps", X86::VRSQRTPSr },
  { "vrsqrtps", X86::VRSQRTPSm },
  { "vrsqrtps", X86::VRSQRTPSYr },
  { "vrsqrtps", X86::VRSQRTPSYm },
  { "vrsqrtss", X86::VRSQRTSSr },
  { "vrsqrtss", X86::VRSQRTSSm },
  { "vscatterdpd", X86::VSCATTERDPDZmr },
  { "vscatterdps", X86::VSCATTERDPSZmr },
  { "vscatterpf0dpd", X86::VSCATTERPF0DPDm },
  { "vscatterpf0dps", X86::VSCATTERPF0DPSm },
  { "vscatterpf0qpd", X86::VSCATTERPF0QPDm },
  { "vscatterpf0qps", X86::VSCATTERPF0QPSm },
  { "vscatterpf1dpd", X86::VSCATTERPF1DPDm },
  { "vscatterpf1dps", X86::VSCATTERPF1DPSm },
  { "vscatterpf1qpd", X86::VSCATTERPF1QPDm },
  { "vscatterpf1qps", X86::VSCATTERPF1QPSm },
  { "vscatterqpd", X86::VSCATTERQPDZmr },
  { "vscatterqps", X86::VSCATTERQPSZmr },
  { "vshufpd", X86::VSHUFPDrri },
  { "vshufpd", X86::VSHUFPDrmi },
  { "vshufpd", X86::VSHUFPDYrri },
  { "vshufpd", X86::VSHUFPDYrmi },
  { "vshufpd", X86::VSHUFPDZrri },
  { "vshufpd", X86::VSHUFPDZrmi },
  { "vshufps", X86::VSHUFPSrri },
  { "vshufps", X86::VSHUFPSrmi },
  { "vshufps", X86::VSHUFPSYrri },
  { "vshufps", X86::VSHUFPSYrmi },
  { "vshufps", X86::VSHUFPSZrri },
  { "vshufps", X86::VSHUFPSZrmi },
  { "vsqrtpd", X86::VSQRTPDr },
  { "vsqrtpd", X86::VSQRTPDm },
  { "vsqrtpd", X86::VSQRTPDYr },
  { "vsqrtpd", X86::VSQRTPDYm },
  { "vsqrtpd", X86::VSQRTPDZrr },
  { "vsqrtpd", X86::VSQRTPDZrm },
  { "vsqrtps", X86::VSQRTPSr },
  { "vsqrtps", X86::VSQRTPSm },
  { "vsqrtps", X86::VSQRTPSYr },
  { "vsqrtps", X86::VSQRTPSYm },
  { "vsqrtps", X86::VSQRTPSZrr },
  { "vsqrtps", X86::VSQRTPSZrm },
  { "vsqrtsd", X86::VSQRTSDr },
  { "vsqrtsd", X86::VSQRTSDm },
  { "vsqrtsd", X86::VSQRTSDZr },
  { "vsqrtsd", X86::VSQRTSDZm },
  { "vsqrtss", X86::VSQRTSSr },
  { "vsqrtss", X86::VSQRTSSm },
  { "vsqrtss", X86::VSQRTSSZr },
  { "vsqrtss", X86::VSQRTSSZm },
  { "vstmxcsr", X86::VSTMXCSR },
  { "vsubpd", X86::VSUBPDrr },
  { "vsubpd", X86::VSUBPDrm },
  { "vsubpd", X86::VSUBPDYrr },
  { "vsubpd", X86::VSUBPDYrm },
  { "vsubpd", X86::VSUBPDZrr },
  { "vsubpd", X86::VSUBPDZrm },
  { "vsubpd", X86::VSUBPDZrmb },
  { "vsubpd", X86::VSUBPDZrrk },
  { "vsubpd", X86::VSUBPDZrmk },
  { "vsubpd", X86::VSUBPDZrrkz },
  { "vsubpd", X86::VSUBPDZrmkz },
  { "vsubpd", X86::VSUBPDZrmbk },
  { "vsubpd", X86::VSUBPDZrmbkz },
  { "vsubps", X86::VSUBPSrr },
  { "vsubps", X86::VSUBPSrm },
  { "vsubps", X86::VSUBPSYrr },
  { "vsubps", X86::VSUBPSYrm },
  { "vsubps", X86::VSUBPSZrr },
  { "vsubps", X86::VSUBPSZrm },
  { "vsubps", X86::VSUBPSZrmb },
  { "vsubps", X86::VSUBPSZrrk },
  { "vsubps", X86::VSUBPSZrmk },
  { "vsubps", X86::VSUBPSZrrkz },
  { "vsubps", X86::VSUBPSZrmkz },
  { "vsubps", X86::VSUBPSZrmbk },
  { "vsubps", X86::VSUBPSZrmbkz },
  { "vsubsd", X86::VSUBSDrr },
  { "vsubsd", X86::VSUBSDrm },
  { "vsubsd", X86::VSUBSDZrr },
  { "vsubsd", X86::VSUBSDZrm },
  { "vsubss", X86::VSUBSSrr },
  { "vsubss", X86::VSUBSSrm },
  { "vsubss", X86::VSUBSSZrr },
  { "vsubss", X86::VSUBSSZrm },
  { "vtestpd", X86::VTESTPDrr },
  { "vtestpd", X86::VTESTPDrm },
  { "vtestpd", X86::VTESTPDYrr },
  { "vtestpd", X86::VTESTPDYrm },
  { "vtestps", X86::VTESTPSrr },
  { "vtestps", X86::VTESTPSrm },
  { "vtestps", X86::VTESTPSYrr },
  { "vtestps", X86::VTESTPSYrm },
  { "vucomisd", X86::VUCOMISDrr },
  { "vucomisd", X86::VUCOMISDrm },
  { "vucomisd", X86::VUCOMISDZrr },
  { "vucomisd", X86::VUCOMISDZrm },
  { "vucomiss", X86::VUCOMISSrr },
  { "vucomiss", X86::VUCOMISSrm },
  { "vucomiss", X86::VUCOMISSZrr },
  { "vucomiss", X86::VUCOMISSZrm },
  { "vunpckhpd", X86::VUNPCKHPDrr },
  { "vunpckhpd", X86::VUNPCKHPDrm },
  { "vunpckhpd", X86::VUNPCKHPDYrr },
  { "vunpckhpd", X86::VUNPCKHPDYrm },
  { "vunpckhpd", X86::VUNPCKHPDZrr },
  { "vunpckhpd", X86::VUNPCKHPDZrm },
  { "vunpckhps", X86::VUNPCKHPSrr },
  { "vunpckhps", X86::VUNPCKHPSrm },
  { "vunpckhps", X86::VUNPCKHPSYrr },
  { "vunpckhps", X86::VUNPCKHPSYrm },
  { "vunpckhps", X86::VUNPCKHPSZrr },
  { "vunpckhps", X86::VUNPCKHPSZrm },
  { "vunpcklpd", X86::VUNPCKLPDrr },
  { "vunpcklpd", X86::VUNPCKLPDrm },
  { "vunpcklpd", X86::VUNPCKLPDYrr },
  { "vunpcklpd", X86::VUNPCKLPDYrm },
  { "vunpcklpd", X86::VUNPCKLPDZrr },
  { "vunpcklpd", X86::VUNPCKLPDZrm },
  { "vunpcklps", X86::VUNPCKLPSrr },
  { "vunpcklps", X86::VUNPCKLPSrm },
  { "vunpcklps", X86::VUNPCKLPSYrr },
  { "vunpcklps", X86::VUNPCKLPSYrm },
  { "vunpcklps", X86::VUNPCKLPSZrr },
  { "vunpcklps", X86::VUNPCKLPSZrm },
  { "vxorpd", X86::VXORPDrr },
  { "vxorpd", X86::VXORPDrm },
  { "vxorpd", X86::VXORPDYrr },
  { "vxorpd", X86::VXORPDYrm },
  { "vxorps", X86::VXORPSrr },
  { "vxorps", X86::VXORPSrm },
  { "vxorps", X86::VXORPSYrr },
  { "vxorps", X86::VXORPSYrm },
  { "vzeroall", X86::VZEROALL },
  { "vzeroupper", X86::VZEROUPPER },
  { "wait", X86::WAIT },
  { "wbinvd", X86::WBINVD },
  { "wrfsbase", X86::WRFSBASE },
  { "wrfsbase", X86::WRFSBASE64 },
  { "wrgsbase", X86::WRGSBASE },
  { "wrgsbase", X86::WRGSBASE64 },
  { "wrmsr", X86::WRMSR },
  { "xabort", X86::XABORT },
  { "xacquire", X86::XACQUIRE_PREFIX },
  { "xadd", X86::XADD8rr },
  { "xadd", X86::XADD16rr },
  { "xadd", X86::XADD32rr },
  { "xadd", X86::XADD64rr },
  { "xadd", X86::XADD16rm },
  { "xadd", X86::XADD32rm },
  { "xadd", X86::XADD64rm },
  { "xadd", X86::XADD8rm },
  { "xbegin", X86::XBEGIN_4 },
  { "xchg", X86::XCHG8rr },
  { "xchg", X86::XCHG8rm },
  { "xchg", X86::XCHG16ar },
  { "xchg", X86::XCHG16ar },
  { "xchg", X86::XCHG16rr },
  { "xchg", X86::XCHG16rm },
  { "xchg", X86::XCHG32ar64 },
  { "xchg", X86::XCHG32ar },
  { "xchg", X86::XCHG32ar64 },
  { "xchg", X86::XCHG32ar },
  { "xchg", X86::XCHG32rr },
  { "xchg", X86::XCHG32rm },
  { "xchg", X86::XCHG64ar },
  { "xchg", X86::XCHG64ar },
  { "xchg", X86::XCHG64rr },
  { "xchg", X86::XCHG64rm },
  { "xchg", X86::XCHG16rm },
  { "xchg", X86::XCHG32rm },
  { "xchg", X86::XCHG64rm },
  { "xchg", X86::XCHG8rm },
  { "xcryptcbc", X86::XCRYPTCBC },
  { "xcryptcfb", X86::XCRYPTCFB },
  { "xcryptctr", X86::XCRYPTCTR },
  { "xcryptecb", X86::XCRYPTECB },
  { "xcryptofb", X86::XCRYPTOFB },
  { "xend", X86::XEND },
  { "xgetbv", X86::XGETBV },
  { "xlatb", X86::XLAT },
  { "xor", X86::XOR8i8 },
  { "xor", X86::XOR8rr },
  { "xor", X86::XOR8ri },
  { "xor", X86::XOR8rm },
  { "xor", X86::XOR16i16 },
  { "xor", X86::XOR16rr },
  { "xor", X86::XOR16ri8 },
  { "xor", X86::XOR16ri },
  { "xor", X86::XOR16rm },
  { "xor", X86::XOR32i32 },
  { "xor", X86::XOR32rr },
  { "xor", X86::XOR32ri8 },
  { "xor", X86::XOR32ri },
  { "xor", X86::XOR32rm },
  { "xor", X86::XOR64i32 },
  { "xor", X86::XOR64rr },
  { "xor", X86::XOR64ri8 },
  { "xor", X86::XOR64ri32 },
  { "xor", X86::XOR64rm },
  { "xor", X86::XOR16mr },
  { "xor", X86::XOR16mi8 },
  { "xor", X86::XOR16mi },
  { "xor", X86::XOR32mr },
  { "xor", X86::XOR32mi8 },
  { "xor", X86::XOR32mi },
  { "xor", X86::XOR64mr },
  { "xor", X86::XOR64mi8 },
  { "xor", X86::XOR64mi32 },
  { "xor", X86::XOR8mr },
  { "xor", X86::XOR8mi },
  { "xorpd", X86::XORPDrr },
  { "xorpd", X86::XORPDrm },
  { "xorps", X86::XORPSrr },
  { "xorps", X86::XORPSrm },
  { "xrelease", X86::XRELEASE_PREFIX },
  { "xrstor", X86::XRSTOR },
  { "xrstor64", X86::XRSTOR64 },
  { "xsave", X86::XSAVE },
  { "xsave64", X86::XSAVE64 },
  { "xsaveopt", X86::XSAVEOPT },
  { "xsaveopt64", X86::XSAVEOPT64 },
  { "xsetbv", X86::XSETBV },
  { "xsha1", X86::XSHA1 },
  { "xsha256", X86::XSHA256 },
  { "xstore", X86::XSTORE },
  { "xstorerng", X86::XSTORE },
  { "xtest", X86::XTEST },*/
  { nullptr, 0 }
};
